/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 15/2/2
 * Time: 上午10:57
 * To change this template use File | Settings | File Templates.
 */


var EquipManager = {

	//背包
	m_oPlayerPack : null,
	m_oBankPack : null,
	m_oTravelPack : null,
	m_oFloorPack : null,
	//当前背包
	m_oCurrentPack : null,

	//---------------------------------------------------------------------------------------------------------------------------
	//属性方法

	//玩家身上背包
	getPlayerPack : function()
	{
		return this.m_oPlayerPack;
	},
	//得到当前背包
	getCurrentPack : function()
	{
		return this.m_oCurrentPack;
	},
	//修改当前背包
	setPackType : function(nType)
	{
		switch (nType)
		{
			case PackType.TravelPack:
			{
				this.m_oCurrentPack = this.m_oTravelPack;
			}
				break;
			case PackType.BankPack:
			{
				this.m_oCurrentPack = this.m_oBankPack;
			}
				break;
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//初始化

	//初始化
	initEquipManager : function(bFromData)
	{
		this.m_oPlayerPack = new PlayerPack();
		this.m_oBankPack   = new EquipPack();
		this.m_oTravelPack = new EquipPack();

		//--------------------------------------------------

		//初始化数据
		this.initPlayerEquip(bFromData);
		this.initPackEquip(this.m_oBankPack, "BankPack");
		//读取特殊装备
		this.initPackEquip(this.m_oTravelPack, "TravelPack");

		//--------------------------------------------------

		//设置当前背包
		this.setPackType(PackType.BankPack);
	},
	//重置
	resetEquipManager : function(bPassFloor)
	{
		//重置玩家身上装备
		if(!bPassFloor)
		{
			//清空身上装备
			this.emptyPlayer();
			//初始玩家身上道具
			this.initPlayerEquip(false);
		}

		//--------------------------------------------------

		//重置旅行背包
		this.m_oTravelPack = new EquipPack();

		//--------------------------------------------------

		//设置当前背包
		this.setPackType(PackType.BankPack);
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//初始化数据

	//初始玩家身上道具
	initPlayerEquip : function(bFromData)
	{
		//获取装备数据
		var aEquips = null;
		if(bFromData){
			aEquips = StaticMethod.getDataArr(vee.data["PlayerPackTower"]);
		}else{
			aEquips = StaticMethod.getDataArr(vee.data["PlayerPack"]);
		}

		//---------------------------------------------------------------------

		//生成道具
		for(var i = 0; i < 9; i++)
		{
			//获取装备等级
			var oEquipCoe = null;
			if(bFromData){
				oEquipCoe = vee.data["PlayerPackTower"][i];
			}else{
				oEquipCoe = vee.data["PlayerPack"][i];
			}

			//---------------------------------------------------------------------

			//生成道具
			if(oEquipCoe)
			{
				var oEquip = new GameEquip1(oEquipCoe, aEquips[i]);
				this.m_oPlayerPack.setEquipById(i, oEquip);
			}
		}
	},
	//初始化道具包
	initPackEquip : function(oPack, strPack)
	{
		if(!vee.data[strPack]) return;

		var aEquip = StaticMethod.getDataArr(vee.data[strPack]);
		for(var i = 0; i < aEquip.length; i++)
		{
			var oEquipCoe = vee.data[strPack][i];
			if(strPack == "TravelPack")
			{
				if(aEquip[i].EquipType == EquipType.Special)
				{
					GameManager.getTowerData().m_nTowerSp |= (1 << (aEquip[i].EqupSpType - 1));
					var oEquip = new GameEquip1(oEquipCoe, aEquip[i]);
					oPack.setEquipById(i, oEquip);
				}
			}
			else if(strPack == "BankPack")
			{
				var oEquip = new GameEquip1(oEquipCoe, aEquip[i]);
				oPack.setEquipById(i, oEquip);
			}
		}
	},
	//清空道具
	emptyPlayer : function()
	{
		for(var i = 0; i < 9; i++){
			this.m_oPlayerPack.setEquipById(i, null);
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//具体创建

	//创建宝箱数组
	createFloorPack : function(aSteps, bFromData, nKeyNumber)
	{
		//重置每层道具数组
		this.m_oFloorPack = null;
		this.m_oFloorPack = new EquipPack();

		//------------------------------------------------------------

		//读取数据
		if(bFromData)
		{
			if(vee.data["FloorPack"])
			{
				var aEquips = StaticMethod.getDataArr(vee.data["FloorPack"]);
				for(var i = 0; i < aEquips.length; i++)
				{
					var oEquipCoe = vee.data["FloorPack"][i];
					var oEquip = new GameEquip1(oEquipCoe, aEquips[i]);
					//确定位置
					oEquip.m_nStep = oEquipCoe.m_nStep;
					this.m_oFloorPack.addEquip(oEquip);
				}
			}
			return;
		}

		//------------------------------------------------------------

		//生成钥匙
		for(var i = 0; i < nKeyNumber; i++)
		{
			var oEquipCoe = new EquipCoe(EquipData[502].Id, 1, 0);
			var oEquip = new GameEquip1(oEquipCoe, EquipData[502]);
			//确定位置
			oEquip.m_nStep = aSteps[i];
			this.m_oFloorPack.addEquip(oEquip);
		}

		//------------------------------------------------------------

		//得到当前层的道具
		var oTowerData = GameManager.getTowerData();
		var strFloor = "layer_" + oTowerData.m_nBigFloor + "_" + oTowerData.m_nSmallFloor;
		var aEquips = StaticMethod.getDataArr2(EquipMap[strFloor]);

		//------------------------------------------------------------

		//计算总权重
		var nTotal = 0;
		for(var i = 0; i < aEquips.length; i++){
			nTotal += aEquips[i].Weight;
		}

		//根据权重随机获得道具
		for(var i = nKeyNumber; i < aSteps.length; i++)
		{
			//索引
			var nIndex = 0;
			//计算权重
			var nLast = 0;
			//取随机数
			var nRandom = StaticMethod.getRandom(nTotal);

			//取权重
			for(var j = 0; j < aEquips.length; j++)
			{
				var nWeight = aEquips[j].Weight;
				if(nRandom >= nLast && nRandom < nWeight + nLast)
				{
					nIndex = j;
					break;
				}
				else{
					nLast += nWeight;
				}
			}

			//生成道具加入数组
			var oEquipCoe = new EquipCoe(aEquips[nIndex].Id, aEquips[nIndex].Lv, 0);
			var oEquip = new GameEquip1(oEquipCoe, aEquips[nIndex]);
			//确定位置
			oEquip.m_nStep = aSteps[i];
			this.m_oFloorPack.addEquip(oEquip);
		}
	},
	//创建特殊道具
	createSpecialEquip : function(nId)
	{
		var oData = EquipData[nId];
		if(!this.m_oTravelPack.checkByTypeSp(oData.EqupSpType, false))
		{
			var oCoe = new EquipCoe(nId, 1, 0);
			var oEquip = new GameEquip1(oCoe, oData);
			this.m_oTravelPack.addEquip(oEquip);
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//初始化属性

	//初始化装备属性
	updatePlayerEquipAttr : function(oPlayer)
	{
		for(var i = 0; i < 9; i++)
		{
			var oEquip = this.m_oPlayerPack.getEquipById(i);
			if(oEquip){
				this.setPlayerEquipAttr(oPlayer, oEquip, false);
			}
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//修改道具包

	//添加移除道具
	setPlayerEquipAttr : function(oPlayer, oEquip, bRemove)
	{
		//得到装备属性数组
		var aEquip1 = oPlayer.m_aEquip1;
		var aEquip2 = oPlayer.m_aEquip2;

		//--------------------------------------------------------

		//设置道具
		for(var j = 1; j < 3; j++)
		{
			//属性
			var oAtt = oEquip.getAttrById(j);

			//没有属性
			if(!oAtt){
				break;
			}

			//数值
			var nValue = oEquip.getAttrValueById(j);
			nValue = bRemove ? -nValue : nValue;

			//计算
			if(StaticMethod.isInteger(oAtt.m_nValue)){
				aEquip1[oAtt.m_nType] += nValue;
				cc.log("ssssssssssssssssss1 =" + nValue);
			}
			else{
				aEquip2[oAtt.m_nType] += nValue;
				cc.log("ssssssssssssssssss2 =" + nValue);
			}
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//检查

	//按照位置找到宝箱
	getEquipByStep : function(nStep, bRemove)
	{
		for(var i = 0; i < this.m_oFloorPack.getPackLength(); i++)
		{
			var oEquip = this.m_oFloorPack.getEquipById(i);
			if(oEquip.m_nStep == nStep)
			{
				if(bRemove){
					this.m_oFloorPack.setEquipById(i, null);
				}
				return oEquip;
			}
		}
	},
	//检测道具包是否已满
	checkTravelIsFull : function()
	{
		var nIndex = vee.VIPValues.getValue(VipKey.Capacity);
		return (this.m_oTravelPack.getPackLength() >= DilatationData[nIndex][1]);
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//修改道具包

	//交换道具
	exchangeEquip : function(oEquip1, oEquip2, nIndex)
	{
		//交换
		this.m_oPlayerPack.setEquipById(nIndex, oEquip1);
		if(oEquip2){
			this.m_oCurrentPack.exchangeEquip(oEquip1, oEquip2);
		}else{
			this.m_oCurrentPack.removeEquip(oEquip1);
		}

		//---------------------------------------------------

		//更新玩家属性
		var oPlayer = FightManager.getPlayer();
		if(oEquip2){
			this.setPlayerEquipAttr(oPlayer, oEquip2, true);
		}
		this.setPlayerEquipAttr(oPlayer, oEquip1, false);
	},
	//添加道具到旅行袋
	addTravelEquip : function(oEquip)
	{
		this.m_oTravelPack.addEquip(oEquip);
		//修改数量
		MyNotificationCenter.postNotification(GameEvent.UPDATAEQUIPNUMBER, this.m_oCurrentPack.getPackLength());
	},
	//升级道具
	upgradeEquip : function(oEquip, bSetPlayer)
	{
		var oPlayer = FightManager.getPlayer();
		if(bSetPlayer){
			this.setPlayerEquipAttr(oPlayer, oEquip, true);
		}
		oEquip.m_oCoe.m_nLv++;
		if(bSetPlayer){
			this.setPlayerEquipAttr(oPlayer, oEquip, false);
		}
	},
	//移除一般道具
	removePackEquip: function(oEquip)
	{
		//移除道具
		this.m_oCurrentPack.removeEquip(oEquip);
		//修改数量
		MyNotificationCenter.postNotification(GameEvent.UPDATAEQUIPNUMBER, this.m_oCurrentPack.getPackLength());
	},
	//移除特殊道具
	removePackEquipSp: function(oEquip)
	{
		//移除道具
		this.m_oCurrentPack.removeEquip(oEquip);
		//修改数量
		MyNotificationCenter.postNotification(GameEvent.UPDATAEQUIPNUMBER, this.m_oCurrentPack.getPackLength());
	},
	//按类型移除道具
	removePackEquipSpType: function(nType)
	{
		var bRemove = this.m_oCurrentPack.checkByTypeSp(nType, true);
		//修改数量
		MyNotificationCenter.postNotification(GameEvent.UPDATAEQUIPNUMBER, this.m_oCurrentPack.getPackLength());
		return bRemove;
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//重置属性
	restEquip : function()
	{
		for(var i = 0; i < 9; i++)
		{
			var oEquip = this.m_oPlayerPack.getEquipById(i);
			if(oEquip){
				oEquip.m_oCoe.m_nRare = 0;
			}
		}
		for(var i = 0; i < this.m_oTravelPack.getPackLength(); i++)
		{
			var oEquip = this.m_oTravelPack.getEquipById(i);
			if(oEquip){
				oEquip.m_oCoe.m_nRare = 0;
			}
		}
	},
	//设置龙装备
	setDragonEquip : function()
	{
		for(var i = 0; i < 3; i++)
		{
			var oEquip = this.m_oPlayerPack.getEquipById(i);
			if(oEquip){
				oEquip.m_oCoe.m_nRare = 1;
			}
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//存储
	//存储玩家身上装备
	savePlayerPack : function(strPack)
	{
		var arrPack = [];
		for(var i = 0; i < 9; i++)
		{
			var oEquip = this.m_oPlayerPack.getEquipById(i);
			if(oEquip)
			{
				var oEquipCoe = new EquipCoe(oEquip.m_oCoe.m_nId, oEquip.m_oCoe.m_nLv, oEquip.m_oCoe.m_nRare);
				arrPack.push(oEquipCoe);
			}
		}
		vee.data[strPack] = arrPack;
	},
	//存储背包装备
	saveEquipPack : function(oPack, strPack)
	{
		var arrPack = [];
		for(var i = 0; i < oPack.getPackLength(); i++)
		{
			var oEquip = oPack.getEquipById(i);
			if(oEquip)
			{
				var oEquipCoe = new EquipCoe(oEquip.m_oCoe.m_nId, oEquip.m_oCoe.m_nLv, oEquip.m_oCoe.m_nRare);
				arrPack.push(oEquipCoe);
			}
		}
		vee.data[strPack] = arrPack;
	},
	//存储仓库道具
	saveBankPack : function(bMerge)
	{
		//添加仓库装备
		if(bMerge)
		{
			for(var i = 0; i < this.m_oTravelPack.getPackLength(); i++)
			{
				var oEquip = this.m_oTravelPack.getEquipById(i);
				if(oEquip.m_oData.EquipType <= EquipType.Accessories){
					this.m_oBankPack.addEquip(oEquip);
				}
			}
		}
		//存储仓库装备
		this.saveEquipPack(this.m_oBankPack, "BankPack");
	},
	//存储过关道具
	savePassEquipData : function(bIsPass, bSaveTravel)
	{
		//玩家
		this.savePlayerPack("PlayerPack");
		//仓库
		this.saveBankPack(bIsPass);
		//存储特殊道具
		if(bSaveTravel){
			this.saveEquipPack(this.m_oTravelPack, "TravelPack");
		}
	},
	//存储塔中道具
	saveTowerEquipData : function()
	{
		//存储身上装备
		this.savePlayerPack("PlayerPackTower");
		//存储旅行背包
		this.saveEquipPack(this.m_oTravelPack, "TravelPack");
		//每层道具
		if(this.m_oFloorPack.getPackLength() > 0)
		{
			var arrPack = [];
			for(var i = 0; i < this.m_oFloorPack.getPackLength(); i++)
			{
				var oEquip = this.m_oFloorPack.getEquipById(i);
				if(oEquip)
				{
					var oEquipCoe = new EquipCoe(oEquip.m_oCoe.m_nId, oEquip.m_oCoe.m_nLv, oEquip.m_oCoe.m_nRare);
					oEquipCoe.m_nStep = oEquip.m_nStep;
					arrPack.push(oEquipCoe);
				}
			}
			vee.data["FloorPack"] = arrPack;
		}
	}
}