/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 15/1/31
 * Time: 下午3:42
 * To change this template use File | Settings | File Templates.
 */

var FightManager = {

	//战斗对象
	m_oPlayer : null,
	m_oEnemy : null,

	//怪物id
	m_nEnemyId : -1,

	//战斗参数
	m_bFightStart : false,
	m_nFightBout : 0,
	m_nPSpd : 0,
	m_nESpd : 0,

	//战斗数据
	m_oFightResult : null,
	m_oWinResult : null,
	m_oFightCache : null,

	//---------------------------------------------------------------------------------------------------------------------------
	//属性

	getPlayer : function()
	{
		return this.m_oPlayer;
	},
	getEnemy : function()
	{
		return this.m_oEnemy;
	},
	getFightResult : function()
	{
		return this.m_oFightResult;
	},
	getWinResult : function()
	{
		return this.m_oWinResult;
	},
	getFightCache : function()
	{
		return this.m_oFightCache;
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//初始化

	//初始化
	initFightManager : function(bFromData)
	{
		//玩家，敌人
		this.m_oPlayer = new EquipRole();
		this.m_oEnemy  = new GameRole();
		
		//战斗数据
		this.m_oFightResult = new FightResult();
		this.m_oWinResult   = new WinResult();
		this.m_oFightCache  = new FightCache();
		
		//赋值玩家数据
		this.initPlayerData(bFromData);
	},
	//重置
	resetFightManager : function()
	{
		//赋值玩家数据
		this.initPlayerData(false);
	},
	
	//------------------------------------------
	
	//玩家属性
	initPlayerData : function(bFromData)
	{
		//判断读取数据
		if(bFromData)
		{
			//读取人物属性
			var oSavePlayer = vee.data["SavePlayer"];
			this.m_oPlayer.m_nLv = oSavePlayer.m_nLv;
			this.m_oPlayer.m_nExp = oSavePlayer.m_nExp;
			for(var i = 0; i < 5; i++){
				this.m_oPlayer.setBaseByIndex(i, oSavePlayer.m_aBase[i]);
			}
			//怪物id
			this.m_nEnemyId = vee.data["EnemyId"];
		}
		else
		{
			//初始化人物属性
			this.m_oPlayer.m_nLv = 1;
			this.m_oPlayer.m_nExp = 0;
			for(var i = 0; i < 5; i++){
				this.m_oPlayer.setBaseByIndex(i, 0);
			}
		}
		
		//重置装备属性
		for(var i = 0; i < 5; i++)
		{
			this.m_oPlayer.setEquip1ByIndex(i, 0);
			this.m_oPlayer.setEquip2ByIndex(i, 0);
		}

		//计算玩家默认属性
		this.computerRoleFightWithDefault(this.m_oPlayer);
	},
	//重置道具数组
	resetPlayerEquip : function()
	{
		//重置装备属性
		for(var i = 0; i < 5; i++)
		{
			this.m_oPlayer.setEquip1ByIndex(i, 0);
			this.m_oPlayer.setEquip2ByIndex(i, 0);
		}
	},
	
	//------------------------------------------
	
	//初始化敌人
	setEnemy : function()
	{
		//获取id
		var nIndex = 0;
		//是否读取进度
		if(this.m_nEnemyId > 0)
		{
			nIndex = this.m_nEnemyId;
		}
		else
		{
			var oTowerData = GameManager.getTowerData();
			var strFloor = "layer_" + oTowerData.m_nBigFloor + "_" + oTowerData.m_nSmallFloor;
			var nLength =  MonsterMap[strFloor].length;
			//判断boss
			if(MapManager.locateBossStep())
			{
				nIndex = MonsterMap[strFloor][nLength - 1];
			}
			else
			{
				if(oTowerData.m_nSmallFloor == 3){
					nIndex = MonsterMap[strFloor][StaticMethod.getRandom(nLength-1)];
				}else{
					nIndex = MonsterMap[strFloor][StaticMethod.getRandom(nLength)];
				}
			}
		}

		//得到怪物数据
		var oEnemyData = MonsterData[nIndex];
		this.initEnemyData(oEnemyData);
	},
	//初始化敌人数据
	initEnemyData : function(oEnemyData)
	{
		//记录怪物id
		this.m_nEnemyId = oEnemyData.Id;

		//初始化怪物属性
		this.m_oEnemy.m_nLv = oEnemyData.Lv;
		this.m_oEnemy.m_nExp = oEnemyData.Exp;
		this.m_oEnemy.m_nCoin = oEnemyData.Coin;
		this.m_oEnemy.m_strName = oEnemyData.Name;
		this.m_oEnemy.m_strIcon = oEnemyData.Icon;
		//属性
		this.m_oEnemy.setFightByIndex(0, oEnemyData.HP);
		this.m_oEnemy.setFightByIndex(1, oEnemyData.Attack);
		this.m_oEnemy.setFightByIndex(2, oEnemyData.Defense);
		this.m_oEnemy.setFightByIndex(3, oEnemyData.Speed);
		//标记boss
		this.m_oEnemy.m_bIsBoss = oEnemyData.Boss ? true : false ;
		//回复满血
		this.m_oEnemy.revertHP();

		//玩家回血
		this.m_oPlayer.revertHP();
	},

	//------------------------------------------------------------------------------------------------------------

	//战斗逻辑
	gameFight : function()
	{
		//初始化
		if(!this.m_bFightStart)
		{
			//标记开始
			this.m_bFightStart = true;
			//回合数
			this.m_nFightBout = -1;

			//初始化速度
			this.m_nPSpd = this.m_oPlayer.getRealByIndex(AttributeType.Speed) + 30;
			this.m_nESpd = this.m_oEnemy.getRealByIndex(AttributeType.Speed) + 30;

			//初始化每回合结果
			this.m_oFightResult.reset();
			this.m_oFightResult.m_bIsBoss = this.m_oEnemy.m_bIsBoss;
			this.m_oFightResult.m_strEnemyName = this.m_oEnemy.m_strName;
			
			//初始化胜利结果
			this.m_oWinResult.reset();
			
			//缓存
			var oTowerData = GameManager.getTowerData();
			this.m_oFightCache.m_nCacheMoney = oTowerData.m_nTowerMoney;
			this.m_oFightCache.m_nCacheStep = oTowerData.m_nTowerStep;
			this.m_oFightCache.m_nPotion = oTowerData.m_nPotion;
			this.m_oFightCache.m_nCacheLv = this.m_oPlayer.m_nLv;
			this.m_oFightCache.m_nCacheExp = this.m_oPlayer.m_nExp;
		}

		//先制攻击
		if(this.m_nFightBout == -1)
		{
			//记录回合
			this.m_nFightBout++;
			//先制攻击
			if(GameFormula.firstAttack(this.m_oPlayer, this.m_oEnemy) && !this.m_oEnemy.m_bIsBoss)
			{
				//计算攻击
				this.computerAttack(false, true);
				return;
			}
		}

		//战斗逻辑
		if(this.m_nPSpd >= this.m_nESpd)
		{
			//计算速度
			this.m_nPSpd -= this.m_nESpd;
			this.m_nESpd = 30;
			//计算伤害
			this.computerAttack(true, false);
			//更新速度
			this.m_nESpd += Math.floor(this.m_oEnemy.getRealByIndex(AttributeType.Speed) * 1.3);
		}
		else
		{
			//计算速度
			this.m_nESpd -= this.m_nPSpd;
			this.m_nPSpd = 30;
			//计算伤害
			this.computerAttack(false, false);
			//更新速度
			this.m_nPSpd += Math.floor(this.m_oPlayer.getRealByIndex(AttributeType.Speed) * 1.3);
		}

		//记录回合
		this.m_nFightBout++;
	},
	//计算攻击
	computerAttack : function(bPlayer, bFirstAttack)
	{
		if(bPlayer)
		{
			//计算Combo
			this.m_oFightResult.m_nCombo = GameFormula.getCombo(this.m_oPlayer);
			var nAttack = this.m_oPlayer.getRealByIndex(AttributeType.Attack);
			if(this.m_oFightResult.m_nCombo > 1){
				nAttack = GameFormula.getComboAttack(this.m_oPlayer, this.m_oFightResult.m_nCombo);
			}
			//计算伤害
			var nDamageValue = GameFormula.roleAttack(nAttack, this.m_oEnemy.getRealByIndex(AttributeType.Defense));
			this.m_oEnemy.m_nHP -= nDamageValue;

			//显示HP
			this.m_oFightResult.m_nRoleHp = this.m_oEnemy.m_nHP ;

			//修改攻击结果
			this.m_oFightResult.m_nFightRole = 1;
			this.m_oFightResult.m_nFightHp = nDamageValue;
			this.m_oFightResult.m_nHpPercent = this.m_oEnemy.getHpPercent();
			//
			cc.log("Player attacks! Enemy HP " + nDamageValue);
			cc.log("Enemy HP:" + this.m_oEnemy.m_nHP);

			//判断死亡
			if(this.m_oEnemy.isDead())
			{
				//标记战斗结束
				this.m_bFightStart = false;
				this.m_oFightResult.m_nFightOver = 1;
				//
				cc.log("Enemy is dead !");
			}
		}
		else
		{
			//计算Combo
			this.m_oFightResult.m_nCombo = 1;

			//计算伤害
			var nDamageValue = GameFormula.roleAttack(this.m_oEnemy.getRealByIndex(AttributeType.Attack), this.m_oPlayer.getRealByIndex(AttributeType.Defense));
			this.m_oPlayer.m_nHP -= nDamageValue;

			//
			this.m_oFightResult.m_nRoleHp = this.m_oPlayer.m_nHP;

			//修改攻击结果
			this.m_oFightResult.m_nFightRole = 2;
			this.m_oFightResult.m_nFightHp = nDamageValue;
			this.m_oFightResult.m_nHpPercent = this.m_oPlayer.getHpPercent();
			this.m_oFightResult.m_nFightPercent = this.m_oPlayer.getFightPercent(nDamageValue);
			//
			cc.log("Enemy attacks! Player HP " + nDamageValue);
			cc.log("Player HP:" + this.m_oPlayer.m_nHP);

			//判断死亡
			if(this.m_oPlayer.isDead())
			{
				//标记战斗结束
				this.m_bFightStart = false;
				this.m_oFightResult.m_nFightOver = -1;
				//
				cc.log("Player is dead !");
			}
		}

		//先制
		this.m_oFightResult.m_bFirstAttack = bFirstAttack;
	},

	//计算步数
	computerStep : function()
	{
		if(this.m_oFightResult.m_nFightOver == -1)
		{
			var oTowerData = GameManager.getTowerData();
			this.m_oFightResult.m_nChangeStep = this.m_oEnemy.m_bIsBoss ? -oTowerData.m_nTowerStep : -2;
		}
		else
		{
			if(this.m_nFightBout == 1)
			{
				this.m_oFightResult.m_nChangeStep = 3;
			}
			else if(this.m_nFightBout <= 3 && this.m_nFightBout > 1)
			{
				this.m_oFightResult.m_nChangeStep = 2;
			}
			else
			{
				this.m_oFightResult.m_nChangeStep = 1;
			}
		}
	},
	
	//结算经验
	computerExpAndMoney : function()
	{
		//金钱
		this.m_oWinResult.m_nCoin = GameFormula.getFightCoin(this.m_oEnemy);
		//经验
		this.m_oWinResult.m_nExp = GameFormula.getFightExp(this.m_oEnemy);
		//属性点
		this.m_oWinResult.m_nBoost = 0;
		//当前等级
		this.m_oWinResult.m_nLvPre = this.m_oPlayer.m_nLv;
		//当前等级百分比
		this.m_oWinResult.m_nExpPercent = GameFormula.getNextLvExpPercent(this.m_oPlayer.m_nExp, this.m_oPlayer.m_nLv);
	},
	
	//战斗结算完成
	fightClearingOver : function(bRemove)
	{
		//移除血瓶
		if(bRemove){
			EquipManager.removePackEquipSpType(EqupSp.Potion);
		}
		//重置缓存
		this.m_oFightCache.reset();
		//重置怪物id
		this.m_nEnemyId = -1;
	},

	//计算升级
	computerMaxLvUp : function()
	{
		//计算等级
		this.m_oWinResult.m_nLvCur = GameFormula.getLvByExp(this.m_oWinResult.m_nLvPre, this.m_oWinResult.m_nExp + this.m_oPlayer.m_nExp);
		//剩余经验
		this.m_oPlayer.m_nExp = GameFormula.getResidueExp(this.m_oWinResult.m_nLvCur, this.m_oWinResult.m_nLvPre, this.m_oWinResult.m_nExp + this.m_oPlayer.m_nExp);
		//升得等级
		var nLv = this.m_oWinResult.m_nLvCur - this.m_oWinResult.m_nLvPre;
		//属性加5
		this.m_oWinResult.m_nBoost = nLv * 5;
		//增量
		this.m_oWinResult.m_nLvPlus = Math.floor((nLv - 1) / 30) + 1;
		//当前等级百分比
		this.m_oWinResult.m_nExpPercent = GameFormula.getNextLvExpPercent(this.m_oPlayer.m_nExp, this.m_oWinResult.m_nLvCur);
	},

	//---------------------------------------------------------------------------------------------------------------------------

	//计算有默认值的属性
	computerRoleFightWithDefault : function(oGameRole)
	{
		for(var i = 0; i < 5; i++){
			var nValue = PlayerDefaultBase[i] + GameFormula.computerFightByBase(i, oGameRole.getBaseByIndex(i));
			oGameRole.setFightByIndex(i, nValue);
		}
	},
	computerRoleFight : function(oGameRole)
	{
		for(var i = 0; i < 5; i++){
			var nValue = GameFormula.computerFightByBase(i, oGameRole.getBaseByIndex(i));
			oGameRole.setFightByIndex(i, nValue);
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------

	//存储人物属性
	saveFightData : function()
	{
		//存储对象
		var oSavePlayer = {};
		
		//等级经验--缓存
		if(this.m_oFightCache.m_nCacheLv > 0)
		{
			oSavePlayer.m_nLv = this.m_oFightCache.m_nCacheLv;
			oSavePlayer.m_nExp = this.m_oFightCache.m_nCacheExp;
		}
		else
		{
			oSavePlayer.m_nLv = this.m_oPlayer.m_nLv;
			oSavePlayer.m_nExp = this.m_oPlayer.m_nExp;
		}
		
		//基础属性
		oSavePlayer.m_aBase = new Array(5);
		for(var i = 0; i < 5; i++){
			oSavePlayer.m_aBase[i] = this.m_oPlayer.getBaseByIndex(i);
		}
		
		//玩家
		vee.data["SavePlayer"] = oSavePlayer;
		//记录敌人
		vee.data["EnemyId"] = this.m_nEnemyId;
	}
}