/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 15/1/30
 * Time: 下午5:04
 * To change this template use File | Settings | File Templates.
 */

var GameManager = {

	//重要数据
	m_oVipData : null,
	//塔中数据
	m_oTowerData : null,
	//是否在塔中
	m_bInTower : false,

	//-------------------------------------------------------------------------------------------------------------------------------------------
	//初始化1
	//初始化默认数据
	initDefaultData : function()
	{
		//第一次进入游戏
		//vee.data["IsFirstPlay"] = true;
		vee.isFirstPlay = false;
		//在塔中标记
		vee.data["IsInTower"] = false;
		
		//游戏数据-----------------------------------------------------------------
		
		//重要数据
		this.m_oVipData = new GameVipData(0, 1, -1, 4);
		//初始化默认数据
		vee.VIPValues.load(
			{
				"Jewel"          : 15,
				"Compass"        : 0,
                "Capacity"       : 0,
				"JewelProb"      : 0,
				"PlayerMoney"    : this.m_oVipData.m_nMoney,
				"OpenFloor"      : this.m_oVipData.m_nOpenFloor,
				"UnLockFloor"    : this.m_oVipData.m_nUnLockFloor,
				"PackLockIndex"  : this.m_oVipData.m_nPackLockIndex
			}
		);
		vee.VIPValues.save();

		//统计
		vee.Analytics.logReward(15, "FirstGame");
		
		//游戏装备-----------------------------------------------------------------
		
		//默认装备
		vee.data["PlayerPack"] = [];
		for(var i = 0; i < 4; i++){
			vee.data["PlayerPack"][i] = new EquipCoe(EquipMap.defaultEquip[i], 1, 0);
		}
		vee.saveData();
	},
	
	//-------------------------------------------------------------------------------------------------------------------------------------------
	//初始化2
	//初始化游戏数据
	initGame : function()
	{
		//游戏数据
		this.initGameVipData();
		//塔中数据
		this.initTowerData();
		
		//初始化游戏模块-----------------------------------------------------------------------------
		
		//地图初始化
		MapManager.initMapManager();
		//战斗初始化
		FightManager.initFightManager(this.m_bInTower);
		//道具初始化
		EquipManager.initEquipManager(this.m_bInTower);
		//初始化玩家属性
		var oPlayer = FightManager.getPlayer();
		EquipManager.updatePlayerEquipAttr(oPlayer);
	},
	//初始化vip数据
	initGameVipData : function()
	{
		//初始化
		if(!this.m_oVipData){
			this.m_oVipData = new GameVipData(0, 1, -1, 4);
		}
		//加载数据
		vee.VIPValues.load();
		this.m_oVipData.m_nMoney         = vee.VIPValues.getValue("PlayerMoney");
		this.m_oVipData.m_nOpenFloor     = vee.VIPValues.getValue("OpenFloor");
		this.m_oVipData.m_nUnLockFloor   = vee.VIPValues.getValue("UnLockFloor");
		this.m_oVipData.m_nPackLockIndex = vee.VIPValues.getValue("PackLockIndex");
	},
	//初始化塔中数据
	initTowerData : function()
	{
		//在塔中
		this.m_bInTower = vee.data["IsInTower"];
		//塔中数据
		this.m_oTowerData = new TowerData(0, 1, 1, 0, 40, 0);
		//读取化塔中数据
		if(this.m_bInTower)
		{
			var oTowerData = vee.data["TowerData"];
			this.m_oTowerData.m_nGameWin    = oTowerData.m_nGameWin;
			this.m_oTowerData.m_nBigFloor   = oTowerData.m_nBigFloor;
			this.m_oTowerData.m_nSmallFloor = oTowerData.m_nSmallFloor;
			this.m_oTowerData.m_nTowerMoney = oTowerData.m_nTowerMoney;
			this.m_oTowerData.m_nTowerStep  = oTowerData.m_nTowerStep;
			this.m_oTowerData.m_nTowerSp    = oTowerData.m_nTowerSp;
		}
	},
	
	//-------------------------------------------------------------------------------------------------------------------------------------------
	//重置游戏
	//重新开始游戏
	resetGame : function()
	{
		//重置数据
		EquipManager.restEquip();

		//存储逻辑
		switch (this.m_oTowerData.m_nGameWin)
		{
			//祈福药水
			case -1:
			{
				if(this.checkSpecialEquip(EqupSp.Wish)){
					EquipManager.savePlayerPack("PlayerPack");
				}
			}
				break;
			//回城卷轴
			case 0:
			{
				if(this.checkSpecialEquip(EqupSp.TP)){
					this.savePassGameData(false);
				}
			}
				break;
			//过关保存
			case 1:
			{
				this.savePassGameData(true);
			}
				break;
		}
		//--------------------------------------------

		//重置塔数据
		var bPass = this.m_oTowerData.m_nGameWin == 1;
		this.m_bInTower = false;
		this.m_oTowerData.reset();
		
		//--------------------------------------------
		
		//重置模块数据
		FightManager.resetFightManager();
		EquipManager.resetEquipManager(bPass);
		var oPlayer = FightManager.getPlayer();
		EquipManager.updatePlayerEquipAttr(oPlayer);
	},
	
	//-------------------------------------------------------------------------------------------------------------------------------------------
	//游戏逻辑

	//进入游戏界面
	initTower : function()
	{
		//切换旅行背包
		EquipManager.setPackType(PackType.TravelPack);

		//在塔中
		if(this.m_bInTower)
		{
			//地图初始化
			MapManager.createMapByData();
		}
		else
		{
			//存储道具数据
			EquipManager.savePassEquipData(false, false);
			vee.saveData();
			//存储重要数值
			this.saveVIPValues("All", 0);

			//设置龙道具
			if(this.checkSpecialEquip(EqupSp.Dragon))
			{
				FightManager.resetPlayerEquip();
				//
				EquipManager.setDragonEquip();
				//
				var oPlayer = FightManager.getPlayer();
				EquipManager.updatePlayerEquipAttr(oPlayer);
			}

			//地图初始化
			MapManager.createMap();

			//标记为塔中状态
			this.m_bInTower = true;
		}

		//统计
		vee.Analytics.logEvent(StatEventId.IntoTower, {
			"Floor" : ''+ this.m_oTowerData.m_nBigFloor
		});
	},	
	//升层
	passFloor : function()
	{
		this.m_oTowerData.m_nSmallFloor++;
		if(this.m_oTowerData.m_nSmallFloor > 3)
		{
			this.m_oTowerData.m_nSmallFloor = 1;
			this.m_oTowerData.m_nBigFloor++;
		}
	},

	//-------------------------------------------------------------------------------------------------------------------------------------------
	//设置

	//重要数据
	getVIPData : function()
	{
		return this.m_oVipData;
	},
	//塔中数据
	getTowerData : function()
	{
		return this.m_oTowerData;
	},
	//得到当前楼层
	getCurrentFloor : function()
	{
		return (this.m_oTowerData.m_nBigFloor - 1) * 3 + this.m_oTowerData.m_nSmallFloor;
	},

	//-------------------------------------------------------------------------------------------------------------------------------------------
	//初始化塔内数据

	//解装备栏
	unLockEquip : function()
	{
		this.m_oVipData.m_nMoney -= GameFormula.equipBoxPrice(this.m_oVipData.m_nPackLockIndex+1);
		this.m_oVipData.m_nPackLockIndex++;
	},
	//解锁楼层
	unLockFloor : function()
	{
		this.m_oVipData.m_nMoney -= GameFormula.floorPrice(this.m_oVipData.m_nUnLockFloor);
		if(this.m_oVipData.m_nUnLockFloor == 8){
			this.m_oVipData.m_nOpenFloor = 10;
		}else{
			this.m_oVipData.m_nOpenFloor = this.m_oVipData.m_nUnLockFloor;
		}
		this.m_oVipData.m_nUnLockFloor = -1;
	},

	//升级道具
	upgradeEquip : function(oEquip, bSetPlayer)
	{
		this.m_oVipData.m_nMoney -= GameFormula.upgradePrice(oEquip);
		EquipManager.upgradeEquip(oEquip, bSetPlayer);
	},
	//买道具
	sellEquip : function(oEquip)
	{
		this.m_oVipData.m_nMoney += GameFormula.sellPrice(oEquip);
		EquipManager.removePackEquip(oEquip);
	},

	//买血瓶
	buyPotion : function(nPotion)
	{
		if(nPotion > 0)
		{
			//修改血瓶数量
			this.m_oTowerData.m_nPotion = nPotion;
			//修改金钱
			this.m_oVipData.m_nMoney -= GameFormula.potionPrice(nPotion);

			return true;
		}
		return false;
	},
	//移除血瓶
	removePotion : function(bRemovePack)
	{
		//移除背包血瓶
		if(bRemovePack){
			EquipManager.removePackEquipByType(EquipType.Potion);
		}
		//返回数量
		return --this.m_oTowerData.m_nPotion;
	},
	//移除特殊道具
	removeSpecialEquip : function(nType, bRemovePack) 
	{
		//移除特殊道具
		if(bRemovePack){
			EquipManager.removePackEquipSpType(nType);
		}
		//修改Tower数据
		var nValue = ~(1 << (nType - 1));
		this.m_oTowerData.m_nTowerSp &= nValue;
	},
	//购买特殊道具
	buySpecialEquip : function(oShopData, nPrice, bAddPack)
	{
		//计算钻石
		vee.VIPValues.setValue(VipKey.Jewel, vee.VIPValues.getValue(VipKey.Jewel)-nPrice);
		
		//道具作用
		switch (oShopData.FunctionType)
		{
			case ShopFunctionType.EquipSp:
			{
				this.m_oTowerData.m_nTowerSp |= (1 << (oShopData.EquipSpType - 1));
				if(bAddPack){
					EquipManager.createSpecialEquip(500 + oShopData.EquipSpType);
				}

				//统计
				switch (oShopData.EquipSpType)
				{
					case EqupSp.Potion:
					{
						vee.Analytics.logItemPurchase("Potion", nPrice, 1);
					}
						break;
					case EqupSp.TP:
					{
						vee.Analytics.logItemPurchase("TP", nPrice, 1);
					}
						break;
					case EqupSp.Agility:
					{
						vee.Analytics.logItemPurchase("Agility", nPrice, 1);
					}
						break;
					case EqupSp.Wish:
					{
						vee.Analytics.logItemPurchase("Wish", nPrice, 1);
					}
						break;
					case EqupSp.Dragon:
					{
						vee.Analytics.logItemPurchase("Dragon", nPrice, 1);
					}
						break;
				}
			}
				break;
			case ShopFunctionType.Dilatation:
			{
				vee.VIPValues.add2Value(VipKey.Capacity, 1);
			}
				break;
			case ShopFunctionType.Compass:
			{
				vee.VIPValues.setValue(VipKey.Compass, 1);

				//统计
				vee.Analytics.logItemPurchase("Compass", nPrice, 1);
			}
				break;
			case ShopFunctionType.Convert:
			{
				vee.VIPValues.setValue(VipKey.Compass, vee.VIPValues.getValue() - 10);
				this.m_oVipData.m_nMoney += 150000;

				//统计
				vee.Analytics.logItemPurchase("Coin", nPrice, 1);
			}
				break;
		}
	},

	//-------------------------------------------------------------------------------------------------------------------------------------------
	//检测vip数据

	//boss层
	isBossFloor : function()
	{
		return this.m_oTowerData.m_nSmallFloor == 3;
	},
	//最高层
	isMaxFloor : function(bMove)
	{
		if(bMove && this.m_oTowerData.m_nBigFloor == 8){
			return false;
		}
		return this.m_oTowerData.m_nBigFloor < this.m_oVipData.m_nOpenFloor;
	},
	//装备栏枷锁
	boxLocked : function(nIndex)
	{
		return nIndex > this.m_oVipData.m_nPackLockIndex;
	},
	//是否够钱
	moneyEnough : function(nMoney, nType)
	{
		switch (nType)
		{
			case ShopPayType.Jewel :
			{
				return vee.VIPValues.getValue(VipKey.Jewel) >= nMoney;
			}
				break;
			case ShopPayType.Coin :
			{
				return this.m_oVipData.m_nMoney >= nMoney;
			}
				break;
		}
		return false;
	},
	//最多血瓶
	isMaxPotion : function(nPotion)
	{
		return nPotion < 5;
	},
	//检测特殊道具
	checkSpecialEquip : function(nType) 
	{
		return (this.m_oTowerData.m_nTowerSp & (1 << (nType-1))) == (1 << (nType-1));
	},

	//-------------------------------------------------------------------------------------------------------------------------------------------
	//存储

	//存储过关数据
	savePassGameData : function(bPass)
	{
		//存储道具数据
		EquipManager.savePassEquipData(true, false);
		vee.saveData();
		
		//-------------------------------------------------
		
		//游戏金钱
		this.m_oVipData.m_nMoney += this.m_oTowerData.m_nTowerMoney;
		//解锁关卡
		if(bPass
			&& (this.m_oTowerData.m_nBigFloor == this.m_oVipData.m_nOpenFloor)
			&& (this.m_oVipData.m_nOpenFloor < 8))
		{
			this.m_oVipData.m_nUnLockFloor = this.m_oVipData.m_nOpenFloor + 1;
		}
		//存储重要数值
		this.saveVIPValues("All", 0);
	},
	//存储重要数值
	saveVIPValues : function(strName, nValue)
	{
		if(strName == "All")
		{
			vee.VIPValues.setValue("PlayerMoney", this.m_oVipData.m_nMoney);
			vee.VIPValues.setValue("OpenFloor", this.m_oVipData.m_nOpenFloor);
			vee.VIPValues.setValue("UnLockFloor", this.m_oVipData.m_nUnLockFloor);
			vee.VIPValues.setValue("PackLockIndex", this.m_oVipData.m_nPackLockIndex);
		}
		else
		{
			vee.VIPValues.setValue(strName, nValue);
		}
		vee.VIPValues.save();
	},
	//最小化存储
	saveGameData : function()
	{
		//判断是否在塔中
		if(this.m_bInTower)
		{
			//在塔中
			vee.data["IsInTower"] = true;
			//----------------------------------------

			//塔中数据
			var oTowerData = {};
			oTowerData.m_nGameWin = this.m_oTowerData.m_nGameWin;
			oTowerData.m_nBigFloor = this.m_oTowerData.m_nBigFloor;
			oTowerData.m_nSmallFloor = this.m_oTowerData.m_nSmallFloor;

			//----------------------------------------

			//缓存数据
			var oFightCache = FightManager.getFightCache();
			if(oFightCache.m_nCacheMoney > 0 )
			{
				oTowerData.m_nTowerMoney = oFightCache.m_nCacheMoney;
				oTowerData.m_nTowerStep = oFightCache.m_nCacheStep;
			}
			else
			{
				oTowerData.m_nTowerMoney = this.m_oTowerData.m_nTowerMoney;
				oTowerData.m_nTowerStep = this.m_oTowerData.m_nTowerStep;
			}
			//塔中数据
			vee.data["TowerData"] = oTowerData;
			
			//----------------------------------------

			//其他数据
			MapManager.saveMap();
			FightManager.saveFightData();
			EquipManager.saveTowerEquipData();
		}
		else
		{
			//不在塔中
			vee.data["IsInTower"] = false;
			//存储道具数据
			EquipManager.savePassEquipData(false, true);
		}
		vee.saveData();

		//----------------------------------------
		//存储重要数值
		this.saveVIPValues("All", 0);
	}
}