/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 15/1/31
 * Time: 上午11:47
 * To change this template use File | Settings | File Templates.
 */

var MapManager = {

	//基本地图数据
	m_nRow : 4,
	m_nCol : 4,

	//地图数据
	m_aStepsList : null,
	m_nCurrentStep : -1,
	m_nTargetStep : -1,
	m_nBossStep : -1,

	//辅助生成地图工具
	m_aStepLengths : null,
	m_aStepTargets : null,
	m_aStepAccess : null,
	m_aStepOne : null,
	m_nStepTargetIndex : 0,

	m_aStepsHistory : null,

	//---------------------------------------------------------------------------------------------------------------------------
	//初始化

	initMapManager : function()
	{
		//地图数据
		this.m_aStepsList = new Array(this.m_nRow * this.m_nCol);
		this.m_aStepAccess = new Array(this.m_nRow * this.m_nCol);
		this.m_aStepLengths = new Array(this.m_nRow * this.m_nCol);
		//辅助工具
		this.m_aStepTargets = new Array(4);
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//创建地图

	//初始化随机地图
	createMap : function()
	{
		//楼层
		var nFloor = GameManager.getCurrentFloor();
		//生成地图
		if(FloorData[nFloor].MapType == MapType.Sideway1){
			this.initMap2();
		}else{
			this.initMap();
		}
		//-----------------------------------------------------------
		//检索一通路
		this.setStepOne();
		//创建boss
		this.createBoss();
		//生成锁
		var nChestStep = this.createLock();
		//生成敌人
		this.createEnemy();
		//生成道具
		this.createChest(nChestStep);
		//-----------------------------------------------------------
		//设置不可见位置
		if(vee.VIPValues.getValue(VipKey.Compass) != 1){
			this.hideMap();
		}
	},

	//从存档中创建地图
	createMapByData : function()
	{
		var oMapData = vee.data["MapData"];
		//数据
		this.m_nCurrentStep = oMapData.m_nCurrentStep;
		this.m_nTargetStep = oMapData.m_nTargetStep;
		this.m_nBossStep = oMapData.m_nBossStep;
		this.m_aStepsList = oMapData.m_aStepsList;
		//清除数据
		vee.data["MapData"] = null;

		//每层随机道具
		EquipManager.createFloorPack(null, true, 0);
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//地图生成方法

	//生成地图
	initMap : function()
	{
		//重置地图数据
		this.resetMapData();

		//-----------------------------------------------------------

		//初始位置
		var nCurrentStep = StaticMethod.getRandom(this.m_nCol * this.m_nRow);
		this.m_nCurrentStep = nCurrentStep;
		//设置为在地图中
		this.m_aStepLengths[nCurrentStep] = 1;

		//添加门
		var aDoor = new Array();
		this.addDoor(aDoor, nCurrentStep);

		//循环生成
		while(aDoor.length > 0)
		{
			//随机选门
			var nIndex = StaticMethod.getRandom(aDoor.length);
			nCurrentStep = aDoor[nIndex];
			//加入地图
			this.m_aStepsList[nCurrentStep] &= 0xffffffef;

			//链接地图
			this.linkStep(nCurrentStep);

			//添加门
			this.addDoor(aDoor, nCurrentStep);

			//移除门
			aDoor.splice(nIndex, 1);
		}

		//重置地图
		for(var i = 0; i < this.m_nCol; i++)
		{
			var str = "";
			for(var j = 0; j < this.m_nCol; j++)
			{
				str += "   " + this.m_aStepLengths[i*4 + j];
			}
			cc.log(str);
		}
	},
	//添加门
	addDoor : function(aDoor, nCurrentStep)
	{
		//周围位置
		var nNextStep = 0;

		var nCount = -10;

		// 判断当前格子上方的格子是否可在下一次遍历到达
		nNextStep = nCurrentStep - this.m_nCol;
		if(nNextStep >= 0 && !this.m_aStepsList[nNextStep])
		{
			aDoor.push(nNextStep);
			this.m_aStepsList[nNextStep] = 0x10;

			nCount++;
			if(nCount > 1){
				return;
			}
		}
		// 判断当前格子右方的格子是否可在下一次遍历到达
		nNextStep = nCurrentStep + 1;
		if (nNextStep % this.m_nCol != 0 && !this.m_aStepsList[nNextStep])
		{
			aDoor.push(nNextStep);
			this.m_aStepsList[nNextStep] = 0x10;

			nCount++;
			if(nCount > 1){
				return;
			}
		}
		// 判断当前格子下方的格子是否可在下一次遍历到达
		nNextStep = nCurrentStep + this.m_nCol;
		if (nNextStep < this.m_aStepsList.length && !this.m_aStepsList[nNextStep])
		{
			aDoor.push(nNextStep);
			this.m_aStepsList[nNextStep] = 0x10;

			nCount++;
			if(nCount > 1){
				return;
			}
		}
		// 判断当前格子左方的格子是否可在下一次遍历到达
		nNextStep = nCurrentStep - 1;
		if (nCurrentStep % this.m_nCol != 0 && !this.m_aStepsList[nNextStep])
		{
			aDoor.push(nNextStep);
			this.m_aStepsList[nNextStep] = 0x10;

			nCount++;
			if(nCount > 1){
				return;
			}
		}
	},
	//得到随机相邻位置
	setAccess : function(nCurrentStep)
	{
		//重置方向
		this.m_nStepTargetIndex = 0;
		for(var i = 0; i < 4; i++)
		{
			this.m_aStepTargets[i] = -1;
		}
		//周围位置
		var nNextStep = 0;

		// 判断当前格子上方的格子是否可在下一次遍历到达
		nNextStep = nCurrentStep - this.m_nCol;
		if(nNextStep >= 0 && this.m_aStepLengths[nNextStep])
		{
			this.m_aStepTargets[0] = nNextStep;
			this.m_nStepTargetIndex++;
		}
		// 判断当前格子右方的格子是否可在下一次遍历到达
		nNextStep = nCurrentStep + 1;
		if (nNextStep % this.m_nCol != 0 && this.m_aStepLengths[nNextStep])
		{
			this.m_aStepTargets[1] = nNextStep;
			this.m_nStepTargetIndex++;
		}
		// 判断当前格子下方的格子是否可在下一次遍历到达
		nNextStep = nCurrentStep + this.m_nCol;
		if (nNextStep < this.m_aStepsList.length && this.m_aStepLengths[nNextStep])
		{
			this.m_aStepTargets[2] = nNextStep;
			this.m_nStepTargetIndex++;
		}
		// 判断当前格子左方的格子是否可在下一次遍历到达
		nNextStep = nCurrentStep - 1;
		if (nCurrentStep % this.m_nCol != 0 && this.m_aStepLengths[nNextStep])
		{
			this.m_aStepTargets[3] = nNextStep;
			this.m_nStepTargetIndex++;
		}

		return nNextStep;
	},
	//链接通路
	linkStep : function(nCurrentStep)
	{
		//设置相邻位置
		this.setAccess(nCurrentStep);

		//随机链接
		var nIndex = StaticMethod.getRandom(4);
		while (this.m_aStepTargets[nIndex] == -1){
			nIndex = StaticMethod.getRandom(4);
		}
		var nNextStep = this.m_aStepTargets[nIndex];

		//标记距离
		this.m_aStepLengths[nCurrentStep] = this.m_aStepLengths[nNextStep] + 1;
		//生成终点
		if(!GameManager.isBossFloor()
			&& this.m_aStepLengths[nCurrentStep] == 5
			&& this.m_nTargetStep == -1)
		{
			this.m_nTargetStep = nCurrentStep;
		}

		//标记地图
		switch (nIndex)
		{
			case 0:
			{
				// 如果是向上走
				// 当前格子的顶边标记为可通过（标记为1）
				// 下一格子的底边标记为可通过（标记为1）
				this.m_aStepsList[nCurrentStep] |= 1;
				this.m_aStepsList[nNextStep] |= 4;
			}
				break;
			case 1:
			{
				// 如果是向右走
				// 当前格子的右边标记为可通过（标记为1）
				// 下一格子的左边标记为可通过（标记为1）
				this.m_aStepsList[nCurrentStep] |= 2;
				this.m_aStepsList[nNextStep] |= 8;
			}
				break;
			case 2:
			{
				// 如果是向下走
				// 当前格子的底边标记为可通过（标记为1）
				// 下一格子的顶边标记为可通过（标记为1）
				this.m_aStepsList[nCurrentStep] |= 4;
				this.m_aStepsList[nNextStep] |= 1;
			}
				break;
			case 3:
			{
				// 如果是向左走
				// 当前格子的左边标记为可通过（标记为1）
				// 下一格子的右边标记为可通过（标记为1）
				this.m_aStepsList[nCurrentStep] |= 8;
				this.m_aStepsList[nNextStep] |= 2;
			}
				break;
		}

		//标记通路数量
		this.m_aStepAccess[nCurrentStep]++;
		this.m_aStepAccess[nNextStep]++;
	},

	//清空地图
	resetMapData : function()
	{
		//初始化主要位置
		this.m_nCurrentStep = -1;
		this.m_nTargetStep = -1;
		this.m_nBossStep = -1;

		//清空地图
		for(var i = 0; i < this.m_aStepsList.length; i++)
		{
			this.m_aStepsList[i] = 0;
			this.m_aStepAccess[i] = 0;
			this.m_aStepLengths[i] = 0;
		}

		//清空历史
		this.m_aStepsHistory = [];
		//一通路
		this.m_aStepOne = [];
	},

	//---------------------------------------------------------------------------------------------------------------------------

	initMap2 : function()
	{
		//重置地图数据
		this.resetMapData();
		//-----------------------------------------------------------
		//初始位置
		var nCurrentStep = StaticMethod.getRandom(this.m_nCol * this.m_nRow);
		this.m_nCurrentStep = nCurrentStep;
		this.m_aStepLengths[nCurrentStep] = 1;
		//寻路算法
		while(this.hasNextStep()){
			nCurrentStep = this.stepNext(nCurrentStep);
		}

		//重置地图
		for(var i = 0; i < this.m_nCol; i++)
		{
			var str = "";
			for(var j = 0; j < this.m_nCol; j++)
			{
				str += "   " + this.m_aStepLengths[i*4 + j];
			}
			cc.log(str);
		}
	},
	//检测空位
	hasNextStep : function()
	{
		// 得到地图上下一个未到达的格子
		for (var i = 0; i < this.m_aStepsList.length; i ++) {
			if (!this.m_aStepsList[i]){
				return true;
			}
		}
		return false;
	},
	//设置下一步
	stepNext : function(nCurrentStep)
	{
		//获取可行方向
		this.setStepTargets(nCurrentStep);

		// 如果当前格子的所有邻居都无法到达，
		if(this.m_nStepTargetIndex == 0){
			var nLastStep = this.m_aStepsHistory.pop();
			return this.stepNext(nLastStep);
		}
		// 将当前位置记入历史记录
		this.m_aStepsHistory.push(nCurrentStep);

		// 从当前格子可到达的领居中随机选取一个
		var nIndex = StaticMethod.getRandom(4);
		while (this.m_aStepTargets[nIndex] == -1) {
			nIndex = StaticMethod.getRandom(4);
		}
		var nNextStep = this.m_aStepTargets[nIndex];
		//标记距离
		this.m_aStepLengths[nNextStep] = this.m_aStepLengths[nCurrentStep] + 1;

		//标记地图
		switch (nIndex)
		{
			case 0:
			{
				// 如果是向上走
				// 当前格子的顶边标记为可通过（标记为1）
				// 下一格子的底边标记为可通过（标记为1）
				this.m_aStepsList[nCurrentStep] |= 1;
				this.m_aStepsList[nNextStep] |= 4;
			}
				break;
			case 1:
			{
				// 如果是向右走
				// 当前格子的右边标记为可通过（标记为1）
				// 下一格子的左边标记为可通过（标记为1）
				this.m_aStepsList[nCurrentStep] |= 2;
				this.m_aStepsList[nNextStep] |= 8;
			}
				break;
			case 2:
			{
				// 如果是向下走
				// 当前格子的底边标记为可通过（标记为1）
				// 下一格子的顶边标记为可通过（标记为1）
				this.m_aStepsList[nCurrentStep] |= 4;
				this.m_aStepsList[nNextStep] |= 1;
			}
				break;
			case 3:
			{
				// 如果是向左走
				// 当前格子的左边标记为可通过（标记为1）
				// 下一格子的右边标记为可通过（标记为1）
				this.m_aStepsList[nCurrentStep] |= 8;
				this.m_aStepsList[nNextStep] |= 2;
			}
				break;
		}

		//标记通路数量
		this.m_aStepAccess[nCurrentStep]++;
		this.m_aStepAccess[nNextStep]++;

		return nNextStep;
	},
	//寻找方向
	setStepTargets : function(nCurrentStep)
	{
		//重置
		var nNextStep = 0;
		this.m_nStepTargetIndex = 0;
		for(var i = 0; i < 4; i++){
			this.m_aStepTargets[i] = -1;
		}

		// 判断当前格子上方的格子是否可在下一次遍历到达
		nNextStep = nCurrentStep - this.m_nCol;
		if(nNextStep >= 0 && !this.m_aStepsList[nNextStep])
		{
			this.m_aStepTargets[0] = nNextStep;
			this.m_nStepTargetIndex++;
		}

		// 判断当前格子右方的格子是否可在下一次遍历到达
		nNextStep = nCurrentStep + 1;
		if (nNextStep % this.m_nCol != 0 && !this.m_aStepsList[nNextStep])
		{
			this.m_aStepTargets[1] = nNextStep;
			this.m_nStepTargetIndex++;
		}

		// 判断当前格子下方的格子是否可在下一次遍历到达
		nNextStep = nCurrentStep + this.m_nCol;
		if (nNextStep < this.m_aStepsList.length && !this.m_aStepsList[nNextStep])
		{
			this.m_aStepTargets[2] = nNextStep;
			this.m_nStepTargetIndex++;
		}

		// 判断当前格子左方的格子是否可在下一次遍历到达
		nNextStep = nCurrentStep - 1;
		if (nCurrentStep % this.m_nCol != 0 && !this.m_aStepsList[nNextStep])
		{
			this.m_aStepTargets[3] = nNextStep;
			this.m_nStepTargetIndex++;
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//辅助地图方法

	//找到同路为一的位置
	setStepOne : function()
	{
		// 得到地图上下一个未到达的格子
		for (var i = 0; i < this.m_aStepsList.length; i ++)
		{
			if (this.m_aStepAccess[i] == 1 && i != this.m_nCurrentStep)
			{
				this.m_aStepOne.push(i);
			}
		}
	},
	//得到单一通路相邻位置
	getLinkStep : function(nStepData, nStep, bLock)
	{
		//位置
		var nNextStep = -1;
		//判断通路方向
		switch (nStepData & 0xf)
		{
			case 1:
			{
				//相邻位置
				nNextStep = nStep - this.m_nCol;
				//相邻上锁
				if(bLock)
				{
					this.m_aStepsList[nNextStep] |= 0x40;
				}
			}
				break;
			case 2:
			{
				//相邻位置
				nNextStep = nStep + 1;
				//相邻上锁
				if(bLock)
				{
					this.m_aStepsList[nNextStep] |= 0x80;
				}
			}
				break;
			case 4:
			{
				//相邻位置
				nNextStep = nStep + this.m_nCol;
				//相邻位置
				if(bLock)
				{
					this.m_aStepsList[nNextStep] |= 0x10;
				}
			}
				break;
			case 8:
			{
				//相邻位置
				nNextStep = nStep - 1;
				//相邻位置
				if(bLock)
				{
					this.m_aStepsList[nNextStep] |= 0x20;
				}
			}
				break;
		}

		return nNextStep;
	},
	//锁boss
	getLinkStepByDirection : function(nStepData, nCurrentStep, bLock)
	{
		var nNextStep = -1;
		// 判断当前格子上方的格子是否可在下一次遍历到达
		nNextStep = nCurrentStep - this.m_nCol;
		if(nNextStep >= 0
			&& (this.m_aStepLengths[nNextStep] == this.m_aStepLengths[nCurrentStep]-1)
			&& (this.m_aStepsList[nCurrentStep] & 1) == 1)
		{
			if(bLock) this.m_aStepsList[nNextStep] |= 0x40;
			return nNextStep;
		}

		// 判断当前格子右方的格子是否可在下一次遍历到达
		nNextStep = nCurrentStep + 1;
		if (nNextStep % this.m_nCol != 0
			&& (this.m_aStepLengths[nNextStep] == this.m_aStepLengths[nCurrentStep]-1)
			&& (this.m_aStepsList[nCurrentStep] & 2) == 2)
		{
			if(bLock) this.m_aStepsList[nNextStep] |= 0x80;
			return nNextStep;
		}

		// 判断当前格子下方的格子是否可在下一次遍历到达
		nNextStep = nCurrentStep + this.m_nCol;
		if (nNextStep < this.m_aStepsList.length
			&& (this.m_aStepLengths[nNextStep] == this.m_aStepLengths[nCurrentStep]-1)
			&& (this.m_aStepsList[nCurrentStep] & 4) == 4)
		{
			if(bLock) this.m_aStepsList[nNextStep] |= 0x10;
			return nNextStep;
		}

		// 判断当前格子左方的格子是否可在下一次遍历到达
		nNextStep = nCurrentStep - 1;
		if (nCurrentStep % this.m_nCol != 0
			&& (this.m_aStepLengths[nNextStep] == this.m_aStepLengths[nCurrentStep]-1)
			&& (this.m_aStepsList[nCurrentStep] & 8) == 8)
		{
			if(bLock) this.m_aStepsList[nNextStep] |= 0x20;
			return nNextStep;
		}

		//
		return null;
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//生成地图内元素

	//生成终点
	createTarget : function()
	{
		var nMax = -1;
		var nStep = -1;
		var nIndex = -1;
		for(var i = 0; i < this.m_aStepOne.length; i++)
		{
			nStep = this.m_aStepOne[i];
			if(this.m_aStepLengths[nStep] > nMax)
			{
				nMax = this.m_aStepLengths[nStep];
				//终点
				this.m_nTargetStep = nStep;
				nIndex = i;
			}
		}
		this.m_aStepOne.splice(nIndex, 1);
	},
	//创建开始结束位置
	createBoss : function()
	{
		//boss位置
		if(GameManager.isBossFloor())
		{
			var nMax = -1;
			var nStep = -1;
			var nIndex = -1;
			for(var i = 0; i < this.m_aStepOne.length; i++)
			{
				nStep = this.m_aStepOne[i];
				if(this.m_aStepLengths[nStep] > nMax)
				{
					nMax = this.m_aStepLengths[nStep];
					//终点
					this.m_nTargetStep = nStep;
					nIndex = i;
				}
			}
			this.m_aStepOne.splice(nIndex, 1);

			//boss
			this.m_nBossStep = this.getLinkStep(this.m_aStepsList[this.m_nTargetStep], this.m_nTargetStep, true);
			//生成敌人地图位置
			this.createEnemyStep(this.m_nBossStep);
		}
		else
		{
			this.createTarget();
		}
	},
	//生成锁
	createLock : function()
	{
		//得到当前层
		var oTowerData = GameManager.getTowerData();
		var strFloor = "layer_" + oTowerData.m_nBigFloor + "_" + oTowerData.m_nSmallFloor;

		//锁住宝箱位置
		var nChestStep = -1;

		//判断有锁
		if(DoorMap[strFloor][0] <= 0){
			return nChestStep;
		}

		//生成锁
		for(var i = 0; i < DoorMap[strFloor].length; i++)
		{
			switch (DoorMap[strFloor][i])
			{
				//一般锁
				case 1:
				{
					//随机锁位置
					var nRandom = StaticMethod.getRandom(this.m_aStepOne.length);
					nChestStep = this.m_aStepOne[nRandom];
					this.createLockStep(nChestStep);

					//生成一般锁
					this.getLinkStep(this.m_aStepsList[nChestStep], nChestStep, true);
				}
					break;

				//boss锁
				case 2:
				{
					this.getLinkStepByDirection(this.m_aStepsList[this.m_nBossStep], this.m_nBossStep, true);
				}
					break;
			}
		}

		return nChestStep;
	},

	//生成敌人
	createEnemy : function()
	{
		var nRandom = StaticMethod.getRandom(100);
		var nNumber = 2;
		if(nRandom < 15){
			nNumber = 2;
		}else if(nRandom >= 15 && nRandom < 45){
			nNumber = 3;
		}else if(nRandom >= 45 && nRandom < 85){
			nNumber = 4;
		}else{
			nNumber = 5;
		}

		//怪物数量
		//var nNumber = StaticMethod.getRandom(2) + 2;
		//循环随机确定位置
		while(nNumber != 0)
		{
			var nTempStep = StaticMethod.getRandom(this.m_aStepsList.length);
			if(nTempStep != this.m_nCurrentStep
				&& nTempStep != this.m_nTargetStep
				&& !this.locateEnemyStep(nTempStep)
				&& !this.locateLockStep(nTempStep))
			{
				this.createEnemyStep(nTempStep);
				nNumber--;
			}
		}
	},
	//生成宝箱
	createChest : function(nChestStep)
	{
		//得到当前层
		var oTowerData = GameManager.getTowerData();
		var strFloor = "layer_" + oTowerData.m_nBigFloor + "_" + oTowerData.m_nSmallFloor;

		//得到钥匙
		var nKeyNumber = KeyMap[strFloor][0];

		//生成道具数量
		var nRandom = StaticMethod.getRandom(100);
		var nNumber = 2;
		if(nRandom < 15){
			nNumber = 2;
		}else if(nRandom >= 15 && nRandom < 75){
			nNumber = 3;
		}else {
			nNumber = 4;
		}
		//var nNumber = StaticMethod.getRandom(2) + 2 + nKeyNumber;
		var aEquipSteps = [];

		//随机生成道具位置
		while(nNumber != 0)
		{
			var nTempStep = StaticMethod.getRandom(this.m_aStepsList.length);
			if(nTempStep != this.m_nCurrentStep
				&& nTempStep != this.m_nTargetStep
				&& nTempStep != this.m_nBossStep
				&& !this.locateChestStep(nTempStep)
				&& !this.locateLockStep(nTempStep))
			{
				this.createEquipStep(nTempStep);
				aEquipSteps.push(nTempStep);
				nNumber--;
			}
		}

		//生成锁宝箱
		if(nChestStep >= 0)
		{
			this.createEquipStep(nChestStep);
			aEquipSteps.push(nChestStep);
		}

		//每层随机道具
		EquipManager.createFloorPack(aEquipSteps, false, nKeyNumber);
	},

	//设置不可见位置
	hideMap : function()
	{
		for(var i = 0; i < this.m_aStepsList.length; i++)
		{
			if(i != this.m_nCurrentStep)
			{
				this.m_aStepsList[i] |= 0x100;
			}
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------

	//生成敌人位置
	createEnemyStep : function(nStep)
	{
		this.m_aStepsList[nStep] |= 0x200;
	},
	//生成道具位置
	createEquipStep : function(nStep)
	{
		this.m_aStepsList[nStep] |= 0x400;
		this.m_aStepsList[nStep] |= 0x800;
	},
	//生成锁区域
	createLockStep : function(nStep)
	{
		this.m_aStepsList[nStep] |= 0x1000;
	},

	//---------------------------------------------------------------------------------------------------------------------------

	//检测敌人位置
	locateEnemyStep : function(nStep)
	{
		if(nStep == null)
		{
			nStep = this.m_nCurrentStep;
		}
		return (this.m_aStepsList[nStep] & 0x200) == 0x200;
	},
	//宝箱位置
	locateChestStep : function(nStep)
	{
		if(nStep == null){
			nStep = this.m_nCurrentStep;
		}
		return (this.m_aStepsList[nStep] & 0x400) == 0x400;
	},
	//检测宝箱位置
	locateChestStepWithEnemy : function(nStep)
	{
		if(nStep == null){
			nStep = this.m_nCurrentStep;
		}
		
		if(this.locateEnemyStep(nStep)){
			return 1;
		}
		
		if((this.m_aStepsList[nStep] & 0x400) == 0x400)
		{
			if((this.m_aStepsList[nStep] & 0x800) == 0x800)
			{
				return 2;//宝箱未打开
			}
			else
			{
				return 3;//宝箱已打开
			}
		}
		else
		{
			return 1;//没有宝箱
		}
	},
	//检测Boss位置
	locateBossStep : function(nStep)
	{
		if(nStep == null){
			nStep = this.m_nCurrentStep;
		}
		return (this.m_nBossStep != -1 && (nStep == this.m_nBossStep));
	},
	//检测传送位置
	locatePortalStep : function(nStep)
	{
		if(nStep == null){
			nStep = this.m_nCurrentStep;
		}
		return this.m_nCurrentStep == this.m_nTargetStep;
	},
	//检测隐藏
	locateHideStep : function(nStep)
	{
		if(nStep == null){
			nStep = this.m_nCurrentStep;
		}
		return (this.m_aStepsList[nStep] & 0x100) == 0x100;
	},
	//锁区域
	locateLockStep : function(nStep)
	{
		if(nStep == null){
			nStep = this.m_nCurrentStep;
		}
		return (this.m_aStepsList[nStep] & 0x1000) == 0x1000;
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//修改地图数据

	//显示新地图，修改数据
	removeHideStep : function(nTarget)
	{
		this.m_aStepsList[nTarget] &= 0xfffffeff;
	},
	//修改敌人位置
	removeEnemyStep : function(nTarget)
	{
		this.m_aStepsList[nTarget] &= 0xfffffdff;
	},
	//修改宝箱位置
	openChestStep : function(nTarget)
	{
		this.m_aStepsList[nTarget] &= 0xfffff7ff;
	},
	//清空宝箱
	removeChestStep : function(nTarget)
	{
		this.m_aStepsList[nTarget] &= 0xfffff3ff;
	},
	//清空门
	removeKeyStep : function(nTarget, nData)
	{
		this.m_aStepsList[nTarget] &= ~nData;
	},
	
	//---------------------------------------------------------------------------------------------------------------------------

	//门检测
	moveCheckLock : function(nDirection)
	{
		var nDoor = -1;
		//判断方向
		switch (nDirection)
		{
			case 1:
			{
				if((this.m_aStepsList[this.m_nCurrentStep] & 0x10) == 0x10){
					nDoor = 0x10;
				}
			}
				break;
			case 2:
			{
				if ((this.m_aStepsList[this.m_nCurrentStep] & 0x20) == 0x20){
					nDoor = 0x20;
				}
			}
				break;
			case 4:
			{
				if ((this.m_aStepsList[this.m_nCurrentStep] & 0x40) == 0x40){
					nDoor = 0x40;
				}
			}
				break;
			case 8:
			{
				if ((this.m_aStepsList[this.m_nCurrentStep] & 0x80) == 0x80){
					nDoor = 0x80;
				}
			}
				break;
		}
		return nDoor;
	},
	//移动检测
	moveNextStep : function(nDirection)
	{
		var nCurrentStep = this.m_nCurrentStep;
		
		var nNextStep = -1;
		//判断方向
		switch (nDirection)
		{
			// 如果是向上走
			case 1:
			{
				nNextStep = nCurrentStep - this.m_nCol;
				if(nNextStep >= 0 && (this.m_aStepsList[nCurrentStep] & 1) == 1)
				{
					this.m_nCurrentStep = nNextStep;
					return nNextStep;
				}
			}
				break;
			// 如果是向右走
			case 2:
			{
				nNextStep = nCurrentStep + 1;
				if (nNextStep % this.m_nCol != 0 && (this.m_aStepsList[nCurrentStep] & 2) == 2)
				{
					this.m_nCurrentStep = nNextStep;
					return nNextStep;
				}
			}
				break;
			// 如果是向下走
			case 4:
			{
				nNextStep = nCurrentStep + this.m_nCol;
				if (nNextStep < this.m_aStepsList.length && (this.m_aStepsList[nCurrentStep] & 4) == 4)
				{
					this.m_nCurrentStep = nNextStep;
					return nNextStep;
				}
			}
				break;
			// 如果是向左走
			case 8:
			{
				nNextStep = nCurrentStep - 1;
				if (nCurrentStep % this.m_nCol != 0 && (this.m_aStepsList[nCurrentStep] & 8) == 8)
				{
					this.m_nCurrentStep = nNextStep;
					return nNextStep;
				}
			}
				break;
		}
		//
		return -1;
	},

	//---------------------------------------------------------------------------------------------------------------------------

	//存储地图
	saveMap : function()
	{
		var oMapData = {};
		oMapData.m_nCurrentStep = this.m_nCurrentStep;
		oMapData.m_nTargetStep = this.m_nTargetStep;
		oMapData.m_nBossStep = this.m_nBossStep;
		oMapData.m_aStepsList = this.m_aStepsList;
		//存储地图
		vee.data["MapData"] = oMapData;
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//属性方法

	getStepData : function(nTarget)
	{
		return this.m_aStepsList[nTarget];
	},
	getMapWidth : function()
	{
		return this.m_nCol;
	},
	getMapLength : function()
	{
		return this.m_aStepsList.length;
	},
	getStartStep : function()
	{
		return this.m_nCurrentStep;
	},
	getTargetStep : function()
	{
		return this.m_nTargetStep;
	},
	getCurrentStep : function()
	{
		return this.m_nCurrentStep;
	},
	//boss锁数据
	getBossLock : function()
	{
		return (this.getStepData(this.m_nBossStep) & 0xf0);
	},
	//boss锁方向
	getBossLockDirection : function()
	{
		var nDirection = -1;
		switch (this.getStepData(this.m_nBossStep) & 0xf0)
		{
			case 0x10:
			{
				nDirection = 1;
			}
				break;
			case 0x20:
			{
				nDirection = 2;
			}
				break;
			case 0x40:
			{
				nDirection = 4;
			}
				break;
			case 0x80:
			{
				nDirection = 8;
			}
				break;
		}
		return nDirection;
	}
}
