/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 15/1/31
 * Time: 上午11:13
 * To change this template use File | Settings | File Templates.
 */

//主要数据
function GameVipData(nMoney, nOpenFloor, nUnLockFloor, nPackLockIndex)
{
	this.m_nMoney = nMoney;
	this.m_nOpenFloor = nOpenFloor;
	this.m_nUnLockFloor = nUnLockFloor;
	this.m_nPackLockIndex = nPackLockIndex;
};
//塔中数据
function TowerData(nGameWin, nBigFloor, nSmallFloor, nTowerMoney, nTowerStep, nTowerSp)
{
	this.m_nGameWin = nGameWin;
	this.m_nBigFloor = nBigFloor;
	this.m_nSmallFloor = nSmallFloor;
	this.m_nTowerMoney = nTowerMoney;
	this.m_nTowerStep = nTowerStep;
	this.m_nTowerSp = nTowerSp;
};
TowerData.prototype.reset = function()
{
	this.m_nGameWin = 0;
	this.m_nBigFloor = 1;
	this.m_nSmallFloor = 1;
	this.m_nTowerMoney = 0;
	this.m_nTowerStep = 40;
	this.m_nTowerSp = 0;
};

//------------------------------------------------------------------------------------------------------------

//属性
function AttrItem(nType, nValue)
{
	this.m_nType = nType;
	this.m_nValue = nValue;
};
//装备系数
function EquipCoe(nId, nLv, nRare)
{
	this.m_nId = nId;
	this.m_nLv = nLv;
	this.m_nRare = nRare;
};
//装备
function GameEquip1(oCoe, oData)
{
	this.m_oCoe = oCoe;
	this.m_oData = oData;
};
GameEquip1.prototype.getAttrById = function(nId)
{
	if(this.m_oData["Pro_Type_"+nId] < 0){
		return null;
	}
	return new AttrItem(this.m_oData["Pro_Type_"+nId], this.m_oData["Pro_Value_"+nId]);
};
GameEquip1.prototype.getAttrValueById = function(nId)
{
	var nValue = this.m_oData["Pro_Value_"+nId];
	if(StaticMethod.isInteger(nValue))
	{
		nValue = nValue + (this.m_oCoe.m_nLv - 1) * (nValue / 10);
		nValue = Math.floor(nValue * (1 + 0.5 * this.m_oCoe.m_nRare));
	}
	else
	{
		nValue = parseFloat(nValue);
		nValue = nValue + 0.025 * (this.m_oCoe.m_nLv- 1) + (0.5 * this.m_oCoe.m_nRare);
	}
	return nValue;
};

//------------------------------------------------------------------------------------------------------------

//装备槽
function EquipBox(nType)
{
	this.m_nType = nType;
	this.m_oEquip = null;
};
EquipBox.prototype.addEquip = function(oEquip)
{
	if(this.m_nType == oEquip.m_oData.EquipType){
		this.m_oEquip = oEquip;
		return true;
	}
	return false;
};
EquipBox.prototype.removeEquip = function()
{
	this.m_oEquip = null;
};
//背包
function EquipPack()
{
	this.m_aEquips = new Array();
};
EquipPack.prototype.getPackLength = function()
{
	return this.m_aEquips.length;
};
EquipPack.prototype.addEquip = function(oEquip)
{
	this.m_aEquips.push(oEquip);
};
EquipPack.prototype.setEquipById = function(nId, oEquip)
{
	if(oEquip != null){
		this.m_aEquips[nId] = oEquip;
	}else{
		this.m_aEquips.splice(nId, 1);
	}
};
EquipPack.prototype.getEquipById = function(nId)
{
	return this.m_aEquips[nId];
};
EquipPack.prototype.exchangeEquip = function(oEquip, oEquip2)
{
	for(var i = 0; i < this.m_aEquips.length; i++)
	{
		if(this.m_aEquips[i] == oEquip)
		{
			this.m_aEquips[i] = oEquip2;
			break;
		}
	}
};
EquipPack.prototype.removeEquip = function(oEquip)
{
	for(var i = 0; i < this.m_aEquips.length; i++)
	{
		if(this.m_aEquips[i] == oEquip)
		{
			this.m_aEquips.splice(i, 1);
			break;
		}
	}
};
EquipPack.prototype.removeByType = function(nType)
{
	for(var i = 0; i < this.m_aEquips.length; i++)
	{
		if(this.m_aEquips[i].m_nType == nType)
		{
			this.m_aEquips.splice(i, 1);
			return true;
		}
	}
	return false;
};
EquipPack.prototype.checkByTypeSp = function(nType, bRemove)
{
	for(var i = 0; i < this.m_aEquips.length; i++)
	{
		var oData = this.m_aEquips[i].m_oData;
		if(oData.EquipType == EquipType.Special && oData.EqupSpType == nType)
		{
			if(bRemove){
				this.m_aEquips.splice(i, 1);
			}
			return true;
		}
	}
	return false;
};
//玩家身上装备
function PlayerPack()
{
	EquipPack.call(this);
	this.m_aEquips.push(new EquipBox(EquipType.Hand));
	this.m_aEquips.push(new EquipBox(EquipType.Body));
	this.m_aEquips.push(new EquipBox(EquipType.Hand));
	for(var i = 0; i < 6; i++){
		this.m_aEquips.push(new EquipBox(EquipType.Accessories));
	}
};
PlayerPack.prototype = new EquipPack();
PlayerPack.prototype.setEquipById = function(nId, oEquip)
{
	if(oEquip != null){
		this.m_aEquips[nId].addEquip(oEquip)
	}
	else{
		this.m_aEquips[nId].removeEquip();
	}
};
PlayerPack.prototype.getEquipById = function(nId)
{
	return this.m_aEquips[nId].m_oEquip;
};
PlayerPack.prototype.getEquipBoxById = function(nId)
{
	return this.m_aEquips[nId];
};

//------------------------------------------------------------------------------------------------------------

var PlayerDefaultBase = [110, 10, 10, 0, 1];
//角色
function GameRole()
{
	//赋值玩家数据
	this.m_nLv = 1;
	this.m_nPt = 0;
	this.m_nExp = 0;
	this.m_nHP = 0;

	//属性
	this.m_aBase = [0, 0, 0, 0, 0];
	this.m_aFight = [0, 0, 0, 0, 0];
};
GameRole.prototype.resetBase = function()
{
	for(var i = 0; i < 5; i++){
		this.m_aBase[i] = 0;
	}
};
GameRole.prototype.getBaseByIndex = function(nIndex)
{
	return this.m_aBase[nIndex];
};
GameRole.prototype.setBaseByIndex = function(nIndex, nValue)
{
	this.m_aBase[nIndex] = nValue;
};
GameRole.prototype.getFightByIndex = function(nIndex)
{
	return this.m_aFight[nIndex];
};
GameRole.prototype.setFightByIndex = function(nIndex, nValue)
{
	this.m_aFight[nIndex] = nValue;
};
GameRole.prototype.getRealByIndex = function(nIndex)
{
	return this.m_aFight[nIndex];
};
//其他功能
GameRole.prototype.revertHP = function()
{
	this.m_nHP = this.getRealByIndex(0);
}
GameRole.prototype.getHpPercent = function()
{
	return Math.floor(this.m_nHP / this.getRealByIndex(0) * 100);
}
GameRole.prototype.getFightPercent = function(nFightHp)
{
	return Math.floor(nFightHp / this.getRealByIndex(0) * 100);
};
GameRole.prototype.isDead = function()
{
	return this.m_nHP <= 0;
}
//有装备的角色
function EquipRole()
{
	GameRole.call(this);
	this.m_aEquip1 = [0, 0, 0, 0, 0];
	this.m_aEquip2 = [0, 0, 0, 0, 0];
}
EquipRole.prototype = new GameRole();
EquipRole.prototype.getEquip1ByIndex = function(nIndex)
{
	return this.m_aEquip1[nIndex];
}
EquipRole.prototype.setEquip1ByIndex = function(nIndex, nValue)
{
	this.m_aEquip1[nIndex] = nValue;
}
EquipRole.prototype.getEquip2ByIndex = function(nIndex)
{
	return this.m_aEquip2[nIndex];
}
EquipRole.prototype.setEquip2ByIndex = function(nIndex, nValue)
{
	this.m_aEquip2[nIndex] = nValue;
}
EquipRole.prototype.getRealByIndex = function(nIndex)
{
	var nPercent = this.getEquip2ByIndex(nIndex);
	var nTotal = this.getEquip1ByIndex(nIndex) + this.getFightByIndex(nIndex);
	return Math.floor(nTotal * (1 + nPercent));
}

//------------------------------------------------------------------------------------------------------------

//提示
function HintRole()
{
	this.m_aEquip1 = [0, 0, 0, 0, 0];
	this.m_aEquip2 = [0, 0, 0, 0, 0];
};
HintRole.prototype.reset = function()
{
	for(var i = 0; i < 5; i++)
	{
		this.m_aEquip1[i] = 0;
		this.m_aEquip2[i] = 0;
	}
};

//------------------------------------------------------------------------------------------------------------

//战斗结果
function FightResult()
{
	this.m_nFightOver = 0;
	this.m_nFightRole = -1;
	this.m_nFightHp = 0;
	this.m_nHpPercent = 0;
	this.m_nFightPercent = 0;
	this.m_nRoleHp = 0;
	this.m_nChangeStep = 0;
	this.m_bFirstAttack = false;
	this.m_nCombo = 1;
	this.m_bIsBoss = false;
	this.m_strEnemyName = "";
};
FightResult.prototype.reset = function()
{
	this.m_nFightOver = 0;
	this.m_nFightRole = -1;
	this.m_nFightHp = 0;
	this.m_nHpPercent = 0;
	this.m_nFightPercent = 0;
	this.m_nRoleHp = 0;
	this.m_nChangeStep = 0;
	this.m_bFirstAttack = false;
	this.m_nCombo = 1;
	this.m_bIsBoss = false;
	this.m_strEnemyName = "";
};
//胜利结果
function WinResult()
{
	this.m_nExp = 0;
	this.m_nCoin = 0;
	this.m_nExpPercent = 0;
	this.m_nBoost = 0;
	this.m_nLvPre = 0;
	this.m_nLvCur = 0;
	this.m_nLvPlus = 0
};
WinResult.prototype.reset = function()
{
	this.m_nExp = 0;
	this.m_nCoin = 0;
	this.m_nExpPercent = 0;
	this.m_nBoost = 0;
	this.m_nLvPre = 0;
	this.m_nLvCur = 0;
	this.m_nLvPlus = 0
};
//缓存数据
function FightCache()
{
	this.m_nCacheMoney = -1;
	this.m_nCacheStep = -1;
	this.m_nCacheLv = -1;
	this.m_nCacheExp = -1;
	this.m_nPotion = -1;
};
FightCache.prototype.reset = function()
{
	this.m_nCacheMoney = -1;
	this.m_nCacheStep = -1;
	this.m_nCacheLv = -1;
	this.m_nCacheExp = -1;
	this.m_nPotion = -1;
};

//------------------------------------------------------------------------------------------------------------

//背包迭代器
function PackIterator(oPack)
{
	this.m_oPack = oPack;
	this.m_nPage = 0;
	this.m_nMaxPage = 0;
};
PackIterator.prototype.initPage = function()
{
	var nLength = this.m_oPack.getPackLength();
	this.m_nMaxPage = (nLength - 1) / 4 > 0 ? (nLength - 1) / 4 : 0;
	this.m_nMaxPage = Math.floor(this.m_nMaxPage);
};
PackIterator.prototype.getPage = function()
{
	var aEquips = new Array();
	var nLength = this.m_oPack.getPackLength();
	for(var i = 0; i < 4; i ++)
	{
		//更新每条显示
		var nIndex = i + this.m_nPage * 4;
		nIndex = nLength - nIndex - 1;
		//添加到数组
		if(nIndex >= 0){
			aEquips.push(this.m_oPack.getEquipById(nIndex));
		}else{
			break;
		}
	}
	return aEquips;
};
PackIterator.prototype.hasNext = function()
{
	return this.m_nPage < this.m_nMaxPage;
};
PackIterator.prototype.hasPrevious = function()
{
	return this.m_nPage > 0;
};
PackIterator.prototype.next = function()
{
	this.m_nPage++;
	return this.getPage();
};
PackIterator.prototype.previous = function()
{
	this.m_nPage--;
	return this.getPage();
};
PackIterator.prototype.removeEquip = function(oEquip)
{
	this.m_oPack.removeEquip(oEquip);
};
//迭代器合集
function PackIteratorSet(oIterator)
{
	this.m_oBase = oIterator;
	this.m_aIterators = new Array(4);
};
PackIteratorSet.prototype.getBaseIterator = function()
{
	return this.m_oBase;
};
PackIteratorSet.prototype.getIteratorByKind = function(nKind)
{
	if(!this.m_aIterators[nKind])
	{
		var oKindPack = new EquipPack();
		var oPack = this.m_oBase.m_oPack;
		for(var i = 0; i < oPack.getPackLength(); i++)
		{
			var oEquip = oPack.getEquipById(i);
			if(oEquip.m_oData.EquipKind == nKind){
				oKindPack.addEquip(oEquip);
			}
		}
		this.m_aIterators[nKind] = new PackIterator(oKindPack);
	}
	return this.m_aIterators[nKind];
};

//------------------------------------------------------------------------------------------------------------
