/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 15/2/3
 * Time: 下午2:37
 * To change this template use File | Settings | File Templates.
 */


//公式
var GameFormula = {

	//---------------------------------------------------------------------------------------------------------------------------
	//角色属性

	//属性增长计算
	computerFightByBase : function(nType, nValue)
	{
		switch(nType)
		{
			case 0:
				return nValue * 5;
				break;
			case 1:
				return nValue * 3;
				break;
			case 2:
				return nValue * 3;
				break;
			case 3:
				return nValue * 2;
				break;
			case 4:
				return nValue;
				break;
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//floor相关

	//解锁塔钱
	floorPrice : function(nIndex)
	{
		return FloorPrice[nIndex-1];
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//道具相关

	//得到解锁所需金钱
	equipBoxPrice : function(nIndex)
	{
		return EquipBoxPrice[nIndex-1];
	},
	//升级道具所需金钱
	upgradePrice : function(oEquip)
	{
		var nValue = Math.floor((EquipFloorPrice[oEquip.m_oData.Floor-1] / 4) * (oEquip.m_oCoe.m_nLv + 1) * (oEquip.m_oCoe.m_nLv + 1));
		return nValue
	},
	//卖道具所得金钱
	sellPrice : function(oEquip)
	{
		var nValue = Math.floor(EquipFloorPrice[oEquip.m_oData.Floor-1] / 4 * oEquip.m_oCoe.m_nLv);
		return nValue;
	},
	//血瓶价格
	potionPrice : function(nNumber)
	{
		if(nNumber == 0){
			return 0;
		}
		var nFloor = GameManager.getVIPData().m_nOpenFloor > 8 ? 8 : GameManager.getVIPData().m_nOpenFloor;
		return PotionPrice[nFloor][nNumber-1];
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//战斗相关

	//先制攻击
	firstAttack : function(oPlayer, oEnemy)
	{
		var nSp1 = oPlayer.getRealByIndex(AttributeType.Speed);
		var nSp2 = oEnemy.getRealByIndex(AttributeType.Speed);

		var nOdds = (nSp1 - nSp2) / nSp2 * 0.1;
		nOdds = nOdds > 0.9 ? 0.9 : nOdds;

		if(nOdds > 0)
		{
			nOdds = Math.floor(nOdds * 0.3 * 10);
			if((StaticMethod.getRandom(10) + 1) < nOdds){
				return true;
			}
		}
		return false;
	},
	//攻击公式
	roleAttack : function(nAttack, nDefense)
	{
		return Math.floor(Math.random() * (nAttack/25) + 1 + nAttack * (2 - Math.min(2, Math.max(0, nDefense / nAttack)))/4);
	},
	//获得经验
	getFightExp : function(oEnemyRole)
	{
		return oEnemyRole.m_nExp;
	},
	//获得金钱
	getFightCoin : function(oEnemyRole)
	{
		return oEnemyRole.m_nCoin;
	},

	//下一级所需经验
	getNextLvExp : function(nLv)
	{
		return nLv * 2;
	},
	//下一级所需经验百分比
	getNextLvExpPercent : function(nExp, nLv)
	{
		return Math.floor(nExp / this.getNextLvExp(nLv) * 100);
	},
	//通过经验计算等级
	getLvByExp : function(nLv, nExp)
	{
		var nTotal = nLv * nLv + nLv + nExp + 0.25;
		nTotal = Math.floor(Math.sqrt(nTotal) - 0.5);
		return nTotal;
	},
	//剩余经验
	getResidueExp : function(nLvCur, nLvPre, nExp)
	{
		var nResidueExp = nLvPre * nLvPre + nLvPre + nExp - (nLvCur * nLvCur + nLvCur);
		return nResidueExp;
	},

	//获得combo
	getCombo : function(oPlayer)
	{
		var nOdds = (1 + oPlayer.getRealByIndex(AttributeType.Lucky) * 3 / oPlayer.m_nLv);
		var nCombo = 1;
		while(true)
		{
			if(nOdds > 0 && StaticMethod.getRandom(100) < nOdds)
			{
				nCombo++;
				nOdds -= 2;
			}else{
				break;
			}
		}
		return nCombo;
	},
	getComboAttack : function(oPlayer, nCombo)
	{
		var nAttack = oPlayer.getRealByIndex(AttributeType.Attack);
		var nCoe = (0.5 * (1 - Math.pow(0.5, nCombo-1))) / (1 - 0.5);
		nAttack += nAttack * nCoe;
		return nAttack;
	}
};