/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 14/12/31
 * Time: 下午5:15
 * To change this template use File | Settings | File Templates.
 */

var VeeLongPressButton = vee.Class.extend({

	/** @expose */
	m_spBtn : null,
	//
	m_nBtnType : 0,
	m_bTouched : false,
	m_bEnable : true,
	m_nOnceTime : 0,
	//
	m_oListener : null,

	//---------------------------------------------------------------------------------------------------------------------------
	//设置
	//设置代理
	m_oPressButtonDelegate : null,
	setDelegate : function(oDelegate)
	{
		this.m_oPressButtonDelegate = oDelegate;
	},
	//设置可用
	getBtnEnable : function()
	{
		return this.m_bEnable;
	},
	setBtnEnable : function(bEnable)
	{
		if(bEnable){
			this.m_spBtn.setOpacity(255);
		}else{
			this.m_spBtn.setOpacity(100);
		}
		this.m_bEnable = bEnable;
	},
	//---------------------------------------------------------------------------------------------------------------------------
	//初始化
	onCreate : function()
	{
		this.m_oListener = cc.EventListener.create({
			event: cc.EventListener.TOUCH_ONE_BY_ONE,
			swallowTouches: true,
			onTouchBegan: this.touchBegan,
			onTouchMoved: this.touchMoved,
			onTouchEnded: this.touchEnded,
			onTouchCancelled : this.touchCancelled
		});
		cc.eventManager.addListener(this.m_oListener, this.rootNode);
	},
	//移除
	onExit : function()
	{
		cc.log("btn onExit()");
		cc.eventManager.removeListener(this.m_oListener);
		this.m_oListener = null;
	},
	//---------------------------------------------------------------------------------------------------------------------------
	//类型
	setBtnType : function(nBtnType, strFileName)
	{
		//增减
		this.m_nBtnType = nBtnType;
		//修改图片
		if(strFileName){
			this.m_spBtn.setTexture(strFileName);
		}
	},
	//---------------------------------------------------------------------------------------------------------------------------
	//触控有效范围检测
	getButtonRect : function()
	{
		var rectBtn = this.m_spBtn.getTextureRect();
		rectBtn.x = -rectBtn.width/2;
		rectBtn.y = -rectBtn.height/2;
		return rectBtn;
	},
	containsTouchLocation : function(touch, event)
	{
		var noTarget = event.getCurrentTarget();
		var pointLocationInNode = noTarget.convertToNodeSpace(touch.getLocation());
		var rectBtn = this.getButtonRect();
		if (cc.rectContainsPoint(rectBtn, pointLocationInNode)) {
			return true;
		}
		return false;
	},
	//---------------------------------------------------------------------------------------------------------------------------
	//触控逻辑
	touchBegan : function(touch, event)
	{
		var noTarget = event.getCurrentTarget();
		if(noTarget.controller.m_bEnable
			&& !noTarget.controller.m_bTouched
			&& noTarget.controller.containsTouchLocation(touch, event))
		{
			//触控开始
			noTarget.controller.touchStart();
			//
			cc.log("touch began");
			return true;
		}
		return false;
	},
	touchMoved : function(touch, event)
	{
		var no_target = event.getCurrentTarget();
		if(no_target.controller.m_bTouched
			&& !no_target.controller.containsTouchLocation(touch, event))
		{
			//触控结束
			no_target.controller.touchOver();
			//
			cc.log("touch move out");
		}
	},
	touchEnded : function(touch, event)
	{
		var no_target = event.getCurrentTarget();
		if(no_target.controller.m_bTouched)
		{
			//触控结束
			no_target.controller.touchOver();
			//
			cc.log("touch end");
		}
	},
	touchCancelled : function(touch, event)
	{
		var no_target = event.getCurrentTarget();
		if(no_target.controller.m_bTouched)
		{
			//触控结束
			no_target.controller.touchOver();
			//
			cc.log("touch cancel");
		}
	},
	//触控逻辑
	touchStart : function()
	{
		//标记触控开始
		this.m_bTouched = true;
		//触控效果
		var action = cc.ScaleTo.create(0.03, 1.2);
		this.m_spBtn.runAction(action);
		//启动回调
		this.rootNode.schedule(this.startLongPress, 0.05);

		//调用回调
		if(this.m_oPressButtonDelegate){
			this.m_oPressButtonDelegate.pressButtonTouched(this.rootNode);
		}
	},
	touchOver : function()
	{
		//标记触控结束
		this.m_bTouched = false;
		//单击时间
		this.m_nOnceTime = 0;
		//效果
		var action = cc.ScaleTo.create(0.03, 1);
		this.m_spBtn.runAction(action);
		//停止回调
		this.rootNode.unschedule(this.startLongPress);

		cc.log("schedule stop");
	},
	//---------------------------------------------------------------------------------------------------------------------------
	//回调操作
	startLongPress : function(n_time)
	{
		//单击效果
		if(this.controller.m_nOnceTime < 0.1){
			this.controller.m_nOnceTime += n_time;
			return;
		}

		//
		if(!this.controller.m_bEnable)
		{
			this.controller.touchOver();
			return;
		}

		//
		if(this.controller.m_oPressButtonDelegate){
			this.controller.m_oPressButtonDelegate.pressButtonTouched(this);
		}
	}
});