/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 15/1/5
 * Time: 下午1:03
 * To change this template use File | Settings | File Templates.
 */

var noGameProgress = vee.Class.extend({

	//
	/** @expose */
	m_spProgressOut : null,
	/** @expose */
	m_spProgressBg : null,

	//
	m_noProgress : null,

	//
	_callback : null,
	setCallBack : function(f_callback)
	{
		this._callback = f_callback;
	},

	//初始化
	initGameProgress : function(strOutName, strBgName, strProName)
	{
		this.m_spProgressOut.setTexture(strOutName);
		this.m_spProgressBg.setTexture(strBgName);

		var spPro = cc.Sprite.create(strProName);
		this.m_noProgress = cc.ProgressTimer.create(spPro);
		this.m_noProgress.setBarChangeRate(cc.p(1, 0));
		this.m_noProgress.setMidpoint(cc.p(0, 0));
		this.m_noProgress.setType(cc.ProgressTimer.TYPE_BAR);
		this.rootNode.addChild(this.m_noProgress);
	},

	//变化
	setPercentage : function(nPercent)
	{
		this.m_noProgress.setPercentage(nPercent);
	},
	progressTo : function(nDuration, nPercent, nWaitTime)
	{
		var action1 = cc.ProgressTo.create(nDuration, nPercent);
		var action2 = cc.EaseExponentialOut.create(action1);
		var action3 = cc.CallFunc.create(this.progressToCallBack, this);
		if(nWaitTime > 0){
			var action = cc.DelayTime.create(nWaitTime);
			this.m_noProgress.runAction(cc.Sequence.create(action, action2, action3));
		}else{
			this.m_noProgress.runAction(cc.Sequence.create(action2, action3));
		}
	},
	progressFromTo : function(nDuration, nFromPercentage, nToPercentage, nWaitTime)
	{
		var action1 = cc.ProgressFromTo.create(nDuration, nFromPercentage, nToPercentage);
		var action2 = cc.EaseExponentialOut.create(action1);
		var action3 = cc.CallFunc.create(this.progressToCallBack, this);
		if(nWaitTime > 0){
			var action = cc.DelayTime.create(nWaitTime);
			this.m_noProgress.runAction(cc.Sequence.create(action, action2, action3));
		}else{
			this.m_noProgress.runAction(cc.Sequence.create(action2, action3));
		}
	},
	progressToCallBack : function()
	{
		if (this._callback) {
			this._callback(this);
		}
	},


	//
	m_aValues : null,
	m_aProgress : null,
	//
	_callback2 : null,
	setCallBack2 : function(f_callback)
	{
		this._callback2 = f_callback;
	},

	//初始化
	initGameProgressMuch : function(strOutName, strBgName, nTotalValue, nLayers)
	{
		this.m_spProgressOut.setTexture(strOutName);
		this.m_spProgressBg.setTexture(strBgName);

		this.m_aValues = new Array(0);
		this.m_aProgress = new Array(0);

		var nLayerValue = Math.floor(nTotalValue/nLayers);
		for(var i = 0; i < nLayers; i++)
		{
			var oProgressValue = null;
			if(i == 0){
				var nTempValue = nTotalValue - nLayerValue * (nLayers-1);
				oProgressValue = new ProgressValue(nTempValue, nTempValue);
			}else{
				oProgressValue = new ProgressValue(nLayerValue, nLayerValue);
			}

			var spPro = null;
			switch (i)
			{
				case 0:
				{
					spPro = cc.Sprite.create(res.img_fight_enemy_hp_png);
				}
					break;
				case 1:
				{
					spPro = cc.Sprite.create(res.img_fight_my_hp_png);
				}
				break;
				case 2:
				{
					spPro = cc.Sprite.create(res.img_fight_my_exp_png);
				}
				break;
			}
			var noProgress = cc.ProgressTimer.create(spPro);
			noProgress.setBarChangeRate(cc.p(1, 0));
			noProgress.setMidpoint(cc.p(0, 0));
			noProgress.setType(cc.ProgressTimer.TYPE_BAR);
			noProgress.setPercentage(100);
			this.rootNode.addChild(noProgress);

			this.m_aValues.push(oProgressValue);
			this.m_aProgress.push(noProgress);
		}
	},
	//
	setProgress : function(nValue)
	{
		for(var i = this.m_aValues.length-1; i >= 0; i--)
		{
			var oProgressValue = this.m_aValues[i];
			if(nValue > oProgressValue.m_nCurrentValue){
				nValue -= oProgressValue.m_nCurrentValue;
				oProgressValue.m_nCurrentValue = 0;
			}else{
				oProgressValue.m_nCurrentValue -= nValue;
				break;
			}
		}
		var oProgressValue = this.m_aValues[this.m_aValues.length-1];
		var nPercent = Math.floor(oProgressValue.m_nCurrentValue/oProgressValue.m_nMaxValue*100);
		this.setCallBack(this.setProgressCallback.bind(this));
		this.m_noProgress = this.m_aProgress[this.m_aValues.length-1];
		this.progressTo(0.5, nPercent, 0);
	},
	setProgressCallback : function()
	{
		var oProgressValue = this.m_aValues[this.m_aValues.length-1];
		if(oProgressValue.m_nCurrentValue == 0)
		{
			this.m_aValues.pop();
			var noProgress = this.m_aProgress.pop();
			noProgress.removeFromParent(true);

			if(this.m_aValues.length >= 1)
			{
				oProgressValue = this.m_aValues[this.m_aValues.length-1];
				this.m_noProgress = this.m_aProgress[this.m_aValues.length-1];
				if(oProgressValue.m_nCurrentValue < oProgressValue.m_nMaxValue)
				{
					var nPercent = Math.floor(oProgressValue.m_nCurrentValue/oProgressValue.m_nMaxValue*100);
					this.progressTo(0.5, nPercent, 0);
					return;
				}
			}
		}

		//
		this._callback2(this);
	}

});
cc.BuilderReader.registerController("noGameProgress", noGameProgress);

noGameProgress.create = function(strOutName, strBgName, strProName){
	var node = cc.BuilderReader.load(res.noGameProgress_ccbi);
	node.controller.initGameProgress(strOutName, strBgName, strProName)
	return node;
}
noGameProgress.createMuch = function(strOutName, strBgName, nTotalValue, nLayers){
	var node = cc.BuilderReader.load(res.noGameProgress_ccbi);
	node.controller.initGameProgressMuch(strOutName, strBgName, nTotalValue, nLayers)
	return node;
}


function ProgressValue(nMax, nCurrent)
{
	this.m_nMaxValue = nMax;
	this.m_nCurrentValue = nCurrent;
}


/*
var noProgress = cc.Node.extend({
	
	//
	m_noProgress : null,
	//
	m_fCallBack : null,
	//
	m_nTotal : 0,
	m_nCur : 0,
	
	//------------------------------------------------------------------------------------------------------------
	//初始化
	initProgress : function(strProName, nCur, nTotal)
	{
		//
		this.m_nCur = nCur > 0 ? nCur : 0;
		this.m_nTotal = nTotal;
		//
		this.m_noProgress = this.createCPro(strProName);
		this.m_noProgress.setPercentage(Math.floor(nCur / nTotal * 100));
		this.addChild(this.m_noProgress);
	},
	//创建进度条
	createCPro : function(strProName)
	{
		var spPro = cc.Sprite.create(strProName);
		var noProgress = cc.ProgressTimer.create(spPro);
		noProgress.setBarChangeRate(cc.p(1, 0));
		noProgress.setMidpoint(cc.p(0, 0));
		noProgress.setType(cc.ProgressTimer.TYPE_BAR);
		return noProgress;
	},
	//设置回调
	setCallBack : function(fCallBack)
	{
		this.m_fCallBack = fCallBack;
	},
	//----------------------------------------------------------------------------------------
	//
	progressTo : function(nDuration, nChange, nWaitTime)
	{
		//
		this.m_nCur = this.m_nTotal - nChange;
		var nPercent = Math.floor(this.m_nCur / this.m_nTotal * 100);
		//
		var action1 = cc.ProgressTo.create(nDuration, nPercent);
		var action2 = cc.EaseExponentialOut.create(action1);
		var action3 = cc.CallFunc.create(this.progressToCallBack, this);
		//
		if(nWaitTime > 0){
			var action = cc.DelayTime.create(nWaitTime);
			this.m_noProgress.runAction(cc.Sequence.create(action, action2, action3));
		}else{
			this.m_noProgress.runAction(cc.Sequence.create(action2, action3));
		}
	},
	//
	progressFromTo : function(nDuration, nChange, nWaitTime)
	{
		//
		var nFromPercentage = Math.floor(this.m_nCur / this.m_nTotal * 100);
		this.m_nCur = this.m_nTotal - nChange;
		var nToPercentage = Math.floor(this.m_nCur / this.m_nTotal * 100);
		//
		var action1 = cc.ProgressFromTo.create(nDuration, nFromPercentage, nToPercentage);
		var action2 = cc.EaseExponentialOut.create(action1);
		var action3 = cc.CallFunc.create(this.progressToCallBack, this);
		//
		if(nWaitTime > 0){
			var action = cc.DelayTime.create(nWaitTime);
			this.m_noProgress.runAction(cc.Sequence.create(action, action2, action3));
		}else{
			this.m_noProgress.runAction(cc.Sequence.create(action2, action3));
		}
	},
	//
	progressToCallBack : function()
	{
		if (this._callback) {
			this._callback(this);
		}
	},
	
	//
	getSurplus : function(nChange)
	{
		return this.m_nCur - nChange;
	}
});
noProgress.create = function(strProName, nCur, nTotal){

};

var noProgressL = noProgress.extend({
	
	//
	m_aPros : null,
	//
	m_nIndex : 1,
	//
	m_nChange : 0, 
	
	//
	m_fCallBack2 : null,
	
	initProgress : function(nLayers, aImages, nCur, nTotal)
	{
		//
		this.m_nCur = nCur;
		this.m_nTotal = nTotal;
		//
		var nLayerValue = Math.floor(nTotal/nLayers);
		for(var i = 0; i < nLayers; i++)
		{
			var noTempPro = null;
			if(i == 0){
				var nTempValue = nTotal - nLayerValue * (nLayers-1);
				noTempPro = noProgress.create(aImages[i], 
						nCur > nTempValue ? nTempValue : nCur, nTempValue);
			}else{
				noTempPro = noProgress.create(aImages[i], 
						nCur > nTempValue ? nTempValue : nCur, nTempValue);
			}
			//
			this.m_aPros[i] = noTempPro;
			this.addChild(noTempPro, i+1);
			//
			nCur -= nTempValue;
		}
		//
		this.m_noProgress = this.m_aPros[nLayers-1];
		this.m_nIndex = nLayers;
	},
	//----------------------------------------------------------------------------------------
	//
	progressTo : function(nDuration, nChange, nWaitTime)
	{
		//
		this.m_nCur = this.m_nTotal - nChange;
		
		//
		var nValue = this.m_aPros[i].getSurplus(nChange);
		for(var i = this.m_nIndex; i >= 0; i--)
		{
			var nValue = this.m_aPros[i].getSurplus(nChange);
			if(nValue < 0)
			{
				
			}
		}
	}
});
*/