/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 15/1/12
 * Time: 上午11:23
 * To change this template use File | Settings | File Templates.
 */

var PopupNodeType =
{
	TouchHint : 1,
	TouchHintWithIcon : 2,
	BtnHint : 3,
	BtnHintWithIcon : 4
}

var noPopupNode = vee.Class.extend({

	/** @expose */
	m_lbHintValue : null,
	/** @expose */
	m_lbHintValue2 : null,
	/** @expose */
	m_spHintIcon : null,
	/** @expose */
	m_btnConfirm : null,
	/** @expose */
	m_btnCancel : null,

	/** @expose */
	m_noCoin : null,
	/** @expose */
	m_lbCoin : null,
	/** @expose */
	m_spCoin : null,

	//触控控制
	m_bTouch : false,

	//内容
	m_oContent : null,
	//回调
	m_fConfirmCallback : null,
	m_fCancelCallback : null,

	//---------------------------------------------------------------------------------------------------------------------------
	//设置

	//内容
	setContent1 : function(strContext)
	{
		this.m_lbHintValue.setString(strContext);
	},
	setContent2 : function(strContext)
	{
		this.m_lbHintValue2.setString(strContext);
	},
	//icon
	setHintIcon : function(strIconName)
	{
		this.m_spHintIcon.setTexture("res/" + strIconName);
		this.m_spHintIcon.getTexture().setAliasTexParameters();
	},
	//回调设置
	setConfirmCallback : function(fCallback)
	{
		this.m_fConfirmCallback = fCallback;
	},
	setCancelCallback : function(fCallback)
	{
		this.m_fCancelCallback = fCallback;
	},
	//设置可用
	setConfirmEnabled : function(bEnable)
	{
		this.m_btnConfirm.setEnabled(bEnable);
	},
	//回传内容
	setCallbackContent : function(oContent)
	{
		this.m_oContent = oContent;
	},
	//金钱显示
	setCoin : function(bVisible, bEnough, nCoin, strIcon)
	{
		if(bVisible)
		{
			this.m_lbCoin.setString(nCoin);
			if(!bEnough){
				this.m_lbCoin.setColor(cc.RED);
			}
			if(strIcon){
				this.m_spCoin.setTexture(strIcon);
			}
		}
		this.m_noCoin.setVisible(bVisible);
	},
	//替换按钮图片
	seConfirmSprite : function(strNormal, strDisable, oRect)
	{
		if (strNormal && strDisable)
		{
			var spBtn = cc.Scale9Sprite.create(strNormal, oRect);
			this.m_btnConfirm.setBackgroundSpriteForState(spBtn, cc.CONTROL_STATE_NORMAL);
			spBtn = cc.Scale9Sprite.create(strDisable, oRect);
			this.m_btnConfirm.setBackgroundSpriteForState(spBtn, cc.CONTROL_STATE_DISABLED);
		}
	},
	seCancelSprite : function(strNormal, strDisable, oRect)
	{
		if (strNormal && strDisable)
		{
			var spBtn = cc.Scale9Sprite.create(strNormal, oRect);
			this.m_btnCancel.setBackgroundSpriteForState(spBtn, cc.CONTROL_STATE_NORMAL);
			spBtn = cc.Scale9Sprite.create(strDisable, oRect);
			this.m_btnCancel.setBackgroundSpriteForState(spBtn, cc.CONTROL_STATE_DISABLED);
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//初始化

	//仅显示提示框
	initTouchHint : function(strContext, fConfirm)
	{
		this.m_bTouch = true;

		//初始化触控层
		var lyTouchLayer = cc.LayerColor.create(cc.color(0,0,0,10), 0, 0);
		vee.GestureController.registerController(lyTouchLayer, this);
		this.rootNode.addChild(lyTouchLayer);

		//内容
		this.setContent1(strContext);
		//回调
		this.setConfirmCallback(fConfirm);

		//声音
		vee.Audio.playEffect(res.sfx_menu_openwindow_mp3, false);
	},

	//显示提示加icon
	initTouchHintWithIcon : function(strContext1, strContext2, fConfirm, strIconName, oContent)
	{
		this.initTouchHint(strContext1, fConfirm);
		//内容2
		this.setContent2(strContext2);
		//回调内容
		this.setCallbackContent(oContent);
		//icon
		this.setHintIcon(strIconName);

	},

	//按钮提示
	initBtnHint : function(strContext1, strContext2, bShowContext2, bConfirm, fConfirm, fCancel, strMoneyIcon, bEnough)
	{
		//触控控制
		this.m_bTouch = true;

		//内容
		this.setContent1(strContext1);
		if(bShowContext2){
			this.setCoin(true, bEnough, strContext2, strMoneyIcon);
		}else{
			this.setCoin(false, false, strContext2, strMoneyIcon);
		}

		//回调
		this.setConfirmCallback(fConfirm);
		this.setCancelCallback(fCancel);
		//可用
		this.setConfirmEnabled(bConfirm);

		//声音
		vee.Audio.playEffect(res.sfx_menu_openwindow_mp3, false);
	},

	//
	initBtnHintWithIcon : function(strContext1, strContext2, bShowContext2, bConfirm, fConfirm, fCancel, strIconName, oContent, strMoneyIcon, bEnough)
	{
		this.initBtnHint(strContext1, strContext2, bShowContext2, bConfirm, fConfirm, fCancel, strMoneyIcon, bEnough);
		//
		this.setHintIcon(strIconName);
		//回调内容
		this.setCallbackContent(oContent);
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//按钮回调

	/** @expose */
	onConfirm : function()
	{
		//触控控制
		if(!this.m_bTouch){
			return;
		}
		this.m_bTouch = false;

		//--------------------------------------------------------------

		//效果
		this.playAnimate("close", this.onCloseCallback.bind(this));

		//回调
		if(this.m_fConfirmCallback){
			this.m_fConfirmCallback(this.m_oContent);
		}

		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);
	},
	/** @expose */
	onCancel : function()
	{
		//触控控制
		if(!this.m_bTouch){
			return;
		}
		this.m_bTouch = false;

		//--------------------------------------------------------------

		//效果
		this.playAnimate("close", this.onCloseCallback.bind(this), false);

		//回调
		if(this.m_fCancelCallback){
			this.m_fCancelCallback(this.m_oContent);
		}

		//声音
		vee.Audio.playEffect(res.sfx_menu_closewindow_mp3, false);
	},
	//触控
	onGestureLeave : function(context)
	{
		if(!this.m_bTouch){
			return;
		}
		this.m_bTouch = false;

		//--------------------------------------------------------------

		//效果
		this.playAnimate("close", this.onCloseCallback.bind(this), false);

		//回调
		if(this.m_fConfirmCallback){
			this.m_fConfirmCallback(this.m_oContent);
		}

		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);
	},
	onCloseCallback : function()
	{
		//关闭过关弹出
		vee.PopMgr.closeLayerByCtl(this);
	}
});
cc.BuilderReader.registerController("noPopupNode", noPopupNode);

//创建方法
noPopupNode.createTouchHint = function(strContext, fConfirm)
{
	var node = cc.BuilderReader.load(res.vAlertboxMessage_ccbi);
	node.controller.initTouchHint(strContext, fConfirm);
	return node;
};
noPopupNode.createTouchHintWithIcon = function(strContext1, strContext2, fConfirm, strIconName, oContent)
{
	var node = cc.BuilderReader.load(res.vAlertboxGet_ccbi);
	node.controller.initTouchHintWithIcon(strContext1, strContext2, fConfirm, strIconName, oContent);
	return node;
};
noPopupNode.createBtnHint = function(strContext1, strContext2, bShowContext2, bConfirm, fConfirm, fCancel, strMoneyIcon, bEnough)
{
	var node = cc.BuilderReader.load(res.vAlertboxMy_ccbi);
	node.controller.initBtnHint(strContext1, strContext2, bShowContext2, bConfirm, fConfirm, fCancel, strMoneyIcon, bEnough);
	return node;
};
noPopupNode.createBtnHintWithIcon = function(strContext1, strContext2, bShowContext2, bConfirm, fConfirm, fCancel, strIconName, oContent, strMoneyIcon, bEnough)
{
	var node = cc.BuilderReader.load(res.vAlertboxProps_ccbi);
	node.controller.initBtnHintWithIcon(strContext1, strContext2, bShowContext2, bConfirm, fConfirm, fCancel, strIconName, oContent, strMoneyIcon, bEnough);
	return node;
};