/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 14/12/26
 * Time: 下午5:08
 * To change this template use File | Settings | File Templates.
 */

var lyFightLayer = vee.Class.extend({

	//下部
	/** @expose */
	m_noEnemyHpLine : null,
	/** @expose */
	m_noPlayerHpLine : null,
	/** @expose */
	m_noPlayerLvLine : null,
	/** @expose */
	m_lbLvNumber : null,
	/** @expose */
	m_lbName : null,
	/** @expose */
	m_noRed : null,
	/** @expose */
	m_lbHurt : null,

	//-------------------------------------------
	//步数
	/** @expose */
	m_lbChangeStep : null,
	/** @expose */
	m_lbLoseStep : null,
	//飞字效果
	/** @expose */
	m_sbnLv : null,

	//-------------------------------------------
	//敌人
	m_noEnemy : null,

	//-------------------------------------------
	//使用血瓶标记
	m_bUsePotion : false,
	//父类引用
	m_lyGameLayer : null,
	//开始战斗
	m_bIsFight : false,

	//---------------------------------------------------------------------------------------------------------------------------
	//属性设置
	setGameLayer : function(lyGameLayer)
	{
		this.m_lyGameLayer = lyGameLayer;
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//初始化
	setFightLayer : function(noEnemy)
	{
		//初始化触控层
		var lyTouchLayer = cc.LayerColor.create(cc.color(0,0,0,10), 0, 0);
		vee.GestureController.registerController(lyTouchLayer, this);
		this.rootNode.addChild(lyTouchLayer);

		//----------------------------------------------------------

		//敌人血量设定
		this.m_noEnemyHpLine.controller.initGameProgress(res.img_fight_enemy_hp_on_png, 
				res.img_fight_enemy_hp_bg_png, res.img_fight_enemy_hp_png);
		this.m_noEnemyHpLine.controller.setPercentage(100);
		this.m_noEnemyHpLine.controller.setCallBack(this.subHpCallBack.bind(this));
		this.m_noEnemyHpLine.setPosition(cc.p(0, -300));
		//玩家血量设定
		this.m_noPlayerHpLine.controller.initGameProgress(res.img_fight_my_hp_on_png, 
				res.img_fight_my_hp_bg_png, res.img_fight_my_hp_png);
		this.m_noPlayerHpLine.controller.setPercentage(100);
		this.m_noPlayerHpLine.controller.setCallBack(this.subHpCallBack.bind(this));
		this.m_noPlayerHpLine.setPosition(cc.p(0, -300));

		//设定敌人
		this.m_noEnemy = noEnemy;
		//敌人名字
		this.m_lbName.setString(FightManager.getEnemy().m_strName);

		//开始效果
		this.playAnimate("BeforeFight", null, false, 0.3);
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//战斗逻辑
	//战斗开始
	onStartFight : function(pSender)
	{
		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);
		//血瓶可用
		if(GameManager.checkSpecialEquip(EqupSp.Potion)){
			
		}
		//开始效果
		this.playAnimate("StartFight", this.gameFight.bind(this), false, 0);
	},
	//战斗逻辑
	gameFight : function()
	{
		//计算逻辑
		FightManager.gameFight();
		//-------------------------------------------------------------------
		//得到结果
		var oResult = FightManager.getFightResult();
		//判断攻击对象
		if(oResult.m_nFightRole == 1)
		{
			//伤害数字
			this.m_noEnemy.controller.setAttackHp(oResult.m_nFightHp);
			//判断暴击
			if(oResult.m_nCombo > 1)
			{
				//暴击数字
				this.m_noEnemy.controller.setCombo(oResult.m_nCombo);
				//暴击效果
				switch (oResult.m_nCombo)
				{
					case 2:
					{
						this.m_noEnemy.controller.playAnimate("ComboAttack", null, true, 0);
						this.m_noEnemyHpLine.controller.progressTo(0.5, oResult.m_nHpPercent, 0.2);
					}
						break;
					case 3:
					{
						this.m_noEnemy.controller.playAnimate("ComboAttack2", null, true, 0);
						this.m_noEnemyHpLine.controller.progressTo(0.8, oResult.m_nHpPercent, 0.2);
					}
						break;
					default :
					{
						this.m_noEnemy.controller.playAnimate("ComboAttack3", null, true, 0);
						this.m_noEnemyHpLine.controller.progressTo(1.8, oResult.m_nHpPercent, 0.2);
					}
				}
				//声音
				vee.Audio.playEffect(res.ingame_event_combo_mp3, false);
			}
			else
			{
				//攻击效果
				this.m_noEnemy.controller.playAnimate("AttackEnemy", null, true, 0);
				//移动血条
				this.m_noEnemyHpLine.controller.progressTo(0.5, oResult.m_nHpPercent, 0.2);
				//声音
				vee.Audio.playEffect(res.inGame_event_attack_mp3, false);
			}
		}
		else
		{
			//伤害数字
			this.m_lbHurt.setString(oResult.m_nFightHp);
			//被攻击晃动效果
			this.m_lyGameLayer.attackPlayer();
			//伤害效果
			this.playAnimate("AttackPlayer", this.hideRed.bind(this), false, 0);
			//判断先制攻击
			if(oResult.m_bFirstAttack)
			{
				//被攻击效果
				this.m_noEnemy.controller.playAnimate("FirstAttack", null, true, 0);
				//声音
				vee.Audio.playEffect(res.inGame_event_firstAttack_mp3, false);
			}
			else
			{
				//被攻击效果
				this.m_noEnemy.controller.playAnimate("AttackPlayer", null, true, 0);
				//声音
				vee.Audio.playEffect(res.inGame_event_monsterAttack_mp3, false);
			}
			//移动血条
			this.m_noPlayerHpLine.controller.progressTo(0.5, oResult.m_nHpPercent, 0.2);
			//攻击比重
			if(oResult.m_nFightPercent >= 25){
				this.m_noRed.setVisible(true);
			}
		}
	},
	//每回合回调
	subHpCallBack : function()
	{
		//得到结果
		var oResult = FightManager.getFightResult();
		//判断结束
		if(oResult.m_nFightOver != 0)
		{
			//血瓶可用
			if(oResult.m_nFightOver < 0 && GameManager.checkSpecialEquip(EqupSp.Potion))
			{
				//使用血瓶
				this.usePotion();
			}
			else
			{
				//战斗结束逻辑
				this.fightOver();
			}
		}
		else
		{
			//继续战斗
			this.gameFight();
		}
	},
	//使用血瓶
	usePotion : function()
	{
		//标记使用血瓶
		this.m_bUsePotion = true
		//移除血瓶
		GameManager.removeSpecialEquip(EqupSp.Potion, false);
		//回血
		FightManager.getPlayer().revertHP();
		//回血效果
		this.m_noPlayerHpLine.controller.progressTo(0.5, 100, 0.2);
		//继续战斗
		var oResult = FightManager.getFightResult();
		oResult.m_nFightOver = 0;
		//声音
		vee.Audio.playEffect(res.inGame_event_potionDrink_mp3, false);
	},
	//隐藏效果
	hideRed : function()
	{
		this.m_noRed.setVisible(false);
	},
	//---------------------------------------------------------------------------------------------------------------------------
	//战斗结束
	fightOver : function()
	{
		//计算步数
		FightManager.computerStep();
		//-------------------------------------------------------------------
		//得到战斗结果
		var oResult = FightManager.getFightResult();
		//判断胜负
		if(oResult.m_nFightOver > 0)
		{
			//计算获胜结果
			FightManager.computerExpAndMoney();
			//-------------------------------------------------------------------
			//修改步数
			this.m_lbChangeStep.setString("Big Win Bonus: +" + oResult.m_nChangeStep + " Turns");
			//胜利效果
			this.m_noEnemy.controller.playAnimate("DeadNomal", this.removeEnemy.bind(this), true, 0);
			//胜利效果
			this.playAnimate("DeadNomal", this.fightWin1.bind(this), false, 0);
			//声音
			vee.Audio.playEffect(res.inGame_event_monsterDie_mp3, false);
		}
		else if(oResult.m_nFightOver < 0)
		{
			//修改步数
			this.m_lbLoseStep.setString("Penalty: " + oResult.m_nChangeStep + " turns");
			//输了效果
			this.playAnimate("FightLose", this.fightLose.bind(this), false);
		}
	},
	//---------------------------------------------------------------------------------------------------------------------------
	//胜利逻辑
	//移除敌人
	removeEnemy : function()
	{
		//删除敌人node
		this.m_noEnemy.removeFromParent();
		//生成宝箱
		var oResult = FightManager.getFightResult();
		this.m_lyGameLayer.createChest(oResult.m_nFightOver > 0);
	},
	//胜利
	fightWin1 : function()
	{
		//胜利结果
		var oWinResult = FightManager.getWinResult();
		//设置经验条
		this.m_noPlayerLvLine.controller.initGameProgress(res.img_fight_my_hp_on_png, res.img_fight_my_hp_bg_png, res.img_fight_my_exp_png);
		this.m_noPlayerLvLine.controller.setPercentage(oWinResult.m_nExpPercent);
		this.m_noPlayerLvLine.controller.setCallBack(this.playerLvUpEnd.bind(this));
		//等级显示
		this.m_lbLvNumber.setString(FightManager.getPlayer().m_nLv);

		//计算升级
		FightManager.computerMaxLvUp();

		//金币效果
		this.m_lyGameLayer.jumpCoin();
		//胜利效果
		this.playAnimate("FightWin", this.fightWin2.bind(this), false, 0);
	},
	//胜利
	fightWin2 : function()
	{
		//修改金钱步数
		var oWinResult = FightManager.getWinResult();
		var oFightResult = FightManager.getFightResult();
		GameManager.m_oTowerData.m_nTowerMoney += oWinResult.m_nCoin;
		//this.m_lyGameLayer.setDisplayMoney(oWinResult.m_nCoin);
		this.m_lyGameLayer.setDisplayStep(oFightResult.m_nChangeStep);
		//升级循环
		this.playerLvUp();
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//计算升级
	playerLvUp : function()
	{
		//获取结果
		var oWinResult = FightManager.getWinResult();
		var oPlayerRole = FightManager.getPlayer();
		//计算升级
		if(oPlayerRole.m_nLv >= oWinResult.m_nLvCur)
		{
			//升级结束
			this.m_noPlayerLvLine.controller.setCallBack(this.showWinResult.bind(this));
			this.m_noPlayerLvLine.controller.progressFromTo(0.1, 0, oWinResult.m_nExpPercent, 0);
		}
		else
		{
			//升级循环
			this.m_noPlayerLvLine.controller.progressFromTo(0.1, 0, 100, 0);
			//累加等级
			oPlayerRole.m_nLv += oWinResult.m_nLvPlus;
			if(oPlayerRole.m_nLv > oWinResult.m_nLvCur){
				oPlayerRole.m_nLv = oWinResult.m_nLvCur
			}
			//飞字效果
			this.flyLv();
			//声音
			vee.Audio.playEffect(res.inGame_event_levelUp_mp3, false);
		}
	},
	//每升一级回调
	playerLvUpEnd : function()
	{
		var oPlayerRole = FightManager.getPlayer();
		//等级显示效果
		this.m_lbLvNumber.setString(oPlayerRole.m_nLv);
		var action = cc.ScaleTo.create(0.05, 1.5);
		var action2 = cc.ScaleTo.create(0.05, 1);
		this.m_lbLvNumber.runAction(cc.Sequence.create(action, action2));

		//继续计算升级
		this.playerLvUp();
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//显示过关数据
	showWinResult : function()
	{
		//结果页面
		if(this.m_lyGameLayer){
			this.m_lyGameLayer.showWinResult();
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//效果

	//升级飞字效果
	flyLv : function()
	{
		var spLv = cc.Sprite.createWithSpriteFrameName("img_win_level_light.png");
		this.m_sbnLv.addChild(spLv);
		//位置
		spLv.setPosition(cc.p(0, 0));
		spLv.setScale(0.5);

		var nTime = (StaticMethod.getRandom(10) + 10) /10;
		var action1 = cc.ScaleTo.create(nTime, 1.1);
		var action2 = cc.FadeOut.create(nTime * 2);
		//
		var nAngle = StaticMethod.getRandom(12)*10 - 60;
		var nAngle2 = cc.degreesToRadians(nAngle);
		var nLength = StaticMethod.getRandom(70) + 70;
		var nX = Math.sin(nAngle2)*nLength;
		var ny = Math.cos(nAngle2)*nLength;
		var pointTarget = cc.p(nX, ny);
		spLv.setRotation(nAngle);
		var action3 = cc.MoveBy.create(nTime, pointTarget);
		//
		action1 = cc.EaseExponentialOut(action1);
		action2 = cc.EaseExponentialOut(action2);
		action3 = cc.EaseExponentialOut(action3);
		var action4 = cc.spawn(action1, action3);
		var action5 = cc.CallFunc.create(this.flyLvCallback, spLv);
		var action6 = cc.sequence(action2, action5);
		spLv.runAction(action4);
		spLv.runAction(action6);
	},
	//回调
	flyLvCallback : function(pSender)
	{
		pSender.removeFromParent(true);
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//失败逻辑

	//输了
	fightLose : function()
	{
		//删除敌人node
		this.removeEnemy();

		//修改显示步数
		var oFightResult = FightManager.getFightResult();
		this.m_lyGameLayer.setDisplayStep(oFightResult.m_nChangeStep);

		//继续游戏效果
		this.playAnimate("GameRestart", this.gameRestart.bind(this), false);
	},
	//继续游戏
	gameRestart : function()
	{
		//关闭战斗页
		this.m_lyGameLayer.fightOver();
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//按钮回调

	//触控
	onGestureLeave : function(context)
	{
		if(this.m_bIsFight){
			return;
		}
		this.m_bIsFight = true;

		//--------------------------------------------------------------

		this.onStartFight(null);
	},

	//使用血瓶
	/** @expose */
	usePotion1 : function()
	{
		if(this.m_bUsePotion){
			return;
		}
		//标记使用血瓶
		this.m_bUsePotion = true;
		//声音
		vee.Audio.playEffect(res.sfx_menu_pointClick_mp3, false);
	}
});
cc.BuilderReader.registerController("lyFightLayer", lyFightLayer);



var eleEnemy = vee.Class.extend({

	/** @expose */
	m_spEnemy : null,
	/** @expose */
	m_lbAttackHp : null,
	/** @expose */
	m_lbCombo : null,

	//---------------------------------------------------------------------------------------------------------------------------
	//设置方法
	setAttackHp : function(nHP)
	{
		this.m_lbAttackHp.setString(nHP);
	},
	setCombo : function(nCombo)
	{
		this.m_lbCombo.setString(nCombo);
	},
	setEnemyImage : function(strIcon)
	{
		this.m_spEnemy.setTexture("res/" + strIcon);
	}
});
cc.BuilderReader.registerController("eleEnemy", eleEnemy);