/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 15/1/4
 * Time: 下午1:14
 * To change this template use File | Settings | File Templates.
 */

var lyStatsBoost = vee.Class.extend({

	/** @expose */
	m_noBar : null,
	/** @expose */
	m_lbBoostNumber : null,
	/** @expose */
	m_btnClose : null,

	//数值
	m_oRolePro : null,
	m_nBoostNumber : 0,
	m_nCurrentNumber : 0,
	m_nChangeNumber : 1,

	//中介对象
	m_lyGameLayer : null,

	//---------------------------------------------------------------------------------------------------------------------------

	//设置回调
	setGameLayer : function(lyGameLayer)
	{
		this.m_lyGameLayer = lyGameLayer;
	},

	//---------------------------------------------------------------------------------------------------------------------------

	//初始化
	onLoaded : function()
	{
		//
		this.playAnimate("open");

		//声音
		vee.Audio.playEffect(res.sfx_menu_openwindow_mp3, false);

		//战斗数据
		this.m_nBoostNumber = FightManager.getWinResult().m_nBoost;

		//获得点数
		this.m_nCurrentNumber = this.m_nBoostNumber;
		this.m_lbBoostNumber.setString(this.m_nBoostNumber);

		//变化值
		var nNumber = Math.floor(this.m_nBoostNumber/100 * 3);
		this.m_nChangeNumber = nNumber < 1 ? 1 : nNumber;

		//生成属性对象
		this.m_oRolePro = new EquipRole();

		//设置按钮可用
		this.setCellBar();

		//结束按钮
		this.m_btnClose.setEnabled(false);
	},
	//初始化
	setCellBar : function()
	{
		var oPlayerRole = FightManager.getPlayer();
		for(var i = 0; i < 5; i++)
		{
			var noTempCell = this.m_noBar.getChildByTag(i+1);
			noTempCell.controller.onLoaded();
			noTempCell.controller.setCellHeadAndBoosNumber(i+1, oPlayerRole.getRealByIndex(i));
			noTempCell.controller.setBoostCellDelegate(this, this.m_nChangeNumber);
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------

	//修改数值
	setChangeValue : function(nType, nValue)
	{
		//判断按钮可用
		if(this.m_nCurrentNumber == 0 && nType < 0)
		{
			//增加按钮打开
			this.setAllCellBtnDisable(1, true);
			//结束按钮关闭
			this.m_btnClose.setEnabled(false);
		}

		//变化属性
		var nChange = -1;
		//修改属性值
		if(nType > 0)
		{
			if(this.m_nCurrentNumber < this.m_nChangeNumber)
			{
				this.m_nCurrentNumber = 0;
				nChange = this.m_nChangeNumber - this.m_nCurrentNumber;
			}
			else
			{
				this.m_nCurrentNumber -= this.m_nChangeNumber;
				nChange = this.m_nChangeNumber;
			}
		}
		else
		{
			this.m_nCurrentNumber += nValue;
		}

		//修改总数
		this.m_lbBoostNumber.setString(this.m_nCurrentNumber);

		//判断按钮可用
		if(this.m_nCurrentNumber == 0)
		{
			//增加按钮打开关闭
			this.setAllCellBtnDisable(1, false);
			//结束按钮打开
			this.m_btnClose.setEnabled(true);
		}

		return nChange;
	},
	//计算属性
	setBoostCellById : function(nValue, nId)
	{
		//基本属性
		this.m_oRolePro.setBaseByIndex(nId, nValue);
		//计算属性
		var nValue2 = GameFormula.computerFightByBase(nId, this.m_oRolePro.getBaseByIndex(nId));
		this.m_oRolePro.setFightByIndex(nId, nValue2);

		return this.m_oRolePro.getRealByIndex(nId);
	},

	//自动分配点数逻辑
	setPropertyAuto : function()
	{
		if(this.m_nCurrentNumber > 5)
		{
			var nAverage = Math.floor(this.m_nCurrentNumber / 5);
			for(var i = 0; i < 5; i++)
			{
				this.m_oRolePro.setBaseByIndex(i, nAverage);
			}
		}
		for(var i = 0; i < this.m_nCurrentNumber % 5; i++)
		{
			this.m_oRolePro.setBaseByIndex(i+1, this.m_oRolePro.getBaseByIndex(i+1) + 1);
		}
		//计算属性
		FightManager.computerRoleFight(this.m_oRolePro);
		//点数归零
		this.m_nCurrentNumber = 0;
	},
	//设置所有按钮
	setAllCellBtnDisable : function(nType, bEnable)
	{
		for(var i = 0; i < 5; i++)
		{
			var noTempCell = this.m_noBar.getChildByTag(i+1);
			noTempCell.controller.setCellBtnDisable(nType, bEnable);
		}
	},
	//数量显示
	setAllCellNUmber : function()
	{
		for(var i = 0; i < 5; i++)
		{
			var noTempCell = this.m_noBar.getChildByTag(i+1);
			noTempCell.controller.setBaseValue(this.m_oRolePro.getBaseByIndex(i));
			noTempCell.controller.setForceValue(this.m_oRolePro.getRealByIndex(i));
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//按钮回调

	//自动分配
	/** @expose */
	autoLvUpRoleProperty : function()
	{
		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);

		//回复总数
		this.m_nCurrentNumber = this.m_nBoostNumber;
		//回复设置数
		this.m_oRolePro.resetBase();
		//计算平均
		this.setPropertyAuto();
		//数量显示
		this.setAllCellNUmber();
		//修改总数
		this.m_lbBoostNumber.setString(this.m_nCurrentNumber);
		//设置禁用
		this.setAllCellBtnDisable(1, false);
		this.setAllCellBtnDisable(-1, true);
		//结束按钮
		this.m_btnClose.setEnabled(true);
	},
	//重置分配
	/** @expose */
	resetLvUpRoleProperty : function()
	{
		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);

		//回复总数
		this.m_nCurrentNumber = this.m_nBoostNumber;
		//回复设置数
		this.m_oRolePro.resetBase();
		FightManager.computerRoleFight(this.m_oRolePro);
		//回复数量显示
		this.setAllCellNUmber();
		//修改总数
		this.m_lbBoostNumber.setString(this.m_nCurrentNumber);
		//设置禁用
		this.setAllCellBtnDisable(1, true);
		this.setAllCellBtnDisable(-1, false);
		//结束按钮
		this.m_btnClose.setEnabled(false);
	},

	//关闭
	/** @expose */
	closeLayer : function(pSender)
	{
		//得到玩家
		var oPlayerRole = FightManager.getPlayer();
		//跟新点数
		for(var i = 0; i < 5; i++){
			oPlayerRole.setBaseByIndex(i, this.m_oRolePro.getBaseByIndex(i) + oPlayerRole.getBaseByIndex(i));
		}
		//更新点数
		FightManager.computerRoleFightWithDefault(oPlayerRole);

		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);
		//
		this.playAnimate("close", this.onCloseCallback.bind(this));

		//中介方法 结束战斗
		if(this.m_lyGameLayer){
			this.m_lyGameLayer.fightOver();
		}
	},
	onCloseCallback : function()
	{
		//关闭过关弹出
		vee.PopMgr.closeLayerByCtl(this);
	}
});
cc.BuilderReader.registerController("lyStatsBoost", lyStatsBoost);
