/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 14/12/24
 * Time: 下午3:12
 * To change this template use File | Settings | File Templates.
 */

vee.GameModule.GameLayer.extend({

	//游戏界面
	/** @expose */
	m_ly_gameLayer : null,

	//初始化
	onLoaded : function()
	{
		this.m_ly_gameLayer.controller.setVeeGameLayer(this);
		this.m_ly_gameLayer.controller.onLoaded();
	},
	//关闭界面
	onClosed : function()
	{
		this.m_ly_gameLayer.controller.onClosed();
	},
	//
	onKeyBack : function(){
		if (!this.onClose()) {
			vee.onKeyBack();
		}
	},
	//
	onKeyMenu : function() {
		return true;
	}
});

var lyGameLayer = vee.Class.extend({

	//层级
	/** @expose */
	m_lyGameTileLayer : null,
	/** @expose */
	m_lyMapLayer : null,
	/** @expose */
	m_lyGameUiLayer : null,
	/** @expose */
	m_lyFightLayerContain : null,
	//------------------------------------------------
	//战斗页面
	m_lyFightLayer : null,
	//人物属性界面
	m_lyEquipmentLayer : null,
	//包裹页面
	m_lyInventoryLayer : null,
	//弹出
	m_noPopNode : null,
	//------------------------------------------------
	//金币位置
	m_pointCoin : null,
	//敌人
	m_noEnemy : null,
	//------------------------------------------------
	//方向
	m_nDirection : -1,
	//触控控制
	m_bCanSlither : false,
	//中介对象
	m_lyVeeGameLayer : null,

	//id
	m_strOrderId : "1",

	//---------------------------------------------------------------------------------------------------------------------------
	//设置
	
	//父控件
	setVeeGameLayer : function(lyVeeGameLayer)
	{
		this.m_lyVeeGameLayer = lyVeeGameLayer;
	},
	
	//---------------------------------------------------------------------------------------------------------------------------
	//初始化
	
	//初始化
	onLoaded : function()
	{
		//初始化资源
		this.initResource();
		
		//------------------------------------------------------------
		
		//初始化触控层
		var lyTouchLayer = cc.LayerColor.create(cc.color(0,0,0,0), 0, 0);
		this.rootNode.addChild(lyTouchLayer, -1);
		vee.GestureController.registerController(lyTouchLayer, this, true);
		
		//------------------------------------------------------------
		
		//tile
		this.m_noEnemy = this.m_lyGameTileLayer.controller.onLoaded();
		this.m_lyGameTileLayer.controller.setGameLayer(this);
		//map
		this.m_lyMapLayer.controller.onLoaded();
		//ui
		this.m_lyGameUiLayer.controller.setGameLayer(this);
		this.m_pointCoin = this.m_lyGameUiLayer.controller.getCoinPosition();
		
		//------------------------------------------------------------
		
		//更新金钱
		this.setDisplayMoney(0);
		//更新步数
		this.setDisplayStep(0);
		//更新层数
		this.setDisplayFloor();
		
		//------------------------------------------------------------
		
		//检测事件
		this.moveStepOver(2);
	},
	//关闭界面
	onClosed : function()
	{
		this.m_lyGameUiLayer.controller.onClosed();
	},
	
	//---------------------------------------------------------------------------------------------------------------------------
	
	//初始化资源
	initResource : function()
	{
		//加载图片
		cc.spriteFrameCache.addSpriteFrames(res.batch_plist);
		//加载动画
		var aFrames = [];
		for(var i = 1; i < 10; i++)
		{
			var sprFrame = cc.spriteFrameCache.getSpriteFrame("Coin_" + i + ".png");
			aFrames.push(sprFrame);
		}
		cc.animationCache.addAnimation(cc.Animation.create(aFrames, 0.02), "coin");
	},
	
	//---------------------------------------------------------------------------------------------------------------------------
	//显示修改
	
	//修改楼层
	setDisplayFloor : function()
	{
		this.m_lyGameUiLayer.controller.setCurrentLayer(GameManager.getCurrentFloor());
	},
	//更新金钱
	setDisplayMoney : function(nMoney)
	{
		GameManager.m_oTowerData.m_nTowerMoney += nMoney;
		this.m_lyGameUiLayer.controller.setDisplayMoney(GameManager.m_oTowerData.m_nTowerMoney);
	},
	//修改步数
	setDisplayStep : function(nStep)
	{
		GameManager.m_oTowerData.m_nTowerStep += nStep;
		this.m_lyGameUiLayer.controller.setCurrentStep(GameManager.m_oTowerData.m_nTowerStep);
	},
	
	//---------------------------------------------------------------------------------------------------------------------------
	
	//滑动逻辑
	onGestureSwipe : function(context, angle, distance)
	{
		//滑动控制
		if(!this.m_bCanSlither){
			return;
		}
		this.m_bCanSlither = false;
		
		//---------------------------------------------------------------
		
		//四个方向
		if(angle > 360 - 45 || angle < 45 )
		{
			this.moveStep(4);
		}
		else if(angle >= 45 && angle < 45 + 90)
		{
			this.moveStep(8);
		}
		else if(angle >= 45 + 90 && angle < 45 + 180)
		{
			this.moveStep(1);
		}
		else
		{
			this.moveStep(2);
		}
	},
	//移动逻辑
	moveStep : function(nDirection)
	{
		//下一步
		var nNextStep = -1;
		
		//------------------------------------------------------------
		
		//判断是否有门
		var nDoor = MapManager.moveCheckLock(nDirection);
		if(nDoor > 0)
		{
			if(EquipManager.removePackEquipSpType(EqupSp.Key))
			{
				this.openDoor(nDirection, nDoor, true);
				return;
			}
		}
		else
		{
			//计算下一步
			nNextStep = MapManager.moveNextStep(nDirection);
		}
		
		//------------------------------------------------------------
		
		//修改地图
		this.m_lyMapLayer.controller.moveStepBall(nNextStep);
		
		//------------------------------------------------------------
		
		//修改页面,添加敌人
		this.m_noEnemy = this.m_lyGameTileLayer.controller.moveGameTile(nNextStep, nDirection);
		
		//------------------------------------------------------------
		
		//修改步数
		if(nNextStep >= 0){
			this.setDisplayStep(-1);
		}
		
		//------------------------------------------------------------
		
		//声音
		vee.Audio.playEffect(res.inGame_event_step_mp3, false);
	},
	//滑动完成回调
	moveStepOver : function(nType)
	{
		//滑动结束逻辑
		switch (nType)
		{
			case 1:
			{
				//滑动控制
				this.m_bCanSlither = true;
			}
				break;
			case 2:
			{
				//进入下一关界面
				if(MapManager.locatePortalStep())
				{
					this.propPassLayer();
				}
				else if(MapManager.locateEnemyStep())
				{
					this.propFightLayer();
				}
				else
				{
					var oMes = {nType : "Step", nFloor : GameManager.getTowerData().m_nBigFloor};
					//统计
					vee.Analytics.logEvent(StatEventId.Death, oMes);

					this.checkGameOver();
				}
			}
				break;
		}
	},
	//事件结束
	eventOver : function()
	{
		this.checkGameOver();
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//事件1

	//弹出战斗页面
	propFightLayer : function()
	{
		//加入战斗界面
		this.m_lyFightLayer = cc.BuilderReader.load(res.lyFightLayer_ccbi);
		vee.PopMgr.popLayer(this.m_lyFightLayer, { alpha : 0 }, this.m_lyFightLayerContain);
		
		//设置父控件
		this.m_lyFightLayer.controller.setGameLayer(this);
		this.m_lyFightLayer.controller.setFightLayer(this.m_noEnemy);
		
		//----------------------------------------------------------------------------
		
		//ui按钮弹出
		this.m_lyGameUiLayer.controller.btnMoveInOut(true);
		
		//----------------------------------------------------------------------------
		
		//声音
		vee.Audio.playEffect(res.inGame_event_battleStart_mp3, false);
	},
	//受到攻击
	attackPlayer : function()
	{
		this.m_lyGameTileLayer.controller.attackPlayer();
	},
	//显示胜利结果
	showWinResult : function()
	{
		var strContent = GameMessage.getFightWinResultMessage();
		var lyPopupLayer = noPopupNode.createTouchHint(strContent, this.showWinResultCallBack.bind(this));
		vee.PopMgr.popLayer(lyPopupLayer, { alpha : 100 }, null, null, null);
	},
	//胜利回调打开升级界面
	showWinResultCallBack : function()
	{
		//战斗结果
		var oWinResult = FightManager.getWinResult();
		
		//打开升级页
		if(oWinResult.m_nBoost > 0)
		{
			var lyStatsBoostLayer =  vee.PopMgr.popCCB(res.lyStatsBoost_ccbi, { alpha : 100 });
			lyStatsBoostLayer.controller.setGameLayer(this);
		}
		else
		{
			//战斗结束
			this.fightOver();
		}
	},

	//检测掉落宝箱
	createChest : function(bIsWin)
	{
		//移除敌人位置
		var nCurrentStep = MapManager.getCurrentStep();
		//判断是否有道具
		if(MapManager.locateChestStep(nCurrentStep))
		{
			if(bIsWin)
			{
				//生成宝箱
				this.m_lyGameTileLayer.controller.showChest();
				//小地图添加宝箱标记
				this.m_lyMapLayer.controller.showMapChest(nCurrentStep);
			}
			else
			{
				//移除宝箱位置
				MapManager.removeChestStep(nCurrentStep);
			}
		}
	},
	//战斗结束
	fightOver : function()
	{
		//移除敌人数据
		MapManager.removeEnemyStep(MapManager.getCurrentStep());

		//结算战斗数据
		FightManager.fightClearingOver(this.m_lyFightLayer.controller.m_bUsePotion);

		//关闭战斗画面
		vee.PopMgr.closeLayerByCtl(this.m_lyFightLayer.controller);
		this.m_lyFightLayer = null;

		//ui按钮弹出
		this.m_lyGameUiLayer.controller.btnMoveInOut(false);
		
		//得到战斗结果
		var oResult = FightManager.getFightResult();
		//判断胜负
		if(oResult.m_nFightOver > 0)
		{
			//判断boss
			if(oResult.m_bIsBoss)
			{
				//开门
				this.openDoor(MapManager.getBossLockDirection(), MapManager.getBossLock(), false);
			}
			else
			{
				//恢复滑动
				this.m_bCanSlither = true;
			}
		}
		else if(oResult.m_nFightOver < 0)
		{
			//判断boss
			if(oResult.m_bIsBoss)
			{
				var oMes = {nType : "Boss", nFloor : GameManager.getTowerData().m_nBigFloor};
				//统计
				vee.Analytics.logEvent(StatEventId.Death, oMes);
			}else if(GameManager.getTowerData().m_nTowerStep <= 0)
			{
				var oMes = {nType : "Enemy", nFloor : GameManager.getTowerData().m_nBigFloor};
				//统计
				vee.Analytics.logEvent(StatEventId.Death, oMes);
			}

			//事件结束
			this.eventOver();
		}
	},

	//金币效果
	jumpCoin : function()
	{
		this.m_lyGameTileLayer.controller.jumpCoin(this.m_pointCoin);
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//事件2
	//弹出过关选项
	propPassLayer : function()
	{
		//楼层
		var nFloor = GameManager.getCurrentFloor();
		//楼层判断
		if(FloorData[nFloor].FloorType == FloorType.Leave)
		{
			//判断最新记录
			if(!GameManager.isMaxFloor(false))
			{
				//设置弹出页
				var strContent = GameMessage.passOutFloor();
				var lyPopupLayer = noPopupNode.createBtnHint(strContent, "", false, true,
															 this.passFloorOutCallback.bind(this),
														     this.eventOver.bind(this), null, false);
				vee.PopMgr.popLayer(lyPopupLayer, { alpha : 100 }, null, null, null);
			}
			else
			{
				//设置弹出页
				var strContent = GameMessage.passBigFloor();
				var lyPopupLayer = noPopupNode.createBtnHint(strContent, "", false, true,
															 this.passCurrentLayer.bind(this),
															 this.passFloorOutCallback.bind(this), null, false);
				vee.PopMgr.popLayer(lyPopupLayer, { alpha : 100 }, null, null, null);

				//修改按钮
				lyPopupLayer.controller.seConfirmSprite(res.btn_battle_png, res.btn_battle_png, cc.rect(0, 0, 150, 150));
				lyPopupLayer.controller.seCancelSprite(res.btn_home_png, res.btn_home_png, cc.rect(0, 0, 150, 150));
			}
		}
		else
		{
			//设置弹出页
			var strContent = GameMessage.passSmallFloor();
			var lyPopupLayer = noPopupNode.createBtnHint(strContent, "", false, true,
														 this.passCurrentLayer.bind(this),
														 this.eventOver.bind(this), null, false);
			vee.PopMgr.popLayer(lyPopupLayer, { alpha : 100 }, null, null, null);
		}
	},
	//过关回调
	passCurrentLayer : function()
	{
		//更新每层数据
		GameManager.passFloor();
		//初始化地图数据
		MapManager.createMap();
		//过关效果
		this.m_lyGameTileLayer.controller.passCurrentLayer();
		//过关效果
		this.m_lyGameUiLayer.controller.passLayer();
	},
	//重置新地图
	resetNewLayer : function()
	{
		//更新楼层显示
		this.setDisplayFloor();
		//增加步数
		this.setDisplayStep(GameManager.checkSpecialEquip(EqupSp.Agility) ? 15 : 10);
		//过关效果
		//this.m_lyGameUiLayer.controller.passLayer();
		//重置地图
		this.m_lyMapLayer.controller.resetMap();

		//广告
		vee.Ad.showInterstitialAd();
	},
	//到达目前最高层回调
	passFloorOutCallback : function()
	{
		//判断胜利
		GameManager.m_oTowerData.m_nGameWin = 1;
		//打开结果页
		this.m_lyGameTileLayer.controller.moveOutTower();
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//事件3(特殊)
	//打开宝箱回调
	openChest : function()
	{
		//滑动控制
		if(!this.m_bCanSlither){
			return;
		}
		this.m_bCanSlither = false;

		//---------------------------------------------------------------

		//找到宝物
		var nStep   = MapManager.getCurrentStep();
		var bIsFull = EquipManager.checkTravelIsFull();

		//判断钻石
		var nRand = StaticMethod.getRandom(100);
		var nMax = vee.VIPValues.getValue(VipKey.JewelProb);
		nMax = JewelProb[nMax];
		if(nRand < nMax)
		{
			//移除道具
			var oEquip  = EquipManager.getEquipByStep(nStep, true);

			//移除地图标记
			MapManager.openChestStep(nStep);
			//清除地图标记
			this.m_lyMapLayer.controller.removeMapChest(nStep);
			//清空宝箱
			this.m_lyGameTileLayer.controller.emptyChest();

			//---------------------------------------------------------------

			//设置弹出页
			var strContent = GameMessage.Mes_GetJewel;
			this.m_noPopNode = noPopupNode.createTouchHintWithIcon(strContent, "",
				this.getEquipCallBack.bind(this), "img_shop_gem_small.png", false);

			//---------------------------------------------------------------

			//保存数据
			vee.VIPValues.add2Value(VipKey.Jewel, 1);
			//修改几率
			if(vee.VIPValues.getValue(VipKey.JewelProb) < (JewelProb.length-1)){
				vee.VIPValues.add2Value(VipKey.JewelProb, 1);
			}
			vee.VIPValues.save();

			//统计
			vee.Analytics.logReward(1, "OpenChest");
		}
		else
		{
			//移除道具
			var oEquip  = EquipManager.getEquipByStep(nStep, !bIsFull);

			//判断背包已满
			if(!bIsFull)
			{
				//添加道具
				EquipManager.addTravelEquip(oEquip);
				//移除地图标记
				MapManager.openChestStep(nStep);
				//清除地图标记
				this.m_lyMapLayer.controller.removeMapChest(nStep);
			}
			//清空宝箱
			this.m_lyGameTileLayer.controller.emptyChest();

			//---------------------------------------------------------------

			//设置弹出页
			var strContent = "";
			if(oEquip.m_oData.EquipType <= EquipType.Accessories){
				strContent = GameMessage.getEquipMessage(oEquip);
			}else{
				strContent = GameMessage.Mes_SpecialEquipDes[oEquip.m_oData.Id - 501];
			}
			var strContent2 = GameMessage.Mes_PackFull;;
			this.m_noPopNode = noPopupNode.createTouchHintWithIcon(strContent, bIsFull ? strContent2 : "",
				this.getEquipCallBack.bind(this), oEquip.m_oData.Icon, bIsFull);
		}
	},
	//打开宝箱回调
	openChestCallback : function()
	{
		vee.PopMgr.popLayer(this.m_noPopNode, { alpha : 100 }, null, null, null);
		this.m_noPopNode = null;
	},
	//得到道具回调
	getEquipCallBack : function(bIsFull)
	{
		//重置宝箱
		if(bIsFull){
			this.m_lyGameTileLayer.controller.revertChest();
		}

		//滑动控制
		this.m_bCanSlither = true;
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//事件4(特殊)

	//开门
	openDoor : function(nDirection, nData, bAutoMove)
	{
		//移除地图中的门
		MapManager.removeKeyStep(MapManager.getCurrentStep(), nData);
		
		//开门动画
		this.m_lyGameTileLayer.controller.openDoor(nDirection);
		
		//记录门的方向
		if(bAutoMove){
			this.m_nDirection = nDirection;
		}
		
		//---------------------------------

		//声音
		vee.Audio.playEffect(res.inGame_event_openDoor_mp3, false);
	},
	//开门回调
	openDoorCallback : function()
	{
		if(this.m_nDirection > 0)
		{
			//进门滑动
			this.moveStep(this.m_nDirection);
			//清空方向
			this.m_nDirection = -1;
		}
		else
		{
			//恢复滑动
			this.m_bCanSlither = true;
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//其他功能
	//打开装备
	openPlayer  : function()
	{
		//滑动控制
		if(!this.m_bCanSlither){
			return;
		}

		this.m_lyEquipmentLayer = vee.PopMgr.popCCB(res.lyEquipment_ccbi, { alpha : 0 });
		this.m_lyEquipmentLayer.controller.initEquipmentWithType(EquipBarFunction.Exchange);
		this.m_lyEquipmentLayer.controller.setGameLayer(this);

		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);
	},
	//打开仓库
	openPack : function()
	{
		//滑动控制
		if(!this.m_bCanSlither){
			return;
		}

		this.m_lyInventoryLayer = vee.PopMgr.popCCB(res.lyInventory_ccbi, { alpha : 0 });
		this.m_lyInventoryLayer.controller.initInventoryWithType(EquipBarFunction.Discard);
		this.m_lyInventoryLayer.controller.setGameLayer(this);

		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);
	},
	//退出塔
	openOutTower : function()
	{
		//检测回城
		var strContent = "";
		if(GameManager.checkSpecialEquip(EqupSp.TP)){
			strContent = GameMessage.Mes_UseTp;
		}else{
			strContent = GameMessage.outTowerMessage();
		}
		
		//退出提示
		var lyPopupLayer = noPopupNode.createBtnHint(strContent, 0, false, true,
													 this.outTower.bind(this), null, null, false);
		vee.PopMgr.popLayer(lyPopupLayer, { alpha : 100 }, null, null, null);
	},
	//打开结果显示
	openResultHint : function()
	{
		var lyResultLayer = vee.PopMgr.popCCB(res.lyResults_ccbi, { alpha : 100 }, null, null, null);
		lyResultLayer.controller.setGameLayer(this);
	},
	//祈福提示
	showWishHint : function()
	{
		var strContent = GameMessage.Mes_UseBlessed;
		var lyPopupLayer = noPopupNode.createTouchHint(strContent,  this.outTower.bind(this));
		vee.PopMgr.popLayer(lyPopupLayer, { alpha : 100 }, null, null, null);
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//游戏结束
	//检测游戏结束
	checkGameOver : function()
	{
		//数据
		var oTowerData = GameManager.getTowerData();
		
		//检测步数
		if(oTowerData.m_nTowerStep <= 0)
		{
			//标记游戏失败
			oTowerData.m_nGameWin = -1;
			//弹出失败页面
			this.m_lyGameUiLayer.controller.gameOver();
			
			//--------------------------------------
			//声音
			vee.Audio.playEffect(res.inGame_event_gameFailed_mp3, false);
		}
		else
		{
			//滑动控制
			this.m_bCanSlither = true;
		}
	},
	//退出塔
	outTower : function()
	{
		//释放资源
		cc.spriteFrameCache.removeSpriteFrameByName(res.batch_plist);
		cc.animationCache.removeAnimation("coin");
		
		//--------------------------------------	
		//重置数据
		GameManager.resetGame();

		//--------------------------------------
		//统计
		vee.Analytics.logEvent(StatEventId.OuttoTower, { "Floor" : ''+GameManager.getTowerData().m_nBigFloor});
		
		//--------------------------------------
		//退回主界面
		vee.GameModule.SceneMgr.openMain();

		//--------------------------------------
		//评价
		vee.Utils.showRateUs();
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//结束逻辑
	resultCallBack : function()
	{
		if(GameManager.getTowerData().m_nGameWin == -1 && GameManager.checkSpecialEquip(EqupSp.Wish))
		{
			this.showWishHint();
		}
		else if(GameManager.getTowerData().m_nGameWin == -1)
		{
			this.saveEquip();
		}
		else
		{
			this.outTower();
		}
	},
	//退出保存
	saveEquip : function()
	{
		var nPrice = 40;
		var bConfirm = GameManager.moneyEnough(nPrice, ShopPayType.Jewel);
		var lyPopupLayer = noPopupNode.createBtnHint(GameMessage.Mes_DeadSave, nPrice, true, true,
													 bConfirm ? this.saveEquipCallBack1.bind(this) : this.saveEquipCallBack2.bind(this),
													 this.outTower.bind(this), res.img_gem_png, bConfirm);
		vee.PopMgr.popLayer(lyPopupLayer, { alpha : 100 }, null, null, null);
	},
	//回调1
	saveEquipCallBack1 : function()
	{
		//统计
		vee.Analytics.logEvent(StatEventId.LeaveTowerJewel);

		//添加回城保存装备
		GameManager.buySpecialEquip(ShopData[3], 40, false);
		GameManager.getTowerData().m_nGameWin = 0;
		//退出逻辑
		this.outTower();
	},
	//回调2
	saveEquipCallBack2 : function()
	{
		var lyPopupLayer = noPopupNode.createBtnHint(GameMessage.Mes_WantToTopUp2, "",
													 false, true, this.gameTopUpCallBack.bind(this), this.outTower.bind(this), res.img_coin_png, false);
		vee.PopMgr.popLayer(lyPopupLayer, { alpha : 100 }, null, null, null);
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//充值逻辑
	//充值回调
	gameTopUpCallBack : function()
	{
		//统计
		this.m_strOrderId = ''+vee.Utils.getTimeNow();
		vee.Analytics.logChargeRequest(this.m_strOrderId, app.Config.IAPs[1], 1.99, null, 99, null);

		vee.IAPMgr.buyProduct(0, this.topUpSuccessCallBack.bind(this), this.topUpFailCallBack.bind(this), function(){});
	},
	//充值成功回调
	topUpSuccessCallBack : function(productID)
	{
		//修改钻石
		vee.VIPValues.add2Value(VipKey.Jewel, 99);

		//提示
		vee.PopMgr.alert(
			vee.Utils.getObjByLanguage([
				"Purchase success, you`ve got 99 diamonds!",
				"購買成功！获得了99钻石！"
			]),
			vee.Utils.getObjByLanguage([
				"CONGRATULATION",
				"恭喜"
			]),
			this.saveEquip.bind(this),
			this.outTower.bind(this)
		);

		//统计
		vee.Analytics.logChargeSuccess(this.m_strOrderId);
	},
	//充值失败回调
	topUpFailCallBack : function(productID)
	{
		//提示
		vee.PopMgr.alert(
			vee.Utils.getObjByLanguage([
				"Purchase failed！Please retry or quit!",
				"购买失败，请重试或退出游戏。"
			]),
			vee.Utils.getObjByLanguage([
				"RECHARGE FAILURE",
				"购买失败"
			]),
			this.gameTopUpCallBack.bind(this),
			this.outTower.bind(this)
		);
	}
});
cc.BuilderReader.registerController("lyGameLayer", lyGameLayer);