/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 14/12/23
 * Time: 下午1:52
 * To change this template use File | Settings | File Templates.
 */


var lyMapLayer = vee.Class.extend({

	//地图成员
	m_noMapNode : null,
	m_spBall : null,

	//---------------------------------------------------------------------------------------------------------------------------
	
	//
	onLoaded : function()
	{
		//创建地图
		this.createMap();
	},
	
	//---------------------------------------------------------------------------------------------------------------------------
	
	//创建地图
	createMap : function()
	{
		//地图node
		this.m_noMapNode = cc.Node.create();
		//初始化地图
		var nMapWidth = 0;
		for(var i = 0; i < MapManager.getMapLength(); i++)
		{
			//初始化地图tile
			var noTempTile = noMapTile.create(MapManager.getStepData(i));
			noTempTile.setTag(i+1);

			//设置node大小
			if(i == 0){
				nMapWidth = noTempTile.controller.m_nTileWidth * MapManager.getMapWidth();
				this.m_noMapNode.setContentSize(nMapWidth, nMapWidth);
			}

			//位置
			noTempTile.attr({
				anchorX : 0.5,
				anchorY : 0.5,
				x : -nMapWidth/2 + noTempTile.controller.m_nTileWidth/2 * (i % MapManager.getMapWidth() * 2 + 1),
				y : nMapWidth/2 - noTempTile.controller.m_nTileWidth/2 * (Math.floor(i / MapManager.getMapWidth()) *2 + 1)
			});

			//提示
			if(MapManager.locateChestStepWithEnemy(i) == 2){
				noTempTile.controller.setHint(1);
			}

			//隐藏
			if(MapManager.locateHideStep(i)){
				noTempTile.controller.hideMapTile();
			}

			//
			this.m_noMapNode.addChild(noTempTile);
		}

		//球初始化
		var noStartTile = this.m_noMapNode.getChildByTag(MapManager.getStartStep()+1);
		var pointStart = noStartTile.getPosition();
		this.m_spBall = cc.Sprite.create(res.img_map_view_current_png);
		this.m_spBall.setPosition(pointStart);
		this.m_noMapNode.addChild(this.m_spBall, 10);

		//设置地图位置
		var winSize = vee.Director.getWinSize();
		this.m_noMapNode.setPosition(winSize.width + vee.PopMgr.originOffset.x - this.m_noMapNode.getContentSize().width/2,
									  winSize.height + vee.PopMgr.originOffset.y - this.m_noMapNode.getContentSize().height/2);
		this.rootNode.addChild(this.m_noMapNode);

		//终点
		noStartTile = this.m_noMapNode.getChildByTag(MapManager.getTargetStep()+1);
		noStartTile.controller.setHint(2);
	},

	//重置地图
	resetMap : function()
	{
		//重置
		for(var i = 0; i < MapManager.getMapLength(); i++)
		{
			//
			var noMapTile = this.m_noMapNode.getChildByTag(i+1);
			noMapTile.controller.setMapTile(MapManager.getStepData(i));
			
			//清空提示
			noMapTile.controller.removeHint();

			//提示
			if(MapManager.locateChestStepWithEnemy(i) == 2){
				noMapTile.controller.setHint(1);
			}

			//隐藏
			if(MapManager.locateHideStep(i)){
				noMapTile.controller.hideMapTile();
			}else{
				noMapTile.controller.playAnimate("show_tile");
			}
		}

		//起点
		var noStartTile = this.m_noMapNode.getChildByTag(MapManager.getStartStep()+1);
		var pointStart = noStartTile.getPosition();
		this.m_spBall.setPosition(pointStart);

		//终点
		noStartTile = this.m_noMapNode.getChildByTag(MapManager.getTargetStep()+1);
		noStartTile.controller.setHint(2);
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//移动小地图位置
	
	moveStepBall : function(nTarget)
	{
		//移动失败
		if(nTarget < 0){
			return;
		}

		//移动动作
		var noTargetNode = this.m_noMapNode.getChildByTag(nTarget + 1);
		var pointTarget = noTargetNode.getPosition();
		var action = cc.MoveTo.create(0.5, pointTarget);
		this.m_spBall.runAction(action);

		//显示新区域
		if(MapManager.locateHideStep(nTarget))
		{
			MapManager.removeHideStep(nTarget);
			noTargetNode.controller.playAnimate("show_tile");
		}
	},
	
	//---------------------------------------------------------------------------------------------------------------------------

	//
	showMapChest : function(nTarget)
	{
		var noTargetNode = this.m_noMapNode.getChildByTag(nTarget + 1);
		noTargetNode.controller.setHint(1);
	},
	//
	removeMapChest : function(nTarget)
	{
		var noTargetNode = this.m_noMapNode.getChildByTag(nTarget + 1);
		noTargetNode.controller.removeHint();
	}
});
cc.BuilderReader.registerController("lyMapLayer", lyMapLayer);