/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 14/12/25
 * Time: 上午10:59
 * To change this template use File | Settings | File Templates.
 */

var lyGameTileLayer = vee.Class.extend({

	//tile数组
	m_aTiles : [],
	//当前title
	m_nCurrentTile : 0,
	//------------------------------------------------------------
	//中介对象
	m_lyGameLayer : null,

	//---------------------------------------------------------------------------------------------------------------------------
	//设置回调
	setGameLayer : function(lyGameLayer)
	{
		this.m_lyGameLayer = lyGameLayer;
	},
	//---------------------------------------------------------------------------------------------------------------------------
	//初始化
	//初始化
	onLoaded : function()
	{
		return this.createGameTile();
	},
	//创建切换页
	createGameTile : function()
	{
		var layerSize = this.rootNode.getContentSize();
		for(var i = 0; i < 2; i++)
		{
			var noTempTile = noGameTile.create();
			noTempTile.setPosition(cc.p(layerSize.width/2, layerSize.height/2));
			noTempTile.controller.setTileLayer(this);
			this.rootNode.addChild(noTempTile);
			this.m_aTiles[i] = noTempTile;
		}
		//------------------------------------------------------------------------
		//设置当前页面
		var noEnemy = this.setGameTile(this.m_aTiles[this.m_nCurrentTile], MapManager.m_nCurrentStep, 0);
		this.m_aTiles[1 - this.m_nCurrentTile].setVisible(false);
		return noEnemy;
	},
	//设置页面内容
	setGameTile : function(noTile, nStep, nDirection) 
	{
		//判断状况
		var nTileData = MapManager.getStepData(nStep);
		var bIsPass = MapManager.locatePortalStep(nStep);
		var nChestType = MapManager.locateChestStepWithEnemy(nStep);
		//创建敌人
		var bEnemy = MapManager.locateEnemyStep(nStep);
		var noEnemy = null;
		if(bEnemy)
		{
			noEnemy = cc.BuilderReader.load(res.eleEnemy_ccbi);
			FightManager.setEnemy();
			noEnemy.controller.setEnemyImage(FightManager.getEnemy().m_strIcon);
		}
		//设置当前页面
		noTile.controller.setGameTile(nTileData, bIsPass, nChestType, nDirection, noEnemy);
		//返回敌人
		return noEnemy;
	},
	//---------------------------------------------------------------------------------------------------------------------------
	//切换
	moveGameTile : function(nTarget, nDirection)
	{
		//敌人
		var noEnemy = null;
		//切换
		if(nTarget > -1)
		{
			//判断方向
			switch (nDirection)
			{
				// 如果是向下走
				case 1:
				{
					//当前页
					this.m_aTiles[this.m_nCurrentTile].controller.playAnimate("move_up", null, false);
					this.m_aTiles[this.m_nCurrentTile].controller.setChestBtn(false);
					//目标页
					noEnemy = this.setGameTile(this.m_aTiles[1 - this.m_nCurrentTile], nTarget, nDirection);
					this.m_aTiles[1 - this.m_nCurrentTile].controller.playAnimate("move_up_behind", this.moveSuccess.bind(this), false);
				}
					break;
				// 如果是向左走	
				case 2:
				{
					//当前页
					this.m_aTiles[this.m_nCurrentTile].controller.playAnimate("move_left", null, false);
					this.m_aTiles[this.m_nCurrentTile].controller.setChestBtn(false);
					//目标页
					noEnemy = this.setGameTile(this.m_aTiles[1 - this.m_nCurrentTile], nTarget, nDirection);
					this.m_aTiles[1 - this.m_nCurrentTile].controller.playAnimate("move_left_behind", this.moveSuccess.bind(this), false);
				}
					break;
				// 如果是向上走
				case 4:
				{
					//当前页
					this.m_aTiles[this.m_nCurrentTile].controller.playAnimate("move_down", null, false);
					this.m_aTiles[this.m_nCurrentTile].controller.setChestBtn(false);
					//目标页
					noEnemy = this.setGameTile(this.m_aTiles[1 - this.m_nCurrentTile], nTarget, nDirection);
					this.m_aTiles[1 - this.m_nCurrentTile].controller.playAnimate("move_down_behind", this.moveSuccess.bind(this), false);
				}
					break;
				// 如果是向右走
				case 8:
				{
					//当前页
					this.m_aTiles[this.m_nCurrentTile].controller.playAnimate("move_right", null, false);
					this.m_aTiles[this.m_nCurrentTile].controller.setChestBtn(false);
					//目标页
					noEnemy = this.setGameTile(this.m_aTiles[1 - this.m_nCurrentTile], nTarget, nDirection);
					this.m_aTiles[1 - this.m_nCurrentTile].controller.playAnimate("move_right_behind", this.moveSuccess.bind(this), false);
				}
					break;
			}
		}
		else
		{
			switch (nDirection)
			{
				// 如果是向下走
				case 1:
					this.m_aTiles[this.m_nCurrentTile].controller.playAnimate("kickBack_down", this.moveFailed.bind(this), false);
					break;
				// 如果是向左走
				case 2:
					this.m_aTiles[this.m_nCurrentTile].controller.playAnimate("kickBack_left", this.moveFailed.bind(this), false);
					break;
				// 如果是向上走
				case 4:
					this.m_aTiles[this.m_nCurrentTile].controller.playAnimate("kickBack_up", this.moveFailed.bind(this), false);
					break;
				// 如果是向右走
				case 8:
					this.m_aTiles[this.m_nCurrentTile].controller.playAnimate("kickBack_right", this.moveFailed.bind(this), false);
					break;
			}
		}
		//
		return noEnemy;
	},
	//交换当前页
	exchangeCurrentTile : function()
	{
		//切换当前索引
		this.m_nCurrentTile = 1 - this.m_nCurrentTile;
		this.m_aTiles[this.m_nCurrentTile].setLocalZOrder(2);
		this.m_aTiles[1 - this.m_nCurrentTile].setLocalZOrder(1);
	},
	//移动成功
	moveSuccess : function()
	{
		//切换当前索引
		this.exchangeCurrentTile();
		//中介操作
		if(this.m_lyGameLayer){
			this.m_lyGameLayer.moveStepOver(2);
		}
	},
	//移动失败
	moveFailed : function()
	{
		if(this.m_lyGameLayer){
			this.m_lyGameLayer.moveStepOver(1);
		}
	},
	//---------------------------------------------------------------------------------------------------------------------------
	//过关
	passCurrentLayer : function()
	{
		//地图数据
		var nTileData = MapManager.getStepData(MapManager.getStartStep());
		//跟新目标页
		this.m_aTiles[1 - this.m_nCurrentTile].controller.setGameTile(nTileData, true, 1);
		//执行动画
		this.m_aTiles[this.m_nCurrentTile].controller.playAnimate("move_pass", this.moveOutLastLayer.bind(this));
		this.m_aTiles[1 - this.m_nCurrentTile].controller.playAnimate("move_pass_behind", this.moveNewLayer.bind(this));
	},
	//过关回调1
	moveOutLastLayer : function()
	{
		//重置新层
		if(this.m_lyGameLayer){
			this.m_lyGameLayer.resetNewLayer();
		}
	},
	//过关回调2
	moveNewLayer : function()
	{
		//切换当前索引
		this.exchangeCurrentTile();

		//关闭传送门
		this.m_aTiles[this.m_nCurrentTile].controller.setPortalVisible(false);

		//回调
		if(this.m_lyGameLayer){
			this.m_lyGameLayer.eventOver();
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//效果相关
	//受到攻击
	attackPlayer : function()
	{
		this.m_aTiles[this.m_nCurrentTile].controller.playAnimate("attackPlayer", null, false, 0);
	},
	//移出塔
	moveOutTower : function()
	{
		this.m_aTiles[this.m_nCurrentTile].controller.playAnimate("MoveOutTower", this.moveOutTowerCallBack.bind(this));
	},
	moveOutTowerCallBack : function()
	{
		if(this.m_lyGameLayer){
			this.m_lyGameLayer.openResultHint();
		}
	},
	//---------------------------------------------------------------------------------------------------------------------------
	//显示宝箱
	showChest : function()
	{
		this.m_aTiles[this.m_nCurrentTile].controller.showChest();
	},
	//打开宝箱回调
	openChest : function()
	{
		this.m_lyGameLayer.openChest();
	},
	//清空宝箱
	emptyChest : function()
	{
		this.m_aTiles[this.m_nCurrentTile].controller.emptyChest();
	},
	emptyChestCallback : function()
	{
		this.m_lyGameLayer.openChestCallback();
	},
	//回复宝箱
	revertChest : function()
	{
		this.m_aTiles[this.m_nCurrentTile].controller.revertChest();
	},
	//---------------------------------------------------------------------------------------------------------------------------
	//开门
	openDoor : function(nDirection)
	{
		this.m_aTiles[this.m_nCurrentTile].controller.openDoor(nDirection);
	},
	openDoorCallback : function()
	{
		if(this.m_lyGameLayer){
			this.m_lyGameLayer.openDoorCallback();
		}
	},
	//---------------------------------------------------------------------------------------------------------------------------
	//金币效果
	jumpCoin : function(pointCoin)
	{
		this.m_aTiles[this.m_nCurrentTile].controller.jumpCoin(pointCoin);
	}
});
cc.BuilderReader.registerController("lyGameTileLayer", lyGameTileLayer);