/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 14/12/24
 * Time: 下午5:48
 * To change this template use File | Settings | File Templates.
 */

var noGameTile = vee.Class.extend({

	//各方向的门
	/** @expose */
	m_noContain : null,

	//上
	/** @expose */
	m_spBg : null,
	/** @expose */
	m_spUp : null,
	/** @expose */
	m_spUpInner : null,
	/** @expose */
	m_spUpDoor : null,

	//左右，下
	/** @expose */
	m_spLeft : null,
	/** @expose */
	m_spLeftInner : null,
	/** @expose */
	m_spLeftDoor : null,
	/** @expose */
	m_spLeftWall : null,

	/** @expose */
	m_spRight : null,
	/** @expose */
	m_spRightInner : null,
	/** @expose */
	m_spRightDoor : null,
	/** @expose */
	m_spRightWall : null,

	/** @expose */
	m_noDown : null,
	/** @expose */
	m_spDownLeft : null,
	/** @expose */
	m_spDownRight : null,
	/** @expose */
	m_spDownDoor : null,
	/** @expose */
	m_spUpWall : null,

	//传送门
	/** @expose */
	m_noPass : null,
	/** @expose */
	m_spLight : null,
	/** @expose */
	m_parDoor : null,
	/** @expose */
	m_spDoor : null,

	//宝箱
	/** @expose */
	m_btnChest : null,
	/** @expose */
	m_spChest : null,
	/** @expose */
	m_noChestEf : null,

	//金币
	/** @expose */
	m_sbnCoin : null,
	//敌人
	/** @expose */
	m_noEnemyContain : null,
	
	//方向
	m_nDirection : -1,
	//尺寸
	/** @expose */
	m_oNodeSize : null,
	//中介对象
	m_lyTileLayer : null,

	//---------------------------------------------------------------------------------------------------------------------------

	//属性
	setTileLayer : function(lyTileLayer)
	{
		this.m_lyTileLayer = lyTileLayer;
	},
	//属性
	getNodeSize : function()
	{
		return this.m_oNodeSize;
	},

	//---------------------------------------------------------------------------------------------------------------------------

	//初始化
	onCreate : function()
	{
		//设定大小
		this.m_oNodeSize = this.m_spBg.getContentSize();
	},
	
	//---------------------------------------------------------------------------------------------------------------------------

	//设置当前通路
	setGameTile : function(nTileData, bIsPass, nChestType, nDirection, noEnemy)
	{
		//整体
		this.rootNode.setVisible(true);
		//包含
		this.m_noContain.setScale(1);
		//背景
		this.m_spBg.setOpacity(255);
		//传送门
		this.m_noPass.setVisible(bIsPass);
		if(bIsPass){
			this.m_noPass.setScale(1);
			this.m_spDoor.setOpacity(255);
			this.m_spLight.setOpacity(0);
			this.m_parDoor.setScale(0);
		}
		//宝箱
		switch (nChestType)
		{
			case 1:
			{
				this.m_btnChest.setVisible(false);
				this.m_spChest.setVisible(false);
			}
				break;
			case 2:
			{
				this.m_btnChest.setVisible(true);
				this.m_spChest.setVisible(true);
				this.m_spChest.setOpacity(255);
				this.m_spChest.setTexture(res.btn_main_chest_png);
			}
				break;
			case 3:
			{
				this.m_btnChest.setVisible(false);
				this.m_spChest.setVisible(true);
				this.m_spChest.setOpacity(255);
				this.m_spChest.setTexture(res.btn_main_chest_on_png);
			}
				break;
		}

		//四个方向
		//上
		if((nTileData & 1) == 1)
		{
			this.m_spUp.setVisible(true);
			this.m_spUp.setOpacity(255);
			this.m_spUp.setScale(1);
			//
			this.m_spUpInner.setVisible(true);
			this.m_spUpInner.setOpacity(255);
			this.m_spUpInner.setScale(1);
			//
			if((nTileData & 0x10) == 0x10)
			{
				this.m_spUpDoor.setVisible(true);
				this.m_spUpDoor.setVisible(true);
				this.m_spUpDoor.setOpacity(255);
				this.m_spUpDoor.setScale(1);
			}
			else
			{
				this.m_spUpDoor.setVisible(false);
			}
		}
		else
		{
			this.m_spUp.setVisible(false);
			this.m_spUpInner.setVisible(false);
			this.m_spUpDoor.setVisible(false);
		}

		//右
		if((nTileData & 2) == 2)
		{
			this.m_spRight.setVisible(true);
			this.m_spRight.setOpacity(255);
			this.m_spRight.setScaleX(-1);
			//
			this.m_spRightInner.setVisible(true);
			this.m_spRightInner.setOpacity(255);
			this.m_spRightInner.setScale(1);
			//
			if((nTileData & 0x20) == 0x20)
			{
				this.m_spRightDoor.setVisible(true);
				this.m_spRightDoor.setVisible(true);
				this.m_spRightDoor.setOpacity(255);
				this.m_spRightDoor.setScaleX(-1);
			}
			else
			{
				this.m_spRightDoor.setVisible(false);
			}
		}
		else
		{
			this.m_spRight.setVisible(false);
			this.m_spRightInner.setVisible(false);
			this.m_spRightDoor.setVisible(false);
		}

		//下
		if((nTileData & 4) == 4)
		{
			this.m_noDown.setVisible(true);
			this.m_noDown.setScale(1);
			this.m_spDownLeft.setOpacity(255);
			this.m_spDownRight.setOpacity(255);
			//
			if((nTileData & 0x40) == 0x40)
			{
				this.m_spDownDoor.setVisible(true);
				this.m_spDownDoor.setOpacity(255);
			}
			else
			{
				this.m_spDownDoor.setVisible(false);
			}
		}
		else
		{
			this.m_noDown.setVisible(false);
		}

		//左
		if((nTileData & 8) == 8)
		{
			this.m_spLeft.setVisible(true);
			this.m_spLeft.setOpacity(255);
			this.m_spLeft.setScale(1);
			//
			this.m_spLeftInner.setVisible(true);
			this.m_spLeftInner.setOpacity(255);
			this.m_spLeftInner.setScale(1);
			//
			if((nTileData & 0x80) == 0x80)
			{
				this.m_spLeftDoor.setVisible(true);
				this.m_spLeftDoor.setVisible(true);
				this.m_spLeftDoor.setOpacity(255);
				this.m_spLeftDoor.setScale(1);
			}
			else
			{
				this.m_spLeftDoor.setVisible(false);
			}
		}
		else
		{
			this.m_spLeft.setVisible(false);
			this.m_spLeftInner.setVisible(false);
			this.m_spLeftDoor.setVisible(false);
		}

		//位置
		switch (nDirection)
		{
			case 1:
				// 如果是向下走
			{
				this.m_noContain.setPosition(cc.p(0, 0));
				this.m_noDown.setPosition(cc.p(0, -568));
			}
				break;
			case 2:
				// 如果是向左走
			{

			}
				break;
			case 4:
				// 如果是向上走
			{
				this.m_noContain.setPosition(cc.p(0, 0));
				this.m_noDown.setPosition(cc.p(0, -568));
			}
				break;
			case 8:
				// 如果是向右走
			{
			}
				break;
		}

		//添加怪物
		if(noEnemy)
		{
			this.m_noEnemyContain.addChild(noEnemy);
			noEnemy.controller.playAnimate("born", null ,false, 0);
		}
	},
	
	//---------------------------------------------------------------------------------------------------------------------------
	
	//显示传送门
	setPortalVisible : function(bVisible)
	{
		this.m_noPass.setVisible(bVisible);
	},
	//显示宝箱
	showChest : function()
	{
		this.m_btnChest.setVisible(true);
		this.m_spChest.setOpacity(255);
		this.m_spChest.setVisible(true);
		this.m_spChest.setTexture(res.btn_main_chest_png);
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//开门
	openDoor : function(nDirection)
	{
		//标记方向
		this.m_nDirection = nDirection;
		//开门效果
		switch (this.m_nDirection)
		{
			case 1:
				this.playAnimate("OpenDoorUp", this.openDoorCallback.bind(this), false, 0);
				break;
			case 2:
				this.playAnimate("OpenDoorRight", this.openDoorCallback.bind(this), false, 0);
				break;
			case 4:
				this.playAnimate("OpenDoor", this.openDoorCallback.bind(this), false, 0);
				break;
			case 8:
				this.playAnimate("OpenDoorLeft", this.openDoorCallback.bind(this), false, 0);
				break;
		}
	},
	//开门回调
	openDoorCallback : function()
	{
		//隐藏门
		switch (this.m_nDirection)
		{
			case 1:
				this.m_spUpDoor.setVisible(false);
				this.m_spUpWall.setVisible(false);
				break;
			case 2:
				this.m_spRightDoor.setVisible(false);
				this.m_spRightWall.setVisible(false);
				break;
			case 4:
				this.m_noDown.setVisible(false);
				break;
			case 8:
				this.m_spLeftDoor.setVisible(false);
				this.m_spLeftWall.setVisible(false);
				break;
		}
		this.m_nDirection = -1;

		//--------------------------------------------------------------
		//开门回调
		if(this.m_lyTileLayer){
			this.m_lyTileLayer.openDoorCallback();
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------

	//按钮回调
	/** @expose */
	openChest : function(ref_pSender)
	{
		//声音
		vee.Audio.playEffect(res.inGame_event_chestOpen_mp3, false);
		//打开宝箱
		this.m_lyTileLayer.openChest();
	},

	//---------------------------------------------------------------------------------------------------------------------------

	//清空宝箱
	emptyChest : function()
	{
		//移除按钮
		this.m_btnChest.setVisible(false);
		//宝箱效果
		this.m_noChestEf.setVisible(true);
		this.playAnimate("OpenChest", this.emptyChestCallback.bind(this), false, 0);
	},
	emptyChestCallback : function()
	{
		//移除效果
		this.m_noChestEf.setVisible(false);
		//打开回调
		this.m_lyTileLayer.emptyChestCallback();
	},

	//---------------------------------------------------------------------------------------------------------------------------

	//回复宝箱
	revertChest : function()
	{
		this.m_btnChest.setVisible(true);
		this.m_spChest.setTexture(res.btn_main_chest_png);
	},
	//设置按钮
	setChestBtn : function(bVisible)
	{
		this.m_btnChest.setVisible(bVisible);
	},

	//---------------------------------------------------------------------------------------------------------------------------

	//金币效果
	jumpCoin1 : function(pointCoin)
	{
		for(var i = 0; i < 10; i++)
		{
			var spCoin = cc.Sprite.createWithSpriteFrameName("Coin_1.png");
			this.m_sbnCoin.addChild(spCoin);
			//
			var actionAn = cc.animate(cc.animationCache.getAnimation("coin"));
			spCoin.runAction(cc.repeatForever(actionAn));
			//
			spCoin.setTag(i+1);
			spCoin.setPosition(cc.p(384 + StaticMethod.getRandomTest(100), 568));

			//
			var nTime = 0.2 + StaticMethod.getRandom(10)/100;
			var nHeight1 = StaticMethod.getRandom(100) + 100;
			//
			var action = cc.MoveBy.create(nTime, cc.p(0, nHeight1));
			var action2 = cc.EaseBackOut.create(action);

			//
			var nTime2 = 1 + StaticMethod.getRandom(20)/100;
			var nHeight2 = StaticMethod.getRandom(4)*10;
			spCoin.setLocalZOrder(nHeight2);
			//
			var action3 = cc.MoveBy.create(nTime2, cc.p(0, -170 - nHeight1 - nHeight2));
			var action4 = cc.EaseBounceOut.create(action3);

			//
			var action5 = cc.MoveBy.create(nTime + nTime2, cc.p(StaticMethod.getRandomTest(200), 0));
			var action6 = cc.Spawn.create(cc.Sequence.create(action2, action4), action5);

			//
			var point1 = cc.p(100, 700);
			var point2 = cc.p(100, 400);
			var bezier = [point1, point2, pointCoin];
			var action7 = cc.BezierTo.create(1, bezier);
			var action9 = cc.ScaleTo.create(1, 0.7);
			var action10 = cc.Spawn.create(action7, action9);
			var action11 = cc.DelayTime.create(0.05*i);

			//
			var action12 = cc.CallFunc.create(this.jumpCoinCallback, spCoin);

			//
			spCoin.runAction(cc.Sequence.create(action6, action11, action10, action12));
		}
	},
	jumpCoinCallback : function(pSender)
	{
		pSender.removeFromParent(true);
		if(pSender.getTag() == 1){
			MyNotificationCenter.postNotification(GameEvent.UPDATAEGAMEMONEY2, 0);
		}
	},

	jumpCoin : function(pointCoin)
	{
		for(var i = 0; i < 10; i++)
		{
			var spCoin = cc.Sprite.createWithSpriteFrameName("Coin_1.png");
			this.m_sbnCoin.addChild(spCoin);
			//
			var actionAn = cc.animate(cc.animationCache.getAnimation("coin"));
			spCoin.runAction(cc.repeatForever(actionAn));
			//
			spCoin.setTag(i+1);
			var x1 = 384 + StaticMethod.getRandomTest(100);
			spCoin.setPosition(cc.p(x1, 568));

			//
			var nTime = 0.2 + StaticMethod.getRandom(10)/100;
			var nHeight1 = StaticMethod.getRandom(100) + 100;
			//
			var action = cc.MoveBy.create(nTime, cc.p(0, nHeight1));
			var action2 = cc.EaseBackOut.create(action);

			//
			var nTime2 = 1 + StaticMethod.getRandom(20)/100;
			var nHeight2 = StaticMethod.getRandom(4)*10;
			spCoin.setLocalZOrder(nHeight2);
			//
			var action3 = cc.MoveBy.create(nTime2, cc.p(0, -170 - nHeight1 - nHeight2));
			var action4 = cc.EaseBounceOut.create(action3);

			//
			var x2 = StaticMethod.getRandomTest(200);
			var action5 = cc.MoveBy.create(nTime + nTime2, cc.p(x2, 0));
			var action6 = cc.Spawn.create(cc.Sequence.create(action2, action4), action5);

			//
			var point1 = cc.p(100, 700);
			var point2 = cc.p(100, 400);
			var bezier = [point1, point2, pointCoin];
			var action7 = cc.BezierTo.create(1, bezier);
			var action9 = cc.ScaleTo.create(1, 0.7);
			var action10 = cc.Spawn.create(action7, action9);
			var action11 = cc.DelayTime.create(0.05*i);

			//
			var action12 = cc.CallFunc.create(this.jumpCoinCallback, spCoin);
			//
			spCoin.runAction(cc.Sequence.create(action6, action11, action10, action12));




			var spCoin2 = cc.Sprite.createWithSpriteFrameName("img_coin_shadow.png");
			this.m_sbnCoin.addChild(spCoin2);
			spCoin2.setScale(0);
			spCoin2.setPosition(cc.p(x1, 568 -170 - nHeight2-20));
			spCoin2.setLocalZOrder(1);

			var action = cc.DelayTime.create(nTime);

			var action3 = cc.ScaleTo.create(nTime2, 1);
			var action4 = cc.EaseBounceOut.create(action3);

			var action5 = cc.MoveBy.create(nTime + nTime2, cc.p(x2, 0));
			var action6 = cc.Spawn.create(cc.Sequence.create(action, action4), action5);
			var action11 = cc.DelayTime.create(0.05*i);
			var action12 = cc.CallFunc.create(this.jumpCoinCallback, spCoin2);
			//
			spCoin2.runAction(cc.Sequence.create(action6, action11, action12));

		}
	}
});
cc.BuilderReader.registerController("noGameTile", noGameTile);
//创建方法
noGameTile.create = function()
{
	var node = cc.BuilderReader.load(res.noGameTile_ccbi);
	return node;
}

var noMagicDoor = vee.Class.extend({

	/** @expose */
	m_noDoor : null,
	/** @expose */
	m_spDoor : null,
	/** @expose */
	m_spLight : null,
	/** @expose */
	m_parDoor : null,

	//------------------------------------------------------------------------
	//设置
	//正常状态
	setType : function(bVisible, nOpacity, bEffect)
	{
		this.m_noDoor.setVisible(bVisible);
		//背景设置
		this.m_noDoor.setScale(1);
		this.m_spDoor.setOpacity(255);
		//效果设置
		if(bEffect)
		{
			this.m_spLight.setOpacity(255);
			this.m_parDoor.setScale(1);
		}
		else
		{
			this.m_spLight.setOpacity(0);
			this.m_parDoor.setScale(0);
		}
	}
});