/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 15/1/6
 * Time: 下午3:27
 * To change this template use File | Settings | File Templates.
 */

var eleEquipment = vee.Class.extend({

	//控件
	/** @expose */
	m_spEquip : null,
	/** @expose */
	m_noContain : null,
	/** @expose */
	m_lbContent : null,
	//-------------------------------------------------------------------------
	//锁
	/** @expose */
	m_noUnLock : null,
	/** @expose */
	m_lbUnLockPrice : null,
	//-------------------------------------------------------------------------
	//功能按钮
	/** @expose */
	m_btnExchange : null,
	/** @expose */
	m_btnUpgrade : null,
	//-------------------------------------------------------------------------
	//装备类型
	m_nType : -1,
	//-------------------------------------------------------------------------
	//锁
	m_bIsLock : true,
	//解锁价格
	m_nPrice : 0,
	//-------------------------------------------------------------------------
	//功能
	m_nFunction : 0,
	//索引
	m_nIndex : -1,
	//保存的道具
	m_oEquip : null,
	//中介
	m_lyEquipmentLayer : null,

	//---------------------------------------------------------------------------------------------------------------------------

	//初始化设置
	setEquipmentLayer : function(lyEquipmentLayer, nFunction, nIndex, bIsLock, nType)
	{
		//代理
		this.m_lyEquipmentLayer = lyEquipmentLayer;
		//功能
		this.m_nFunction = nFunction;
		//设置索引
		this.m_nIndex = nIndex;

		//-------------------------------------------------------------------------

		//装备类型
		this.m_nType = nType;

		//-------------------------------------------------------------------------

		//枷锁
		this.m_bIsLock = bIsLock;
		//价格
		if(this.m_bIsLock){
			this.m_nPrice = GameFormula.equipBoxPrice(this.m_nIndex+1);
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------

	//更新装备框
	setEquipment : function(oEquip)
	{
		//更新当前道具
		this.m_oEquip = oEquip;

		//---------------------------------------------------

		//打开交换
		this.m_btnExchange.setVisible(!this.m_bIsLock);

		//未解锁的
		if(this.m_bIsLock)
		{
			//显示锁图
			this.m_spEquip.setTexture(res.icon_equipment_not_png);
			this.m_spEquip.setScale(1);
			this.m_spEquip.setVisible(true);

			//---------------------------------------------------

			//价格显示
			if(StaticMethod.checkEquipBarFunction(this.m_nFunction, EquipBarFunction.Upgrade))
			{
				this.m_noUnLock.setVisible(true);
				this.m_lbUnLockPrice.setString(this.m_nPrice)
			}
			else
			{
				this.m_noUnLock.setVisible(false);
			}
		}
		else
		{
			//隐藏价格
			this.m_noUnLock.setVisible(false);

			//---------------------------------------------------

			//判断是否有道具
			if(oEquip == null)
			{
				//都不显示
				this.m_spEquip.setVisible(false);
				this.m_noContain.setVisible(false);
			}
			else
			{
				//信息
				var oData = this.m_oEquip.m_oData;

				//显示内容
				this.m_noContain.setVisible(true);

				//显示装备图
				this.m_spEquip.setTexture("res/" + oData.Icon);
				this.m_spEquip.getTexture().setAliasTexParameters();
				this.m_spEquip.setScale(4);
				this.m_spEquip.setVisible(true);

				//判断显示升级按钮
				if(StaticMethod.checkEquipBarFunction(this.m_nFunction, EquipBarFunction.Upgrade)
					&& oData.EquipType <= EquipType.Body)
				{
					//升级显示
					this.m_btnUpgrade.setVisible(true);
				}
				else
				{
					this.m_btnUpgrade.setVisible(false);
				}

				//---------------------------------------------------

				//更新装备栏
				this.updateEquipment();
			}
		}
	},
	//更新内容
	updateEquipment : function()
	{
		//超出升级范围
		this.m_btnUpgrade.setEnabled(!(this.m_oEquip.m_oCoe.m_nLv >= 10));
		
		//-----------------------------------------------------------------
		
		//内容
		this.m_lbContent.setString(GameMessage.getEquipValueMessage(this.m_oEquip, true, true));
	},
	//设置可解锁
	setCanUnlocked : function()
	{
		this.m_btnExchange.setVisible(true);
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//按钮回调

	/** @expose */
	onExchangeEquip : function(pSender)
	{
		if(this.m_lyEquipmentLayer)
		{
			if(this.m_bIsLock){
				this.m_lyEquipmentLayer.openUnLockEquipmentHint(this);
			}else{
				this.m_lyEquipmentLayer.openExchangeEquip(this);
			}
		}
	},
	/** @expose */
	onUpgradeEquip : function(pSender)
	{
		if(this.m_lyEquipmentLayer)
		{
			this.m_lyEquipmentLayer.openUpgradePlayerEquipHint(this);
		}
	}
});
cc.BuilderReader.registerController("eleEquipment", eleEquipment);