/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 15/1/6
 * Time: 下午5:48
 * To change this template use File | Settings | File Templates.
 */


var eleInventory = vee.Class.extend({

	//显示
	/** @expose */
	m_noContain : null,
	/** @expose */
	m_spIcon : null,
	/** @expose */
	m_lbName : null,
	/** @expose */
	m_lbContent : null,
	//-------------------------------------------------------------------------
	//按钮
	/** @expose */
	m_btnDiscard : null,
	/** @expose */
	m_btnExchange : null,
	/** @expose */
	m_noSell : null,
	/** @expose */
	m_btnUpgrade : null,
	//-------------------------------------------------------------------------
	//交换提示
	/** @expose */
	m_noChange : null,
	//-------------------------------------------------------------------------
	//功能
	m_nFunction : 0,
	//保存的道具
	m_oEquip : null,
	//中介
	m_lyInventoryLayer : null,

	//---------------------------------------------------------------------------------------------------------------------------

	//初始化
	setInventoryLayer : function(lyInventoryLayer, nFunction)
	{
		//代理
		this.m_lyInventoryLayer = lyInventoryLayer;
		//功能
		this.m_nFunction = nFunction;
	},

	//---------------------------------------------------------------------------------------------------------------------------

	//更新货栏
	setInventory : function(oEquip)
	{
		//更新当前道具
		this.m_oEquip = oEquip;

		//---------------------------------------------------

		//显示装备信息
		this.m_noContain.setVisible(!(oEquip == null));
		//跟新仓库栏
		if(oEquip != null)
		{
			//图片
			this.m_spIcon.setTexture("res/" + this.m_oEquip.m_oData.Icon);
			this.m_spIcon.getTexture().setAliasTexParameters();
			//---------------------------------------------------
			//跟新仓库栏
			this.updateInventory();
			//---------------------------------------------------
			//设置显示按钮
			this.setShowBtn();
		}
	},
	//跟新显示
	updateInventory : function()
	{
		//信息
		var oCoe = this.m_oEquip.m_oCoe;
		var oData = this.m_oEquip.m_oData;

		//-----------------------------------------------------------------

		//超出升级范围
		this.m_btnUpgrade.setEnabled(!(oCoe.m_nLv >= 10));

		//-----------------------------------------------------------------

		//等级
		if(oData.EquipType <= EquipType.Accessories)
		{
			this.m_lbName.setString(oData.Name + "  Lv." + oCoe.m_nLv);
			this.m_lbContent.setString(GameMessage.getEquipValueMessage(this.m_oEquip, false, false));
		}
		else
		{
			this.m_lbName.setString(oData.Name);
			this.m_lbContent.setString(GameMessage.Mes_SpecialEquipDes[oData.Id - 501]);
		}
	},
	//设置显示按钮
	setShowBtn : function()
	{
		//信息
		var oData = this.m_oEquip.m_oData;

		//丢弃
		if(StaticMethod.checkEquipBarFunction(this.m_nFunction, EquipBarFunction.Discard))
		{
			if(oData.EquipType < EquipType.Special){
				this.m_btnDiscard.setVisible(true);
			}else if(oData.EqupSpType == EqupSp.Key){
				this.m_btnDiscard.setVisible(true);
			}else{
				this.m_btnDiscard.setVisible(false);
			}
		}
		else
		{
			this.m_btnDiscard.setVisible(false);
		}

		//-----------------------------------------------------------------

		//卖
		if(StaticMethod.checkEquipBarFunction(this.m_nFunction, EquipBarFunction.Sell))
		{
			this.m_noSell.setVisible(true);
		}
		else
		{
			this.m_noSell.setVisible(false);
		}

		//-----------------------------------------------------------------

		//升级
		if(StaticMethod.checkEquipBarFunction(this.m_nFunction, EquipBarFunction.Upgrade)
			&& oData.EquipType <= EquipType.Body)
		{
			this.m_btnUpgrade.setVisible(true);
		}else{
			this.m_btnUpgrade.setVisible(false);
		}

		//-----------------------------------------------------------------

		//交换
		if(StaticMethod.checkEquipBarFunction(this.m_nFunction, EquipBarFunction.Exchange))
		{
			//显示交换按钮
			this.m_btnExchange.setVisible(true);

			//-----------------------------------------------------------------

			//判断交换
			if(oData.EquipType != this.m_lyInventoryLayer.m_nChangeType)
			{
				this.m_btnExchange.setEnabled(false);
				this.m_noChange.setVisible(false);
			}
			else
			{
				this.m_btnExchange.setEnabled(true);
				this.m_noChange.setVisible(true);

				//-----------------------------------------------------------------

				//调用访问者
				this.m_lyInventoryLayer.m_oVisitor.setHintStr(this.m_noChange, this.m_oEquip);
			}
		}
		else
		{
			this.m_btnExchange.setVisible(false);
			this.m_noChange.setVisible(false);
		}
	},
	//---------------------------------------------------------------------------------------------------------------------------
	//按钮回调
	/** @expose */
	onDiscardEquip : function(pSender)
	{
		if(this.m_lyInventoryLayer)
		{
			this.m_lyInventoryLayer.openEquipHint(this, EquipBarFunction.Discard);
		}
	},
	/** @expose */
	onSellEquip : function(pSender)
	{
		if(this.m_lyInventoryLayer)
		{
			this.m_lyInventoryLayer.openEquipHint(this, EquipBarFunction.Sell);
		}
	},
	/** @expose */
	onUpgradeEquip : function(pSender)
	{
		if(this.m_lyInventoryLayer)
		{
			this.m_lyInventoryLayer.openEquipHint(this, EquipBarFunction.Upgrade);
		}
	},
	/** @expose */
	onExchangeEquip : function(pSender)
	{
		if(this.m_lyInventoryLayer)
		{
			this.m_lyInventoryLayer.exchangeEquip(this);
		}
	}
});
cc.BuilderReader.registerController("eleInventory", eleInventory);
