/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 15/1/6
 * Time: 下午2:37
 * To change this template use File | Settings | File Templates.
 */


var lyEquipmentLayer = vee.Class.extend({

	//文字包含
	/** @expose */
	m_noBaseValue : null,
	/** @expose */
	m_noFightValue : null,
	//------------------------------------------------------
	//道具包含
	/** @expose */
	m_noFightEquips : null,
	/** @expose */
	m_noAccEquips : null,
	//------------------------------------------------------
	//功能按钮
	/** @expose */
	m_noMusic : null,
	/** @expose */
	m_btnOut : null,
	//------------------------------------------------------
	//类型
	m_nFunction : 0,
	//目标框
	m_oTargetEquipment : null,
	//------------------------------------------------------
	//中介对象
	m_lyMainLayer : null,
	m_lyGameLayer : null,
	//------------------------------------------------------
	//关闭表示
	m_bTouch : false,

	//---------------------------------------------------------------------------------------------------------------------------
	//设置

	//游戏界面
	setGameLayer : function(lyGameLayer)
	{
		this.m_lyGameLayer = lyGameLayer;
	},
	//主界面
	setMainLayer : function(lyMainLayer)
	{
		this.m_lyMainLayer = lyMainLayer;
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//初始化

	//初始化数据
	initEquipmentWithType : function(nFunction)
	{
		//打开效果
		this.playAnimate("open", this.openCallBack.bind(this), false);

		//------------------------------------------------------

		//类型
		this.m_nFunction = nFunction;
		//设置退出按钮
		if((nFunction & EquipBarFunction.Upgrade) == EquipBarFunction.Upgrade){
			this.m_btnOut.setVisible(false);
		}

		//------------------------------------------------------

		//初始化玩家数值
		this.upDataPlayerProValue();

		//------------------------------------------------------

		//初始化装备框
		for(var i = 0; i < 9; i ++)
		{
			var nType = -1;
			var noEquipment = null;
			//找到道具栏
			if(i < 3)
			{
				//装备栏
				noEquipment = this.m_noFightEquips.getChildByTag(i+1).getChildByTag(2);
				//装备类型
				if(i == 1){
					nType = EquipType.Body;
				}else{
					nType = EquipType.Hand;
				}
			}
			else
			{
				//装备栏
				noEquipment = this.m_noAccEquips.getChildByTag(i+1).getChildByTag(2);
				//装备类型
				nType = EquipType.Accessories;
			}
			//设置代理状态
			var bIsLock = GameManager.boxLocked(i+1);
			noEquipment.controller.setEquipmentLayer(this, this.m_nFunction, i, bIsLock, nType);
		}

		//更新装备框
		this.setPlayerEquips();

		//------------------------------------------------------

		//设置解锁按钮
		if((this.m_nFunction & EquipBarFunction.Upgrade) == EquipBarFunction.Upgrade){
			this.upDataUnlockedEquipment();
		}
	},

	//---------------------------------------------------------------------------------------------------------

	//更新玩家属性
	upDataPlayerProValue : function()
	{
		//得到玩家属性数据
		var oPlayer = FightManager.getPlayer();
		//3项基本数据
		this.m_noBaseValue.getChildByTag(1).getChildByTag(1).setString(oPlayer.m_nLv);
		this.m_noBaseValue.getChildByTag(2).getChildByTag(1).setString(oPlayer.m_nExp);
		this.m_noBaseValue.getChildByTag(3).getChildByTag(1).setString(oPlayer.getRealByIndex(AttributeType.HP));
		//战斗数据
		for(var i = 1; i < 5; i++){
			this.m_noFightValue.getChildByTag(i).getChildByTag(1).setString(oPlayer.getRealByIndex(i));
		}
	},
	//更新装备框
	setPlayerEquips : function()
	{
		//得到玩家装备包
		var oPlayerPack = EquipManager.getPlayerPack();
		//更新武器
		for(var i = 0; i < 9; i ++)
		{
			var noEquipment = null;
			if(i < 3){
				noEquipment = this.m_noFightEquips.getChildByTag(i+1).getChildByTag(2);
			}else{
				noEquipment = this.m_noAccEquips.getChildByTag(i+1).getChildByTag(2);
			}
			//设置道具
			var oEquip = oPlayerPack.getEquipById(i);
			noEquipment.controller.setEquipment(oEquip);
		}
	},
	//更新解锁位置
	upDataUnlockedEquipment : function()
	{
		var oVipData = GameManager.getVIPData();
		if(oVipData.m_nPackLockIndex < 9)
		{
			var noEquipment = this.m_noAccEquips.getChildByTag(oVipData.m_nPackLockIndex+1).getChildByTag(2);
			noEquipment.controller.setCanUnlocked();
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//回调方法

	//装备框回调更新
	upDataPlayerEquip : function(bIsUnLock)
	{
		var oPlayer = FightManager.getPlayer();
		vee.Utils.logObj(oPlayer);

		if(bIsUnLock)
		{
			//更新装备框状态
			this.m_oTargetEquipment.m_bIsLock = false;
			this.m_oTargetEquipment.setEquipment(null);
			//更新新的可解锁位置
			this.upDataUnlockedEquipment();

			//统计
			vee.Analytics.logEvent(StatEventId.DredgeGrid, {"Lock" : + ""+GameManager.getVIPData().m_nPackLockIndex});
		}
		else
		{
			//更新装备框数据
			this.m_oTargetEquipment.updateEquipment();
			//更新玩家数值
			this.upDataPlayerProValue();
		}
	},
	//交换道具回调
	exchangeEquip : function(oEquip)
	{
		//交换逻辑
		EquipManager.exchangeEquip(oEquip, this.m_oTargetEquipment.m_oEquip, this.m_oTargetEquipment.m_nIndex);
		//更新目标装备栏
		this.m_oTargetEquipment.setEquipment(oEquip);
		//更新玩家数值
		this.upDataPlayerProValue();
	},
	//解锁回调
	unLockCallback : function()
	{
		//解锁
		GameManager.unLockEquip();
		//刷新金钱
		this.m_lyMainLayer.upDataCurrentMoney();
		//装备页更新
		this.upDataPlayerEquip(true);
	},
	//升级回调
	upgradeCallback : function(oEquip)
	{
		//升级道具
		GameManager.upgradeEquip(oEquip, true);
		//刷新金钱
		this.m_lyMainLayer.upDataCurrentMoney();
		//装备页更新
		this.upDataPlayerEquip(false);
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//按钮回调

	//打开道具窗口
	openExchangeEquip : function(oEquipMent)
	{
		//触控控制
		if(!this.m_bTouch){
			return;
		}
		//--------------------------------------------------------------

		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);

		//---------------------------------------------------------

		//确定装备框
		this.m_oTargetEquipment = oEquipMent;

		//---------------------------------------------------------

		//打开道具窗口
		var lyInventory = vee.PopMgr.popCCB(res.lyInventory_ccbi, { alpha : 0 }, null, null, null);
		lyInventory.controller.initInventoryWithType(EquipBarFunction.Exchange, oEquipMent.m_nType,
			oEquipMent.m_oEquip);
		lyInventory.controller.setDelegate(this);
	},
	//打开解锁提示
	openUnLockEquipmentHint : function(oEquipment)
	{
		//触控控制
		if(!this.m_bTouch){
			return;
		}
		//--------------------------------------------------------------

		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);

		//---------------------------------------------------------

		//确定解锁框
		this.m_oTargetEquipment = oEquipment;

		//---------------------------------------------------------

		//判断是否够钱
		var bConfirm = GameManager.moneyEnough(oEquipment.m_nPrice, ShopPayType.Coin);

		//---------------------------------------------------------

		//设置弹出页
		var strContent = GameMessage.unLockEquipBoxMessage();
		var lyPopupLayer = noPopupNode.createBtnHint(strContent, oEquipment.m_nPrice, true, bConfirm,
													 this.unLockCallback.bind(this), null, res.img_coin_png, bConfirm);
		vee.PopMgr.popLayer(lyPopupLayer, { alpha : 100 }, null, null, null);
	},
	//打开玩家装备升级提示
	openUpgradePlayerEquipHint : function(oEquipment)
	{
		//触控控制
		if(!this.m_bTouch){
			return;
		}
		//--------------------------------------------------------------

		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);

		//---------------------------------------------------------

		//确定目标框
		this.m_oTargetEquipment = oEquipment;

		//---------------------------------------------------------

		//目标道具
		var oEquip = oEquipment.m_oEquip;
		//得到价格
		var nPrice = GameFormula.upgradePrice(oEquip);
		//判断是否够钱
		var bConfirm = GameManager.moneyEnough(nPrice, ShopPayType.Coin);
		//设置弹出页
		var strContent = GameMessage.upgradeEquipMessage(oEquip);
		var lyPopupLayer = noPopupNode.createBtnHintWithIcon(strContent, nPrice, true, bConfirm,
															 this.upgradeCallback.bind(this), null,
															 oEquip.m_oData.Icon, oEquip, res.img_coin_png, bConfirm);
		vee.PopMgr.popLayer(lyPopupLayer, { alpha : 100 }, null, null, null);
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//按钮回调2

	//退出塔
	/** @expose */
	openOutTower : function()
	{
		if(this.m_lyGameLayer)
		{
			//声音
			vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);
			//退出
			this.m_lyGameLayer.openOutTower();
		}
	},
	//关闭
	/** @expose */
	closeLayer : function(pSender)
	{
		//触控控制
		if(!this.m_bTouch){
			return;
		}
		//--------------------------------------------------------------

		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);

		//------------------------------------------------------------

		//关闭标记
		this.m_bTouch = false;
		//关闭效果
		this.playAnimate("close", this.closeCallBack.bind(this), false);
	},
	//打开关闭回调
	openCallBack : function()
	{
		this.m_bTouch = true;
	},
	closeCallBack : function()
	{
		vee.PopMgr.closeLayerByCtl(this);
	}
});
cc.BuilderReader.registerController("lyEquipmentLayer", lyEquipmentLayer);
