/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 14/12/29
 * Time: 上午11:26
 * To change this template use File | Settings | File Templates.
 */

var lyGameUiLayer = vee.Class.extend({

	//显示控件
	/** @expose */
	m_noMoney : null,
	/** @expose */
	m_noStep : null,
	/** @expose */
	m_noDownContain : null,

	/** @expose */
	m_lbMoneyNumber : null,
	/** @expose */
	m_lbStepNumber : null,
	/** @expose */
	m_lbLayers : null,
	/** @expose */
	m_btnPack : null,

	//中介对象
	m_lyGameLayer : null,

	//------------------------------------------------------------------------------------------------------------

	//设置回调
	setGameLayer : function(lyGameLayer)
	{
		this.m_lyGameLayer = lyGameLayer;
	},
	//得到金钱位置
	getCoinPosition : function()
	{
		return this.m_noMoney.getPosition();
	},

	//------------------------------------------------------------------------------------------------------------

	//初始化
	onCreate : function()
	{
		//初始化位置
		vee.PopMgr.resetLayer(this.m_noMoney, vee.PopMgr.PositionType.TopLeft, cc.p(40, -50), true);
		vee.PopMgr.resetLayer(this.m_noStep, vee.PopMgr.PositionType.Top, cc.p(0, -40), true);
		vee.PopMgr.resetLayer(this.m_noDownContain, vee.PopMgr.PositionType.Bottom, cc.p(0, 100), true);

		//更新数量
		this.setEquipNumber(EquipManager.getCurrentPack().getPackLength());
		//设置观察者
		MyNotificationCenter.addObserver(this, GameEvent.UPDATAEQUIPNUMBER, this.setEquipNumber);
		MyNotificationCenter.addObserver(this, GameEvent.UPDATAEGAMEMONEY2, this.setDisplayMoney);
	},

	//关闭界面
	onClosed : function()
	{
		MyNotificationCenter.removeObserver(this, GameEvent.UPDATAEQUIPNUMBER);
		MyNotificationCenter.removeObserver(this, GameEvent.UPDATAEGAMEMONEY2);
	},

	//------------------------------------------------------------------------------------------------------------
	//效果

	//开始战斗效果
	btnMoveInOut : function(bOut)
	{
		if(bOut){
			this.playAnimate("btnMoveOut", null, false, 0);
		}else{
			this.playAnimate("btnMoveBack", null, false, 0);
		}
	},
	//切换楼层
	passLayer : function()
	{
		this.playAnimate("passLayer", null, false);
	},
	//游戏结束
	gameOver : function()
	{
		this.playAnimate("GameOver", this.openResultHint.bind(this), false);
	},

	//------------------------------------------------------------------------------------------------------------

	//更新金钱
	setDisplayMoney : function(nMoney)
	{
		if(!nMoney){
			nMoney = GameManager.getTowerData().m_nTowerMoney;
		}
		var strMoney = StaticMethod.setMoneyString(nMoney);
		this.m_lbMoneyNumber.setString(strMoney);
	},
	//更新楼层
	setCurrentLayer : function(nLayer)
	{
		this.m_lbLayers.setString(nLayer + "F");
	},
	//更新步数
	setCurrentStep : function(nStep)
	{
		this.m_lbStepNumber.setString(nStep);
		//颜色
		if(nStep <= 5){
			this.m_lbStepNumber.setColor(cc.RED);
		}else{
			this.m_lbStepNumber.setColor(cc.WHITE);
		}
		//动画效果
		var action = cc.ScaleTo.create(0.05, 1.5);
		var action2 = cc.ScaleTo.create(0.05, 1);
		this.m_lbStepNumber.runAction(cc.Sequence.create(action, action2));
	},
	//更新道具数
	setEquipNumber : function(nNumber)
	{
		var nIndex = vee.VIPValues.getValue(VipKey.Capacity);
		this.m_btnPack.setTitleForState(nNumber + "/" + DilatationData[nIndex][1], cc.CONTROL_STATE_NORMAL);
	},

	//------------------------------------------------------------------------------------------------------------
	//按钮回调

	//道具
	openInventoryLayer : function(pSender)
	{
		if(this.m_lyGameLayer){
			this.m_lyGameLayer.openPack();
		}
	},
	//装备
	openEquipmentLayer : function(pSender)
	{
		if(this.m_lyGameLayer){
			this.m_lyGameLayer.openPlayer();
		}
	},
	//打开结果页面
	openResultHint : function()
	{
		if(this.m_lyGameLayer){
			this.m_lyGameLayer.openResultHint();
		}
	}
});
cc.BuilderReader.registerController("lyGameUiLayer", lyGameUiLayer);
