/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 15/1/6
 * Time: 下午5:59
 * To change this template use File | Settings | File Templates.
 */


var lyInventoryLayer = vee.Class.extend({

	//控件
	/** @expose */
	m_noPage : null,
	/** @expose */
	m_btnLeft : null,
	/** @expose */
	m_btnRight : null,
	/** @expose */
	m_noBtnContain : null,
	//------------------------------------------------------
	//类型
	m_nFunction : 0,
	//目标框
	m_oTargetInventory: null,
	//交换道具
	m_nChangeType : -1,
	//访问者
	m_oVisitor : null,
	//------------------------------------------------------
	//代理
	m_oDelegate : null,
	//主界面
	m_lyMainLayer : null,
	//游戏界面
	m_lyGameLayer : null,
	//------------------------------------------------------
	//迭代集合
	m_oIteratorSet : null,
	//迭代
	m_oIterator : null,
	//显示种类
	m_nKind : -1,
	//当前按钮
	m_btnCurrent : null,
	//------------------------------------------------------
	//关闭表示
	m_bTouch : false,

	//---------------------------------------------------------------------------------------------------------------------------
	//设置代理

	setDelegate : function(oDelegate)
	{
		this.m_oDelegate = oDelegate;
	},
	//主界面
	setMainLayer : function(lyMainLayer)
	{
		this.m_lyMainLayer = lyMainLayer;
	},
	//游戏界面
	setGameLayer : function(lyGameLayer)
	{
		this.m_lyGameLayer = lyGameLayer;
	},

	//---------------------------------------------------------------------------------------------------------------------------

	//初始化
	initInventoryWithType : function(nFunction, nType, oEquip)
	{
		//打开效果
		this.playAnimate("open", this.openCallBack.bind(this), false);

		//-------------------------------------------------------

		//设置类型
		this.m_nFunction = nFunction;
		//设置Inventory代理
		for(var i = 0; i < 4; i++)
		{
			var noInventory = this.m_noPage.getChildByTag(i+1).getChildByTag(2);
			noInventory.controller.setInventoryLayer(this, this.m_nFunction);
		}

		//-------------------------------------------------------

		//设置访问者
		if((nFunction & EquipBarFunction.Exchange) == EquipBarFunction.Exchange)
		{
			//装备类型
			this.m_nChangeType = nType;
			//构造访问者
			this.m_oVisitor = new HintValueVisitor(oEquip);
		}

		//-------------------------------------------------------

		//设置迭代器
		this.setIterator(new PackIterator(EquipManager.getCurrentPack()));
	},

	//---------------------------------------------------------------------------------------------------------

	//修改数组重新初始化
	setIterator : function(oIterator)
	{
		//设置迭代器
		this.m_oIterator = oIterator;
		this.m_oIterator.initPage();

		//--------------------------------------------------------------

		//设置左按钮
		this.m_btnLeft.setEnabled(false);
		if(!this.m_oIterator.hasNext())
		{
			this.m_btnRight.setEnabled(false);
		}

		//--------------------------------------------------------------

		//更新当前页
		this.setPage(this.m_oIterator.getPage());
	},
	//更当前页仓库
	setPage : function(aEquip)
	{
		for(var i = 0; i < 4; i ++)
		{
			var oEquip = null;
			if(i < aEquip.length){
				oEquip = aEquip[i];
			}
			//更新仓库
			var noInventory = this.m_noPage.getChildByTag(i+1).getChildByTag(2);
			noInventory.controller.setInventory(oEquip);
		}
	},

	//---------------------------------------------------------------------------------------------------------

	//设置类型迭代
	setShowKindType : function(nKind, btnCurrent)
	{
		//触控控制
		if(!this.m_bTouch){
			return;
		}
		//--------------------------------------------------------------

		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);

		//--------------------------------------------------------------

		//初始化集合
		if(!this.m_oIteratorSet){
			this.m_oIteratorSet = new PackIteratorSet(this.m_oIterator);
		}
		//设置类型
		this.m_nKind = nKind;
		//修改当前按钮
		if(this.m_btnCurrent){
			this.m_btnCurrent.setEnabled(true);
		}
		btnCurrent.setEnabled(false);
		this.m_btnCurrent = btnCurrent;

		//--------------------------------------------------------------

		//修改当前迭代器
		this.setIterator(this.m_oIteratorSet.getIteratorByKind(nKind));
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//按钮回调

	//交换道具回调
	exchangeEquip : function(oInventory)
	{
		//触控控制
		if(!this.m_bTouch){
			return;
		}
		//--------------------------------------------------------------

		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);

		//--------------------------------------------------------------

		//代理更新属性
		if(this.m_oDelegate){
			this.m_oDelegate.exchangeEquip(oInventory.m_oEquip);
		}

		//--------------------------------------------------------------

		//关闭窗口
		this.closeLayer(null);
	},
	//道具相关
	openEquipHint : function(oInventory, nType)
	{
		//触控控制
		if(!this.m_bTouch){
			return;
		}
		//--------------------------------------------------------------

		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);

		//--------------------------------------------------------------

		//确定目标框
		this.m_oTargetInventory = oInventory;

		//--------------------------------------------------------------

		//目标道具
		var oEquip = oInventory.m_oEquip;
		//分类操作
		switch (nType)
		{
			case EquipBarFunction.Upgrade:
			{
				//得到价格
				var nPrice = GameFormula.upgradePrice(oEquip);
				//判断是否够钱
				var bConfirm = GameManager.moneyEnough(nPrice, ShopPayType.Coin);
				//设置弹出页
				var strContent = GameMessage.upgradeEquipMessage(oEquip);
				var lyPopupLayer = noPopupNode.createBtnHintWithIcon(strContent, nPrice, true, bConfirm,
																	 this.upgradeCallback.bind(this), null,
																	 oEquip.m_oData.Icon, oEquip, res.img_coin_png, bConfirm);
				vee.PopMgr.popLayer(lyPopupLayer, { alpha : 100 }, null, null, null);
			}
				break;
			case EquipBarFunction.Sell:
			{
				//得到价格
				var nPrice = GameFormula.sellPrice(oEquip);
				//设置弹出页
				var strContent = GameMessage.sellEquipMessage(oEquip);
				var lyPopupLayer = noPopupNode.createBtnHintWithIcon(strContent, nPrice, true, true,
																	 this.sellCallBack.bind(this), null,
																	 oEquip.m_oData.Icon, oEquip, res.img_coin_png, true);
				vee.PopMgr.popLayer(lyPopupLayer, { alpha : 100 }, null, null, null);
			}
				break;
			case EquipBarFunction.Discard:
			{
				//设置弹出页
				var strContent = GameMessage.discardEquipMessage(oEquip);
				var lyPopupLayer = noPopupNode.createBtnHintWithIcon(strContent, 0, false, true,
																	 this.discardCallBack.bind(this), null,
																	 oEquip.m_oData.Icon, oEquip, res.img_coin_png, false);
				vee.PopMgr.popLayer(lyPopupLayer, { alpha : 100 }, null, null, null);
			}
				break;
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//回调

	//升级回调
	upgradeCallback : function(oEquip)
	{
		//升级道具
		GameManager.upgradeEquip(oEquip, false);
		//刷新金钱
		this.m_lyMainLayer.upDataCurrentMoney();
		//装备页更新
		this.m_oTargetInventory.updateInventory();
	},
	//买道具回调
	sellCallBack : function(oEquip)
	{
		//移除道具
		GameManager.sellEquip(oEquip);
		//刷新金钱
		this.m_lyMainLayer.upDataCurrentMoney();
		//装备页更新
		if(this.m_nKind != -1){
			this.m_oIterator.removeEquip(oEquip);
		}
		this.setPage(this.m_oIterator.getPage());
	},
	//丢弃道具回调
	discardCallBack : function(oEquip)
	{
		//移除道具
		EquipManager.removePackEquip(oEquip);
		//装备页更新
		this.setPage(this.m_oIterator.getPage());
	},

	//---------------------------------------------------------------------------------------------------------------------------

	//按钮回调
	/** @expose */
	showLeft : function(pSender)
	{
		this.setShowKindType(EquipKind.Sword, pSender);
	},
	/** @expose */
	showRight : function(pSender)
	{
		this.setShowKindType(EquipKind.Shield, pSender);
	},
	/** @expose */
	showBody : function(pSender)
	{
		this.setShowKindType(EquipKind.Clothes, pSender);
	},
	/** @expose */
	showAcc : function(pSender)
	{
		this.setShowKindType(EquipKind.Necklace, pSender);
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//按钮回调2

	//翻页
	/** @expose */
	pageLeft : function(pSender)
	{
		//触控控制
		if(!this.m_bTouch){
			return;
		}
		//--------------------------------------------------------------

		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);
		//-----------------------------------------------
		//更新页面
		this.setPage(this.m_oIterator.previous());
		//-----------------------------------------------
		//判断左右
		this.m_btnRight.setEnabled(true);
		if(!this.m_oIterator.hasPrevious()){
			this.m_btnLeft.setEnabled(false);
		}
	},
	/** @expose */
	pageRight : function(pSender)
	{
		//触控控制
		if(!this.m_bTouch){
			return;
		}
		//--------------------------------------------------------------

		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);
		//-----------------------------------------------
		//更新页面
		this.setPage(this.m_oIterator.next());
		//-----------------------------------------------
		//判断左右
		this.m_btnLeft.setEnabled(true);
		if(!this.m_oIterator.hasNext()){
			this.m_btnRight.setEnabled(false);
		}
	},
	//关闭
	/** @expose */
	closeLayer : function(pSender)
	{
		//触控控制
		if(!this.m_bTouch){
			return;
		}
		//--------------------------------------------------------------

		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);

		//------------------------------------------------------------

		//关闭标记
		this.m_bTouch = false;
		//关闭效果
		this.playAnimate("close", this.closeCallBack.bind(this), false);
	},
	//打开关闭回调
	openCallBack : function()
	{
		this.m_bTouch = true;
	},
	closeCallBack : function()
	{
		vee.PopMgr.closeLayerByCtl(this);
	}
});
cc.BuilderReader.registerController("lyInventoryLayer", lyInventoryLayer);


//提示访问者
function HintValueVisitor(oEquip)
{
	this.m_oRole1 = new HintRole();
	this.m_oRole2 = new HintRole();

	//---------------------------------------------------------------------------------------

	this.m_oEquip = oEquip;
	if(oEquip){
		EquipManager.setPlayerEquipAttr(this.m_oRole1, oEquip, false);
	}
};
HintValueVisitor.prototype.setHintStr = function(noChange, oEquip)
{
	//清空显示
	noChange.removeAllChildren();

	//---------------------------------------------------------------------------------------

	//判断同种道具
	if(this.m_oEquip
		&& this.m_oEquip.m_oCoe.m_nId == oEquip.m_oCoe.m_nId
		&& this.m_oEquip.m_oCoe.m_nLv == oEquip.m_oCoe.m_nLv)
	{
		return;
	}

	//---------------------------------------------------------------------------------------

	//重置数据
	this.m_oRole2.reset();
	EquipManager.setPlayerEquipAttr(this.m_oRole2, oEquip, false);

	//---------------------------------------------------------------------------------------

	//标题
	var lbHint = cc.LabelTTF.create("Equipped-> ", res.AveriaSerifRegular_ttf, 20);
	lbHint.setAnchorPoint(cc.p(0, 0.5));
	noChange.addChild(lbHint);

	//---------------------------------------------------------------------------------------

	var nIndex = 1;
	var nWith = 110;
	for(var i = 0; i < 5; i++)
	{
		var nValue1 = this.m_oRole1.m_aEquip1[i];
		var nValue2 = this.m_oRole2.m_aEquip1[i];
		var nTotal = nValue2 - nValue1;
		if(nTotal != 0)
		{
			var lbChange = cc.LabelTTF.create("", res.AveriaSerifRegular_ttf, 20);
			lbChange.setAnchorPoint(cc.p(0, 0.5));
			if(nTotal > 0)
			{
				lbChange.setString(StaticMethod.getAttTypStr(i) + "+" + nTotal);
				lbChange.setColor(cc.GREEN);
			}
			else
			{
				lbChange.setString(StaticMethod.getAttTypStr(i) + nTotal);
				lbChange.setColor(cc.RED);
			}
			lbChange.setPosition(cc.p(nWith, 0));
			nWith += lbChange.getContentSize().width + 5;
			noChange.addChild(lbChange);
		}
		//---------------------------------------------------------------------------------------
		nValue1 = this.m_oRole1.m_aEquip2[i];
		nValue2 = this.m_oRole2.m_aEquip2[i];
		nTotal = nValue2 - nValue1;
		if(nTotal != 0)
		{
			var lbChange = cc.LabelTTF.create("", res.AveriaSerifRegular_ttf, 20);
			lbChange.setAnchorPoint(cc.p(0, 0.5));
			if(nTotal > 0)
			{
				lbChange.setString(StaticMethod.getAttTypStr(i) + "x" + Math.floor((1 + nTotal) * 100) + "%");
				lbChange.setColor(cc.GREEN);
			}
			else
			{
				lbChange.setString(StaticMethod.getAttTypStr(i) + "x" + Math.floor((1 + nTotal) * 100)  + "%");
				lbChange.setColor(cc.RED);
			}
			lbChange.setPosition(cc.p(nWith, 0));
			nWith += lbChange.getContentSize().width + 5;
			noChange.addChild(lbChange);
		}
	}
};