/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 15/1/22
 * Time: 上午11:53
 * To change this template use File | Settings | File Templates.
 */

var lyMainBgLayer = vee.Class.extend({

	/** @expose */
	m_spBg : null,
	/** @expose */
	m_noBg : null,
	/** @expose */
	m_noUnLock : null,

	//进入标记
	m_bShow : false,
	//中介对象
	m_lyMainLayer : null,

	//------------------------------------------------------------------------------------------------------------
	//设置回调
	setMainLayer : function(lyMainLayer)
	{
		this.m_lyMainLayer = lyMainLayer;
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//初始化
	onLoaded : function()
	{
		//进入标记
		this.m_bShow = true;
		//数据
		var oVipData = GameManager.getVIPData();
		//显示楼层
		for(var i = 10; i > oVipData.m_nOpenFloor; i--){
			this.m_noBg.getChildByTag(i).setVisible(false);
		}
		//显示解锁按钮
		if(oVipData.m_nUnLockFloor > 0)
		{
			this.m_noUnLock.setPosition(cc.p(490, 270 + (oVipData.m_nUnLockFloor-2) * 85));
			this.m_noUnLock.setVisible(true);
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//效果
	//修改塔位置
	getTowerPosition : function(nFloor)
	{
		var pointBegin = this.rootNode.convertToNodeSpace(cc.p(0, 540));
		var nHeight = pointBegin.y + 410*2 - (nFloor-1) * 170;
		return cc.p(384, nHeight);
	},
	//显示选关
	showTowerSelect : function(nFloor)
	{
		//进入标记
		if(!this.m_bShow){
			return;
		}
		this.m_bShow = false;

		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);

		//第一层判定
		var bDirect = this.m_lyMainLayer.showSelect(nFloor);
		if(!bDirect){
			return;
		}

		//效果
		var action = cc.ScaleTo.create(0.2, 2);
		var action2 = cc.MoveTo.create(0.2, this.getTowerPosition(nFloor));
		var action3 = cc.Spawn.create(action, action2);
		this.m_spBg.runAction(action3);
	},
	//退出塔
	hideTowerSelect : function()
	{
		//效果
		var action = cc.ScaleTo.create(0.2, 1);
		var action2 = cc.MoveTo.create(0.2, cc.p(384, 568));
		var action3 = cc.Spawn.create(action, action2);
		this.m_spBg.runAction(action3);

		//进入标记
		this.m_bShow = true;
	},
	//切换楼层
	upDownTower : function(nFloor)
	{
		var action = cc.MoveTo.create(0.2, this.getTowerPosition(nFloor));
		this.m_spBg.runAction(action);
	},
	//解锁塔效果
	showUnLockFloor : function(nIndex)
	{
		//显示楼层
		this.m_noBg.getChildByTag(nIndex).setVisible(true);

		//解锁第八层
		if(nIndex == 10)
		{
			this.m_noBg.getChildByTag(8).setVisible(true);
			this.m_noBg.getChildByTag(9).setVisible(true);
		}

		//隐藏按钮
		this.m_noUnLock.setVisible(false);
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//按钮回调
	/** @expose */
	onUnLuckFloor : function()
	{
		if(this.m_lyMainLayer){
			this.m_lyMainLayer.openUnLockFloorHint();
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//按钮回调2
	/** @expose */
	enterTower1 : function(pSender)
	{
		var nFloor = pSender.getParent().getTag();
		this.showTowerSelect(nFloor);
	},
	/** @expose */
	enterTower2 : function(pSender)
	{
		var nFloor = pSender.getParent().getTag();
		//提示
		if(GameManager.getVIPData().m_nOpenFloor == 2 && nFloor > 1)
		{
			var lyPopupLayer = noPopupNode.createBtnHint(GameMessage.Mes_SelectFloor, "",
				false, true, this.floorTwoHint.bind(this), null, null, false);
			vee.PopMgr.popLayer(lyPopupLayer, { alpha : 100 }, null, null, null);
		}
		else
		{
			this.showTowerSelect(nFloor);
		}
	},
	//
	floorTwoHint : function()
	{
		this.showTowerSelect(2);
	},
	/** @expose */
	enterTower3 : function(pSender)
	{
		var nFloor = pSender.getParent().getTag();
		this.showTowerSelect(nFloor);
	},
	/** @expose */
	enterTower4 : function(pSender)
	{
		var nFloor = pSender.getParent().getTag();
		this.showTowerSelect(nFloor);
	},
	/** @expose */
	enterTower5 : function(pSender)
	{
		var nFloor = pSender.getParent().getTag();
		this.showTowerSelect(nFloor);
	},
	/** @expose */
	enterTower6 : function(pSender)
	{
		var nFloor = pSender.getParent().getTag();
		this.showTowerSelect(nFloor);
	},
	enterTower7 : function(pSender)
	{
		var nFloor = pSender.getParent().getTag();
		this.showTowerSelect(nFloor);
	},
	enterTower8 : function(pSender)
	{
		var nFloor = pSender.getParent().getTag();
		this.showTowerSelect(nFloor);
	},
	enterTower9 : function(pSender)
	{
		this.showTowerSelect(8);
	},
	enterTower10 : function(pSender)
	{
		this.showTowerSelect(8);
	}
});
cc.BuilderReader.registerController("lyMainBgLayer", lyMainBgLayer);