/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 15/1/14
 * Time: 上午10:59
 * To change this template use File | Settings | File Templates.
 */

var eleSelectNode = vee.Class.extend({

	//floor
	/** @expose */
	m_btnUp : null,
	/** @expose */
	m_btnDown : null,
	/** @expose */
	m_lbFloor : null,
	//HP Potions
	/** @expose */
	m_btnLess : null,
	/** @expose */
	m_btnPlus : null,
	/** @expose */
	m_lbHp : null,
	//Coin
	/** @expose */
	m_lbCoin : null,
	//背景
	/** @expose */
	m_spBg : null,
	//
	/** @expose */
	m_noContain : null,
	/** @expose */
	m_btnConfirm : null,

	//-----------------------------
	//数据
	m_nFloor : 0,
	m_nPotion : 0,
	m_nMaxFloor : 1,
	
	//-----------------------------
	//代理
	m_oDelegate : null,
	//关闭标记
	m_bTouch : false,

	//---------------------------------------------------------------------------------------------------------------------------
	//设置
	setDelegate : function(oDelegate)
	{
		this.m_oDelegate = oDelegate;
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//初始化

	//初始化
	initSelectNode : function(nCurrentFloor, nMaxFloor)
	{
		//更新数据
		this.m_nFloor = nCurrentFloor;
		this.m_nMaxFloor = nMaxFloor;
		this.m_nPotion = 0;

		//修改数据显示
		this.m_lbFloor.setString(GameManager.getCurrentFloor() + "F");
		this.m_lbHp.setString(this.m_nPotion);
		this.m_lbCoin.setString(0);

		//抗锯齿
		this.m_spBg.getTexture().setAliasTexParameters();

		//设置选关按钮
		if(this.m_nFloor == 1){
			this.m_btnDown.setEnabled(false);
		}
		if(this.m_nFloor == nMaxFloor){
			this.m_btnUp.setEnabled(false);
		}

		//设置选血瓶按钮
		this.m_btnLess.setEnabled(false);

		//设置弹出位置
		vee.PopMgr.resetLayer(this.rootNode, vee.PopMgr.PositionType.Bottom, cc.p(0, 0), false);
	},
	
	//---------------------------------------------------------------------------------------------------------------------------
	//效果
	
	//打开效果
	openSelectNode : function() 
	{
		this.playAnimate("ShowSelect", this.openCallBack.bind(this), false);
	},
	//打开回调
	openCallBack : function()
	{
		this.m_bTouch = true;
	},
	//关闭效果
	closeSelectNode : function() 
	{
		//关闭效果
		this.playAnimate("HideSelect", this.closeCallBack.bind(this), false);
	},
	//关闭回调
	closeCallBack : function() 
	{
		vee.PopMgr.closeLayerByCtl(this);
		//进入塔回调
		this.m_oDelegate.hideSelectCallBack();
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//更新显示

	//更新金币
	upDateCoin : function(nPotion)
	{
		var nPrice = GameFormula.potionPrice(nPotion);
		var bConfirm = GameManager.moneyEnough(nPrice, ShopPayType.Coin);
		this.m_btnConfirm.setEnabled(bConfirm);
		this.m_lbCoin.setString(nPrice);
		this.m_lbCoin.setColor(bConfirm ? cc.WHITE : cc.RED);
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//回调

	//选层
	/** @expose */
	upFloor : function(pSender)
	{
		//声音
		vee.Audio.playEffect(res.sfx_menu_pointClick_mp3, false);

		//设置左按钮
		if(this.m_nFloor == 1){
			this.m_btnDown.setEnabled(true);
		}
		//修改数量
		this.m_nFloor++;
		//设置右按钮
		if(!this.m_oDelegate.setFloor(this.m_nFloor)){
			this.m_btnUp.setEnabled(false);
		}
		//修改数量显示
		this.m_lbFloor.setString(GameManager.getCurrentFloor() + "F");
	},
	/** @expose */
	downFloor : function(pSender)
	{
		//声音
		vee.Audio.playEffect(res.sfx_menu_pointClick_mp3, false);

		//设置左按钮
		if(this.m_nFloor == this.m_nMaxFloor){
			this.m_btnUp.setEnabled(true);
		}
		//修改数量
		this.m_nFloor--;
		this.m_oDelegate.setFloor(this.m_nFloor);
		//设置右按钮
		if(this.m_nFloor == 1){
			this.m_btnDown.setEnabled(false);
		}
		//修改数量显示
		this.m_lbFloor.setString(GameManager.getCurrentFloor() + "F");
	},

	//选血瓶
	/** @expose */
	plusHpPotion : function(pSender)
	{
		//声音
		vee.Audio.playEffect(res.sfx_menu_pointClick_mp3, false);

		//设置左按钮
		if(this.m_nPotion == 0){
			this.m_btnLess.setEnabled(true);
		}
		//修改数量
		this.m_nPotion++;
		this.m_lbHp.setString(this.m_nPotion);
		//刷新价格
		this.upDateCoin(this.m_nPotion);
		//设置右按钮
		if(!GameManager.isMaxPotion(this.m_nPotion)){
			this.m_btnPlus.setEnabled(false);
		}
	},
	/** @expose */
	lessHpPotion : function(pSender)
	{
		//声音
		vee.Audio.playEffect(res.sfx_menu_pointClick_mp3, false);
		//设置左按钮
		if(!GameManager.isMaxPotion(this.m_nPotion)){
			this.m_btnPlus.setEnabled(true);
		}
		//修改数量
		this.m_nPotion--;
		this.m_lbHp.setString(this.m_nPotion);
		//刷新价格
		this.upDateCoin(this.m_nPotion);
		//设置右按钮
		if(this.m_nPotion == 0){
			this.m_btnLess.setEnabled(false);
		}
	},

	//确认按钮
	/** @expose */
	onConfirm : function(pSender)
	{
		//关闭标记
		if(!this.m_bTouch){
			return;
		}
		this.m_bTouch = false;

		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);

		//进入游戏回调
		this.m_oDelegate.hideSelect(true, this.m_nPotion);
	},
	/** @expose */
	onCancel : function(pSender)
	{
		//关闭标记
		if(!this.m_bTouch){
			return;
		}
		this.m_bTouch = false;

		//声音
		vee.Audio.playEffect(res.sfx_menu_closewindow_mp3, false);

		//退出选关回调
		this.m_oDelegate.hideSelect(false, this.m_nPotion);
	}
});
cc.BuilderReader.registerController("elseSelectNode", eleSelectNode);