/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 15/1/14
 * Time: 上午11:38
 * To change this template use File | Settings | File Templates.
 */

vee.GameModule.MainLayer.extend({

	/** @expose */
	m_lyMainLayer : null,

	//初始化
	onLoaded : function()
	{
		this.m_lyMainLayer.controller.onLoaded();
	},
	//关闭界面
	onClosed : function()
	{
		this.m_lyMainLayer.controller.onClosed();
	},
	//
	onKeyMenu : function() {
		return true;
	}
});

var lyMainLayer = vee.Class.extend({

	/** @expose */
	m_noSelect : null,

	/** @expose */
	m_lyMainBgLayer : null,
	/** @expose */
	m_lyMainUiLayer : null,

	//装备页
	m_lyEquipmentLayer : null,
	//仓库页
	m_lyInventoryLayer : null,

	//是否进入游戏
	m_bEnterGame : false,

	//---------------------------------------------------------------------------------------------------------------------------
	//初始化
	//初始化
	onLoaded : function()
	{
		//ui
		this.m_lyMainUiLayer.controller.setMainLayer(this);
		//bg
		this.m_lyMainBgLayer.controller.setMainLayer(this);
		this.m_lyMainBgLayer.controller.onLoaded();
	},
	//关闭界面
	onClosed : function()
	{
		this.m_lyMainUiLayer.controller.onClosed();
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//效果1
	//进入效果
	onEnter : function()
	{
		//进入效果
		if(GameManager.m_bInTower){
			this.enterGame(GameManager.m_bInTower);
		}else{
			this.m_lyMainUiLayer.controller.showUi();
		}
	},
	//进入游戏
	enterGame : function(bDirect)
	{
		if(bDirect)
		{
			//ui移出
			this.m_lyMainUiLayer.controller.playAnimate("GameEnd", null, false);
			//进入效果2
			this.m_lyMainBgLayer.controller.playAnimate("EnterTower2", this.enterTowerCallback.bind(this), false);
		}
		else
		{
			//进入效果1
			this.m_lyMainBgLayer.controller.playAnimate("EnterTower", this.enterTowerCallback.bind(this), false);
		}
	},
	//进入回调
	enterTowerCallback : function()
	{
		//初始化塔内数据
		GameManager.initTower();
		//进入游戏
		vee.GameModule.SceneMgr.openGame();
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//效果2
	//初次进入奖励
	showFirstAward : function()
	{
		//判断初次进入
		if(!vee.isFirstPlay){
			return;
		}
		//----------------------------------------

		//弹出提示
		var node = noPopupNode.createTouchHintWithIcon(GameMessage.Mes_FirstAward, "",
				this.showFirstAwardCallBack.bind(this), "item_1081.png", false);
		vee.PopMgr.popLayer(node, { alpha : 100 }, null, null, null);
	},
	//回调
	showFirstAwardCallBack : function()
	{
		//保存数据
		vee.VIPValues.add2Value(VipKey.Jewel, 15);
		vee.VIPValues.save();
		//刷新钻石
		MyNotificationCenter.postNotification(GameEvent.UPDATAEGAJEWEL, 0);
	},
	
	//---------------------------------------------------------------------------------------------------------------------------
	//显示
	//更新金钱显示
	upDataCurrentMoney : function()
	{
		var oVipData = GameManager.getVIPData();
		this.m_lyMainUiLayer.controller.setDisplayMoney(oVipData.m_nMoney);
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//回调1
	//修改楼层
	setFloor : function(nFloor)
	{
		//修改层数
		GameManager.getTowerData().m_nBigFloor = nFloor;
		//上升下落效果
		this.m_lyMainBgLayer.controller.upDownTower(nFloor);
		//判断边界
		return GameManager.isMaxFloor(true);
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//回调2
	//打开SelectNode
	showSelect : function(nFloor)
	{
		//数据
		var oVipData = GameManager.getVIPData();
		
		//----------------------------------------
		
		//直接进入游戏
		if(oVipData.m_nOpenFloor == 1)
		{	
			this.enterGame(true);
			return false;
		}
		
		//----------------------------------------

		//修改楼层
		var oTowerData = GameManager.getTowerData();
		oTowerData.m_nBigFloor = nFloor;
		//初始化选择界面
		this.m_noSelect = vee.PopMgr.popCCB(res.eleSelectNode_ccbi, { alpha : 0 }, null, null, null);
		this.m_noSelect.controller.initSelectNode(oTowerData.m_nBigFloor, oVipData.m_nOpenFloor > 8 ? 8 : oVipData.m_nOpenFloor);
		this.m_noSelect.controller.setDelegate(this);
		//打开效果
		this.m_noSelect.controller.openSelectNode();
		this.m_lyMainUiLayer.controller.playAnimate("GameEnd", null, false);

		return true;
	},
	//关闭SelectNode
	hideSelect : function(bEnterGame, nPotion)
	{
		//标记进入游戏
		this.m_bEnterGame = bEnterGame;

		//判断进入塔中
		if(!bEnterGame)
		{
			//关闭效果
			this.m_lyMainBgLayer.controller.hideTowerSelect();
			this.m_lyMainUiLayer.controller.playAnimate("GameReset", null, false);
		}
		else
		{
			//购买血瓶
			if(GameManager.buyPotion(nPotion)){
				MyNotificationCenter.postNotification(GameEvent.UPDATAEGAMEMONEY, 0);
			}
		}

		//关闭效果
		this.m_noSelect.controller.closeSelectNode();
	},
	//隐藏选关回调
	hideSelectCallBack : function()
	{
		//进入游戏
		if(this.m_bEnterGame)
		{
			//进入塔标记
			this.m_bEnterGame = false;
			//进塔效果
			this.enterGame(false);
		}
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//ui
	//打开装备
	openPlayer  : function()
	{
		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);
		
		this.m_lyEquipmentLayer = vee.PopMgr.popCCB(res.lyEquipment_ccbi, { alpha : 0 });
		this.m_lyEquipmentLayer.controller.initEquipmentWithType(EquipBarFunction.Upgrade | EquipBarFunction.Exchange);
		this.m_lyEquipmentLayer.controller.setMainLayer(this);
	},
	//打开仓库
	openBank  : function()
	{
		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);
		
		this.m_lyInventoryLayer = vee.PopMgr.popCCB(res.lyInventoryMain_ccbi, { alpha : 0 });
		this.m_lyInventoryLayer.controller.initInventoryWithType(EquipBarFunction.Upgrade | EquipBarFunction.Sell);
		this.m_lyInventoryLayer.controller.setMainLayer(this);
	},
	//打开仓库
	openShop  : function()
	{
		//声音
		vee.Audio.playEffect(res.sfx_menu_buttonclick_mp3, false);
		
		this.m_lyInventoryLayer = vee.PopMgr.popCCB(res.lyShopLayer_ccbi, { alpha : 0 });
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//打开解锁楼层
	openUnLockFloorHint : function()
	{
		//确定价格
		var nPrice = GameFormula.floorPrice(GameManager.getVIPData().m_nUnLockFloor);
		var bConfirm = GameManager.moneyEnough(nPrice, ShopPayType.Coin);
		//设置弹出页
		var strContent = GameMessage.unLockFloorMessage();
		var lyPopupLayer = noPopupNode.createBtnHint(strContent, nPrice, true, bConfirm,
			this.unLockFloorCallback.bind(this), null, res.img_coin_png, bConfirm);
		vee.PopMgr.popLayer(lyPopupLayer, { alpha : 100 }, null, null, null);
	},
	//解锁回调
	unLockFloorCallback : function()
	{
		//解锁
		GameManager.unLockFloor();
		//解锁效果
		this.m_lyMainBgLayer.controller.showUnLockFloor(GameManager.getVIPData().m_nOpenFloor);
		//刷新金钱
		MyNotificationCenter.postNotification(GameEvent.UPDATAEGAMEMONEY, 0);
	}
});
cc.BuilderReader.registerController("lyMainLayer", lyMainLayer);