/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 15/3/7
 * Time: 下午12:18
 * To change this template use File | Settings | File Templates.
 */

var noShopItem = VeeTableCellController.extend({

	/** @expose */
	m_spIcon : null,
	/** @expose */
	m_lbName : null,
	/** @expose */
	m_lbDescribe : null,
	/** @expose */
	m_noPrice : null,
	/** @expose */
	m_btnBuy : null,
	/** @expose */
	m_lbPrice : null,

	//-------------------------------
	//id
	m_nid    : -1,
	//位置
	m_nPosY  :  0,
	//价格
	m_nPrice :  0,
	//功能
	m_oData  :  null,

	//------------------------------------------------------------------------------------------------------------
	//更新

	updateIndex : function(idx, oShopData)
	{
		//设置id
		this.m_nid = idx;
		//功能
		this.m_oData = ShopData[idx];

		//设置内容
		this.m_spIcon.setTexture(ShopData[idx].Icon);
		this.m_lbName.setString(ShopData[idx].Name);
		this.m_lbDescribe.setString(ShopData[idx].Describe);
		//变动价格
		if(ShopData[idx].FunctionType == ShopFunctionType.Dilatation){
			this.setPrice();
		}
		else
		{
			if(this.m_oData.PayType == ShopPayType.Cash){
				this.m_lbPrice.setString("$"+ShopData[idx].Price);
			}else{
				this.m_lbPrice.setString(ShopData[idx].Price);
			}
			this.m_nPrice = ShopData[idx].Price;
		}
		//设置按钮
		this.setBtn();
	},
	//修改价格
	setPrice : function()
	{
		var nIndex = vee.VIPValues.getValue(VipKey.Capacity);
		if(nIndex < 8)
		{
			var nPrice = DilatationData[nIndex+1][0];
			this.m_lbPrice.setString(nPrice);
			this.m_lbName.setString(this.m_oData.Name + " " + DilatationData[nIndex+1][1]);
			this.m_nPrice = nPrice;
		}
		else
		{
			this.m_noPrice.setVisible(false);
			this.m_lbDescribe.setString("Max");
			this.m_nPrice = 0;
		}
	},
	//修改按钮
	setBtn : function()
	{
		//设置按钮
		switch (this.m_oData.FunctionType)
		{
			case ShopFunctionType.Dilatation:
			{
				if(vee.VIPValues.getValue(VipKey.Capacity) >= 8){
					this.m_btnBuy.setEnabled(false);
				}
			}
				break;
			case ShopFunctionType.EquipSp:
			{
				if(GameManager.checkSpecialEquip(this.m_oData.EquipSpType)){
					this.m_btnBuy.setEnabled(false);
				}
			}
				break;
			case ShopFunctionType.Compass:
			{
				if(vee.VIPValues.getValue(VipKey.Compass) == 1){
					this.m_btnBuy.setEnabled(false);
				}
			}
				break;
		}
	},

	//------------------------------------------------------------------------------------------------------------

	//滑动触控
	touched2 : function(table)
	{
		//确定起始位置
		this.m_nPosY = this.rootNode.getParent().convertToWorldSpace(this.rootNode.getPosition()).y;
	},

	//------------------------------------------------------------------------------------------------------------

	//按钮回调
	/** @expose */
	onUpgradeEquip : function(pSender)
	{
		//终止位置
		var nEndY = this.rootNode.getParent().convertToWorldSpace(this.rootNode.getPosition()).y;
		if(Math.abs(nEndY - this.m_nPosY) > 20){
			return ;
		}

		//购买通知
		MyNotificationCenter.postNotification(GameEvent.BUYSHOPITEM, this);
	}
});
cc.BuilderReader.registerController("noShopItem", noShopItem);